<?php
/*********************************************
 cpgShop Plugin for Coppermine Photo Gallery
 ********************************************
 written by Thomas Lange
 based on cpgmart by foulu

 ********************************************
 * @file $Id: codebase.php 82 2012-07-11 12:57:31Z Stramm $
 * @author $Author: Stramm $
 * @version $Revision: 82 $
 * @lastrevision $Date: 2012-07-11 14:57:31 +0200 (Mi, 11. Jul 2012) $
 * @modifiedby $LastChangedBy: Stramm $
 * @lastmodified $LastChangedDate: 2012-07-11 14:57:31 +0200 (Mi, 11. Jul 2012) $
 ********************************************
 cpgShop full Version 1.0.6
 **********************************************/


// -----------------------------------------------------------------------------------------
// DEF PART - ADD ACTINS AND FILTERS
// -----------------------------------------------------------------------------------------

if (!defined('IN_COPPERMINE')) die('Not in Coppermine...');
if (!defined('CORE_PLUGIN')) define('CORE_PLUGIN', true); // 15x
if (!defined('DS')) define('DS', DIRECTORY_SEPARATOR);

// install action
$thisplugin->add_action('plugin_install' ,'cpgshop_install');
// configure action
$thisplugin->add_action('plugin_configure', 'cpgshop_configure');
// uninstall action
$thisplugin->add_action('plugin_uninstall', 'cpgshop_uninstall');
// cleanup action
$thisplugin->add_action('plugin_cleanup', 'cpgshop_cleanup');
// page start action
$thisplugin->add_action('page_start', 'cpgshop_start');
// profile edit action
$thisplugin->add_action('profile_display_form', 'cpgshop_profile_display');
$thisplugin->add_action('profile_submit_form', 'cpgshop_profile_submit');

// register form filter
$thisplugin->add_filter('register_form_create', 'cpgshop_register_form_create');
$thisplugin->add_filter('register_form_submit', 'cpgshop_register_form_submit');

// admin config  button
$thisplugin->add_filter('admin_menu','cpgshop_config_button');

// theme thing
$thisplugin->add_filter('gallery_header', 'cpgshop_gallery_header');
$thisplugin->add_filter('gallery_footer', 'cpgshop_gallery_footer');

// Add file data data filter
$thisplugin->add_filter('file_data','cpgshop_file_data');

// -----------------------------------------------------------------------------------------
// DEFAULT PART - ONLY FOR INSTALL & UNINSTALL PLUGIN
// -----------------------------------------------------------------------------------------

function cpgshop_sql($title, $sqlFile) {
	global $CONFIG;

	require  'include'.DS.'sql_parse.php';
	$sql_query = fread(fopen($sqlFile, 'r'), filesize($sqlFile));
	$sql_query = preg_replace('/CPG_/', $CONFIG['TABLE_PREFIX'], $sql_query);
 	$sql_query = remove_remarks($sql_query);
    $sql_query = split_sql_file($sql_query, ';');

	echo <<<EOT
    	<h2>$title</h2>
        <table class="maintable" border="0" cellspacing="0" cellpadding="0">
EOT;
	foreach($sql_query as $q) {
		echo "<tr><td class='debug_text' style='color: black;'>$q</td>";
		if (cpg_db_query($q)) {
        	echo "<td class='debug_text' style='color: green;'>OK</td></tr>";
        } else {
        	echo "<td class='debug_text' style='color: black;'>Already Done</td></tr>";
        }
	}
	echo '</table>';
}

function cpgshop_install() {
	$submit_code = '';
	$superCage = Inspekt::makeSuperCage();
	if ($superCage->post->keyExists('submit')) {
		$submit_code = $superCage->post->getEscaped('submit');
	}

	if (!$submit_code) {
		return 1;
	} elseif ($submit_code == 'Start') {
		return true;
	} else {
		return 2;
	}
}

function cpgshop_configure($stop=true) {
    global $errors, $CONFIG;
    cpgshop_sql('Performing database updates','plugins'.DS.'cpgshop'.DS.'sql'.DS.'install.sql');

	if ($stop) {
	$superCage = Inspekt::makeSuperCage();
    $cleanup = $superCage->server->getEscaped('REQUEST_URI');

        echo <<<EOT
        <form action="{$cleanup}" method="post">
            <input type="submit" value="Start" name="submit" />
        </form>
EOT;
    }
}

function cpgshop_cleanup($action) {
    if ($action === 1) {
        echo <<<EOT
    <form action="{$_SERVER['REQUEST_URI']}" method="post">
        <p>
            Do you want to drop the plugin's current database ?
        </p>
        <div style="margin:25;">
        <table border="0" cellspacing="0" cellpadding="0">
            <tr>
                <td><input type="radio" name="drop" value="1" /></td>
                <td>YES</td>
            </tr>
            <tr>
                <td><input type="radio" name="drop" value="0" checked="checked" /></td>
                <td>NO</td>
            </tr>
        </table>
        </div>
        <span>
           <input type="submit" name="submit" value="Submit" /> &nbsp;&nbsp;&nbsp;
            <input type="button" name="cancel" onClick="window.location='pluginmgr.php';" value="Cancel" />
        </span>
    </form>
EOT;
    }
}

function cpgshop_uninstall() {
	global $CONFIG;
	$superCage = Inspekt::makeSuperCage();

	if (!$superCage->post->keyExists('drop')) {
		return 1;
	}

	if ($superCage->post->getInt('drop') == 1) {

		cpgshop_sql('Drop the database', 'plugins'.DS.'cpgshop'.DS.'sql'.DS.'uninstall.sql');
	}
	return true;
}

// -----------------------------------------------------------------------------------------
// MAIN PART - EVERYTHING STARTS HERE
// -----------------------------------------------------------------------------------------

function cpgshop_start() {
	//first we need to include CONFIG
	global $CONFIG, $REFERER, $JS;
	//now we can run init.inc.php, define the DB table names and load the shop config
	require_once 'plugins'.DS.'cpgshop'.DS.'include'.DS.'init.inc.php';
	// this page
	global $template_header;
	global $lang_cs_codebase;
	// common
	global $lang_cs_common;
	// admin
	global $lang_cs_mainpage;
	global $lang_cs_config;
	global $lang_cs_price, $lang_cs_priceset;
	global $lang_cs_option, $lang_cs_optionset;
	global $lang_cs_order;
	global $lang_cs_shipping;
	global $lang_cs_discount;
	global $lang_cs_documents;
	// cart
	global $lang_cs_cart;
	// edit pics
	global $lang_cs_edit_pic;
	//countrylist
	global $lang_cs_countrylist;
	// register
	global $lang_cs_profile, $lang_register_php;
	//ipn
	global $lang_cpgshop_ipn;
	// error
	global $lang_cs_error;
	// other
	global $currency_symbol;
	global $item_type;

	if (!file_exists(CPGSHOP_PLUGIN_DIR."lang".DS."{$CONFIG['lang']}.php")) $CONFIG['lang'] = 'english';
	include CPGSHOP_PLUGIN_DIR."lang".DS."{$CONFIG['lang']}.php";

	// inject javascript
	$cage_SERVER = Inspekt::makeServerCage();
	$query_string = $cage_SERVER->getAlnum('QUERY_STRING');

	//inject into backend page --> cpgshop_config&page=
	if (preg_match('/cpgshopconfigpage/',$query_string) || preg_match('/cpgshopeditpic/',$query_string)){
		$JS['includes'][] = 'plugins/cpgshop/js/scripts.js';
	}
	if (preg_match('/cpgshopcartpage/',$query_string) || preg_match('/cpgshopeditpic/',$query_string)){
		$JS['includes'][] = 'plugins/cpgshop/js/scripts.js';
	}
	if (preg_match('/cpgshopcartpageeditaddress/',$query_string) || preg_match('/cpgshopeditpic/',$query_string)){
		$JS['includes'][] = 'plugins/cpgshop/js/register.js';
	}
}

function cpgshop_file_data($CURRENT_PIC_DATA) {
 	global $CONFIG;
 	//global $template_display_media;
 	global $lang_cs_codebase;
 	global $currency_symbol;

	if($CONFIG['cpgshop_enable']) {
		//add piture to basket dialog
 		$CURRENT_PIC_DATA['html'] .= cpgHTML::add_to_cart($CURRENT_PIC_DATA);
	}

	// edit one pic button (below intermediate picture)
 	if (GALLERY_ADMIN_MODE)
	$add_button = "<li><a href=\"index.php?file=cpgshop/cpgshop_edit_pic&pid={$CURRENT_PIC_DATA['pid']}\"><span>{$lang_cs_codebase['edit_pic']}</span></a></li>";
	$to = '</ul>';
	$CURRENT_PIC_DATA['menu'] = str_replace($to,$add_button . $to , $CURRENT_PIC_DATA['menu']);

	return $CURRENT_PIC_DATA;
}

function cpgshop_gallery_header($template_header) {

	global $CONFIG, $CPG_PHP_SELF, $LINEBREAK;
	global $template_album_admin_menu;
	global $lang_cs_codebase;
	global $cpgshop;

	//if registering inject with alternate register.js // $JS['includes'][] will not work
	if ($CPG_PHP_SELF == 'register.php') {
		$template_header = cpgTool::add_js('<script type="text/javascript" src="plugins/cpgshop/js/register.js"></script>'.$LINEBREAK);
	}

	$css_file = 'plugins/cpgshop/css/style.css';
	if (file_exists($css_file)) {
		$template_header = cpgTool::add_js('<link rel="stylesheet" href="' . $css_file . '" type="text/css" />'.$LINEBREAK);
	}

	//global cart
	//create cpgshop object
	if (!is_object($cpgshop)) $cpgshop = new cpgShop();

	if ($CONFIG['enable_menu_icons'] > 0) {
		$cart_config_icon = '<img src="plugins/cpgshop/images/shop.png" border="0" alt="" width="16" height="16" class="icon" />';
	} else {
		$cart_config_icon = '';
	}

	//add button to album admin menu
	$item_in_cart = count($cpgshop->cart);
	if (GALLERY_ADMIN_MODE) {

		$add_button = '<li><a href="index.php?file=cpgshop/cpgshop_edit_pic&aid={ALBUM_ID}"><span>' . $cart_config_icon . $lang_cs_codebase['edit_album'] . '</span></a></li>';
		$to = '</ul>';
		$template_album_admin_menu = str_replace($to,$add_button . $to , $template_album_admin_menu);
	}

	//Add view cart & checkout buttons
	if ($item_in_cart > -1 && $CONFIG['cpgshop_enable']) {
		$tpl_cm_gb = "
		<table align=\"center\"><tr><td>
		<div class=\"buttonlist\" align=\"center\">
		<ul>
				<li>
					<a href=\"index.php?file=cpgshop/cpgshop_cart&page=view_cart\"><span>{$lang_cs_codebase['view_cart']} ($item_in_cart)</span></a>
				</li>";
		if($CONFIG['cpgshop_show_myorders']){
			$tpl_cm_gb .= "
					<li>
						<a href=\"index.php?file=cpgshop/cpgshop_cart&page=history\"><span>{$lang_cs_codebase['history']}</span></a>
					</li>";
		}
		if($CONFIG['cpgshop_enable_cart_save']){
			$tpl_cm_gb .= "
					<li>
						<a href=\"index.php?file=cpgshop/cpgshop_cart&page=save_cart\"><span>{$lang_cs_codebase['save_cart']}</span></a>
					</li>";
		}
		$tpl_cm_gb .= "
		</ul>
		</div>
		</td></tr></table>";

		if (strpos($template_header,'{CART_MENU}')) {
    		$template_header = str_replace('{CART_MENU}',$tpl_cm_gb,$template_header);
		} else {
			$template_header .= $tpl_cm_gb;
		}


		//$template_header = str_replace('{ADMIN_MENU}', $tpl_cm_gb.'{ADMIN_MENU}', $template_header);
	}
	return $template_header;
}

function cpgshop_gallery_footer($template_footer) {
   	return $template_footer;
}

// -----------------------------------------------------------------------------------------
// SUB PART - FUNCTIONS THAT MAKE ADMIN BUTTON, REDIRECT, PROFILE ...
// -----------------------------------------------------------------------------------------

function cpgshop_config_button($admin_menu){
	global $CONFIG, $lang_cs_codebase;

	if ($CONFIG['enable_menu_icons'] > 0) {
		$cart_config_icon = '<img src="plugins/cpgshop/images/shop.png" border="0" alt="" width="16" height="16" class="icon" />';
	} else {
		$cart_config_icon = '';
	}

	$add_button = '<!-- BEGIN cpgshop_control --><div class="admin_menu admin_float"><a href="index.php?file=cpgshop/cpgshop_config" title="'.$lang_cs_codebase['cpgshop_mgr'].'"><span>' . $cart_config_icon . $lang_cs_codebase['cpgshop_mgr'] . '</span></a></div><!-- END cpgshop_control -->';
	$to = '<!-- END plugin_manager -->';
	$admin_menu = str_replace($to, $to. $add_button , $admin_menu);

	return $admin_menu;
}

function cpgshop_redirect($link, $type='php') {
	// PHP redirect
	switch ($type) {
		case 'php':
			//PHP redir
       		header("Location: $link");
			break;
		case 'js':
			//Javascript
			echo "<script language=\"javascript\" type=\"text/javascript\">window.location='$link';</script>";
			break;
		default:
			// HTML redirect
			echo "<html><head><meta http-equive=\"refresh\" content=\"0; URL=$link\"></head></html>";
			break;
	}
}

function cpgshop_profile_display()
{
	global $CONFIG, $lang_cs_profile;

	$user_data = cpgDB::fetchRow("SELECT title, surename, lastname, street, city, zip, state, phone, country FROM {$CONFIG['TABLE_USERS']}  WHERE user_id ='" . USER_ID . "' ");

	$def_array = cpgTool::profile_definition_array();


	foreach ($def_array as $key){
		if($key=='country' || $key=='title') continue;
		$form_data["$key"] = $user_data["$key"];
		$edit_profile_form_param[] = array('input', $key, $lang_cs_profile['prefix'] . $lang_cs_profile["$key"],255);

	}
	$form_data1['title'] = $user_data['title'];
	$edit_profile_form_param1[] = array('select', 'title', $lang_cs_profile['prefix'] . $lang_cs_profile['title'], cpgTool::profile_titles());
	$form_data2['country'] = $user_data['country'];
	$edit_profile_form_param2[] = array('select', 'country', $lang_cs_profile['prefix'] . $lang_cs_profile['country'], cpgTool::countries());


	cpgshop_make_form($edit_profile_form_param1, $form_data1);
    make_form($edit_profile_form_param, $form_data);
	cpgshop_make_form($edit_profile_form_param2, $form_data2);
	return;
}

function cpgshop_profile_submit()
{
	global $CONFIG, $user_data;

	$superCage = Inspekt::makeSuperCage();
	if ($superCage->post->keyExists('change_profile') && USER_ID && UDB_INTEGRATION == 'coppermine') { //!defined('UDB_INTEGRATION')) {
	//Check if the form token is valid
		if(!checkFormToken()){
			cpg_die(ERROR, $lang_errors['invalid_form_token'], __FILE__, __LINE__);
		}

		$def_array = cpgTool::profile_definition_array();
		foreach ($def_array as $key){
			$$key = $superCage->post->getEscaped("$key");
		}

		$result = cpgDB::runQuery("UPDATE {$CONFIG['TABLE_USERS']} SET title = '$title', surename = '$surename', lastname = '$lastname', street = '$street', city = '$city', zip = '$zip', state = '$state', phone = '$phone', country = '$country' WHERE user_id = '" . USER_ID . "';");
	}
	return;
}

function cpgshop_register_form_create($form_data)
{
	global $CONFIG, $lang_cs_profile, $lang_register_php;

	$def_array = cpgTool::profile_definition_array();
	foreach ($def_array as $key){
		if($key=='country' || $key=='title') continue;
		$form_data[] = array('input', $key, $icon_array['blank'] . $lang_cs_profile["$key"], 255);
	}

	$edit_profile_form_param0[] = array('label', $lang_register_php['required_info']);
	$form_data1['title'] = $user_data['title'];
	$edit_profile_form_param1[] = array('select', 'title', $lang_cs_profile['prefix'] . $lang_cs_profile['title'], cpgTool::profile_titles());
	$form_data2['country'] = $user_data['country'];
	$edit_profile_form_param2[] = array('select', 'country', $lang_cs_profile['prefix'] . $lang_cs_profile['country'], cpgTool::countries());

	cpgshop_make_form($edit_profile_form_param0, "");
	cpgshop_make_form($edit_profile_form_param1, $form_data1);
	cpgshop_make_form($edit_profile_form_param2, $form_data2);

	return $form_data;
}

function cpgshop_register_form_submit($user_array)
{
	global $CONFIG, $lang_cs_profile;
	$superCage = Inspekt::makeSuperCage();
	if (UDB_INTEGRATION == 'coppermine') { //!defined('UDB_INTEGRATION')) {

		$def_array = cpgTool::profile_definition_array();
		foreach ($def_array as $key){
			$$key = $superCage->post->getEscaped("$key");
		}

		$result = cpgDB::runQuery("UPDATE {$CONFIG['TABLE_USERS']} SET title = '$title', surename = '$surename', lastname = '$lastname', street = '$street', city = '$city', zip = '$zip', state = '$state', phone = '$phone', country = '$country' WHERE user_id = '" . $user_array['user_id'] . "';");
	}
	return;
}

function cpgshop_make_form($form_param, $form_data)

{
	global $CONFIG, $lang_register_php, $lang_cs_profile;

	$loopCounter = 0;

	foreach ($form_param as $element) {

		if ($loopCounter / 2 == floor($loopCounter / 2)) {
			$cellStyle = 'tableb';
		} else {
			$cellStyle = 'tableb tableb_alternate';
		}

		switch ($element[0]) {

			case 'label':

				echo <<<EOT
			    <tr>
			        <td colspan="2" class="{$cellStyle}">
			            {$element[1]}
			        </td>
			    </tr>

EOT;

	   case 'select':
	   $value = $form_data[$element[1]];

	   if ($element[2]) {

			echo <<<EOT
		   <tr>
			   <td width="40%" class="{$cellStyle}" valign="top">
			   		{$element[2]}
			   </td>
			   <td width="60%" class="{$cellStyle}" valign="top">
		   <select id="{$element[1]}" name="{$element[1]}" class="listbox">
EOT;
		   foreach ($element[3] as $id => $data){

		   $id == $value ? $selected= '  selected="selected"' : $selected= '';

		   echo "<option value=\"{$id}\" {$selected}>{$data}</option>\n";
		   }
		echo <<<EOT
		   </select>
		   </td>
		   </tr>

EOT;
	    }
	    break;


		default:
			cpg_die(CRITICAL_ERROR, 'Invalid action for form creation ' . $element[0], __FILE__, __LINE__);
		}

		$loopCounter++;
	}
}
