<?php
/*********************************************
 cpgShop Plugin for Coppermine Photo Gallery
 ********************************************
 written by Thomas Lange
 based on cpgmart by foulu

 ********************************************
 * @file $Id: cpgshop_calc_shipping.php 82 2012-07-11 12:57:31Z Stramm $
 * @author $Author: Stramm $
 * @version $Revision: 82 $
 * @lastrevision $Date: 2012-07-11 14:57:31 +0200 (Mi, 11. Jul 2012) $
 * @modifiedby $LastChangedBy: Stramm $
 * @lastmodified $LastChangedDate: 2012-07-11 14:57:31 +0200 (Mi, 11. Jul 2012) $
 ********************************************
 cpgShop full Version 1.0.6
 **********************************************/


define('IN_COPPERMINE', true);

$title = $CONFIG['gallery_name'] . ': ' . $lang_cs_cart['calc_shipping'];
$charset = $CONFIG['charset'] == 'language file' ? $lang_charset : $CONFIG['charset'];
echo <<< EOT
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html>
<head>
<title>{$title}</title>
<meta http-equiv="content-type" content="text/html; charset={$charset}" />
<link rel="stylesheet" href="css/coppermine.css" type="text/css" />
<link rel="stylesheet" href="{$THEME_DIR}style.css" type="text/css" />
<script type="text/javascript" src="js/jquery-1.3.2.js"></script>
<script type="text/javascript" src="js/scripts.js"></script>
<script type="text/javascript" src="js/jquery.greybox.js"></script>
<script type="text/javascript" src="js/jquery.elastic.js"></script>

</head>
<body class="tableb" scroll="auto" marginwidth="0" marginheight="0">

EOT;

if (!is_object($cpgshop)) $cpgshop = new cpgShop();

//is an element in the card that needs shipping... or are all elements for download
if( cpgTool::cart_is_ship($cpgshop->cart))
	$delivery_mode = true;
else
	$delivery_mode = false;


// TEMPLATE
$tpl_calc_ship  = cpgTemplate::get('blog_calc_shipping');
$script 		= cpgTemplate::extract($tpl_calc_ship, 'script');
$element   		= cpgTemplate::extract($tpl_calc_ship, 'element');
$page_nav  		= cpgTemplate::extract($tpl_calc_ship, 'page_nav');
$select   		= cpgTemplate::extract($tpl_calc_ship, 'select');


if($delivery_mode){
	//define the country arrays
	$country = array();
	$country_definition = array();
	$current_country_data = cpgDB::fetchRowset("SELECT cid, english_name, currency, shipping, abbr FROM `{$CONFIG['TABLE_CS_COUNTRY']}` ORDER BY english_name;");
	//create an array that's similar to the shops config for delivery and gateway
	foreach($current_country_data as $country_data){
		$key = 'cpgshop_'.$country_data['english_name'].'_enable';
		$key_fee_enable = 'cpgshop_'.$country_data['english_name'].'_fee_enable';
		$key_fee = 'cpgshop_'.$country_data['english_name'].'_fee';

		$country_definition[] = $country_data['english_name'];
		$country["$key"] = 1;
		$country["$key_fee_enable"] = 1;
		$country["$key_fee"] = $country_data['shipping'];
	}
	//get the additional shipping that may be defined for a price
	$weight_shipping = cpgTool::is_max_weight_fee($cpgshop->cart);
	//prepare gateway delivery and country array for select function  call
	$delivery = cpgTool::used_gateway_delivery_array(cpgTool::delivery_definition_array());
	$country_shipping = cpgTool::used_gateway_delivery_array($country_definition, $country);
	$standard_delivery[1] = $delivery['name'][1];
	}
$gateway = cpgTool::used_gateway_delivery_array(cpgTool::gateway_definition_array(), false, $delivery_mode);

if($delivery_mode){
	//add a first entry --- select country etc
	array_unshift($delivery['name'], $lang_cs_cart['select_delivery']);
	array_unshift($standard_delivery, $lang_cs_cart['select_delivery']);
	array_unshift($country_shipping['name'], $lang_cs_cart['select_country']);
	array_unshift($delivery['js'], '0.0');
}
array_unshift($gateway['name'], $lang_cs_cart['select_gateway']);

if($delivery_mode){
	//first the js array key was directly added in the used_gateway_delivery_array function... but if a gateway is disabled in config that gives problems
	//adding the js array key
	array_walk($delivery['js'], 'cpgTool::array_prefix');
	array_walk($country_shipping['js'], 'cpgTool::array_prefix');
}
array_walk($gateway['js'], 'cpgTool::array_prefix');


//prepare the javascript
$js_var = "var gateway = {" . implode(",", $gateway['js']) ."};";
$js_var .= "\nvar total = \"{$lang_cs_cart['total']}:\";\nvar gateway_fee = \"{$lang_cs_cart['gateway_fee']}:\";";
$js_var .= "\nvar currency_symbol = \"".$currency_symbol[$CONFIG['cpgshop_currency']]." \";";
if($delivery_mode){
	$js_var .= "\nvar delivery = {" . implode(",", $delivery['js']) ."};";
	$js_var .= "\nvar standard_delivery = {0:0.0,1:".$delivery['fee'][1]."};";
	$js_var .= "\nvar country_delivery = {" . implode(",", $country_shipping['js']) ."};";
	$js_var .= "\nvar weight_delivery = $weight_shipping;";
	$js_var .= "\nvar country_charge = \"{$lang_cs_cart['country_charge']}:\";\nvar delivery_lang = \"{$lang_cs_cart['delivery']}:\";";

	$js_clause = cpgTool::used_gateways_js($gateway['override']);
}

$tpl_script 	= cpgTemplate::get('blog_gateway_script');
$script_deliver	= cpgTemplate::extract($tpl_script, 'script_deliver');
$script_down  	= cpgTemplate::extract($tpl_script, 'script_down');

if($delivery_mode){
	$js =  cpgTemplate::set($script_deliver, array(
	'{JS_VAR}'	=>	$js_var,
	'{JS_CLAUSE0}'	=>	$js_clause[0],
	'{JS_CLAUSE1}'	=>	$js_clause[1]
));
} else {
	$js =  cpgTemplate::set($script_down, array(
	'{JS_VAR}'	=>	$js_var,
));

}

if ($weight_shipping > 0) {
	$lang_weight = $lang_cs_cart['weight_charge'].':';
	$weight_shipping = $currency_symbol[$CONFIG['cpgshop_currency']].' '.cpgTool::price_format($weight_shipping);
} else {
	$lang_weight = '';
	$weight_shipping = '';
}

if($delivery_mode){
	$select_delivery =	HTMLelement::simple_select('deliverymethod', $delivery['name']);
	$select_delivery_standard = HTMLelement::simple_select('deliverymethod_standard', $standard_delivery);
	$country_shipping = HTMLelement::simple_select('countryselect', $country_shipping['name']);
	$lang_delivery = $lang_cs_cart['select_delivery'];
	$lang_country = $lang_cs_cart['select_country'];
}

echo cpgTemplate::set($script, array(
	'{JS}'	=>	$js
));
starttable('100%', $lang_cs_cart['calc_shipping'], 2);
echo cpgTemplate::set($select, array(
	'{WEIGHT_COST}'					=>	$weight_shipping,
	'{WEIGHT_NAME}'					=>  $lang_weight,
	'{SELECT_COUNTRY}'				=>	$country_shipping,
	'{SELECT_DELIVERY}'				=>	$select_delivery,
	'{SELECT_DELIVERY_STANDARD}'	=>	$select_delivery_standard,
	'{SELECT_GATEWAY}'				=>	HTMLelement::simple_select('paymethod', $gateway['name']),
	'{LANG_GATEWAY}'				=>	$lang_cs_cart['select_gateway'],
	'{LANG_COUNTRY}'				=>	$lang_country,
	'{LANG_DELIVERY}'				=>	$lang_delivery,
));

HTMLelement::spacer();
echo cpgTemplate::set($page_nav, array(
'{CLOSE}'	=>	$lang_cs_cart['close']
));

endtable();
echo "</html>";
