<?php
/*********************************************
 cpgShop Plugin for Coppermine Photo Gallery
 ********************************************
 written by Thomas Lange
 based on cpgmart by foulu

 ********************************************
 * @file $Id: cpgshop_countrylist.php 82 2012-07-11 12:57:31Z Stramm $
 * @author $Author: Stramm $
 * @version $Revision: 82 $
 * @lastrevision $Date: 2012-07-11 14:57:31 +0200 (Mi, 11. Jul 2012) $
 * @modifiedby $LastChangedBy: Stramm $
 * @lastmodified $LastChangedDate: 2012-07-11 14:57:31 +0200 (Mi, 11. Jul 2012) $
 ********************************************
 cpgShop full Version 1.0.6
 **********************************************/

define('IN_COPPERMINE', true);

$title = $CONFIG['gallery_name'] . ': ' . $lang_cs_countrylist['title'];
$charset = $CONFIG['charset'] == 'language file' ? $lang_charset : $CONFIG['charset'];
echo <<< EOT
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html>
<head>
<title>{$title}</title>
<meta http-equiv="content-type" content="text/html; charset={$charset}" />
<link rel="stylesheet" href="css/coppermine.css" type="text/css" />
<link rel="stylesheet" href="{$THEME_DIR}style.css" type="text/css" />

</head>
<body class="tableb" scroll="auto" marginwidth="0" marginheight="0">

EOT;
starttable('100%', $lang_cs_countrylist['title'], 2);

$country_to = cpgDB::fetchRowset("SELECT cid, english_name, native_name, abbr, shipping, type FROM {$CONFIG['TABLE_CS_COUNTRY']} ORDER BY english_name ASC");

echo <<<EOT
    <tr>
        <td width="60%" class="tableb tableb_alternate" height="25" valign="top">
            {$lang_cs_countrylist['country']}
        </td>
        <td width="40%" class="tableb tableb_alternate" valign="top">
            {$lang_cs_countrylist['shipping']}
        </td>
    </tr>

EOT;


$loopCounter = 0;


foreach ($country_to as $key => $element) {
	//does a native name exist in the db
	!$element['native_name'] ? $country = $element['english_name']  : $country = $element['native_name'];
	if ($loopCounter / 2 == floor($loopCounter / 2)) {
		$cellStyle = 'tableb';
	} else {
		$cellStyle = 'tableb tableb_alternate';
	}
	$loopCounter++;
	echo <<<EOT
    <tr>
        <td class="{$cellStyle}" valign="top">
            {$country}
        </td>
        <td class="{$cellStyle}" valign="top">
            {$currency_symbol[$CONFIG['cpgshop_currency']]} {$element['shipping']}
        </td>
    </tr>

EOT;

}
echo <<<EOT

    <tr>
		<td class="tableb" colspan="2" align="center">
			<input onclick="javascript: window.close();" class="button" type="button" value="{$lang_cs_countrylist['close']}">
		</td>
	</tr>
EOT;
endtable();
echo "</html>";
