<?php
/*********************************************
 cpgShop Plugin for Coppermine Photo Gallery
 ********************************************
 written by Thomas Lange
 based on cpgmart by foulu

 ********************************************
 * @file $Id: cpgshop_discount_code.php 82 2012-07-11 12:57:31Z Stramm $
 * @author $Author: Stramm $
 * @version $Revision: 82 $
 * @lastrevision $Date: 2012-07-11 14:57:31 +0200 (Mi, 11. Jul 2012) $
 * @modifiedby $LastChangedBy: Stramm $
 * @lastmodified $LastChangedDate: 2012-07-11 14:57:31 +0200 (Mi, 11. Jul 2012) $
 ********************************************
 cpgShop full Version 1.0.6
 **********************************************/

define('IN_COPPERMINE', true);

$title = $CONFIG['gallery_name'] . ': ' . $lang_cs_cart['verify'];
$charset = $CONFIG['charset'] == 'language file' ? $lang_charset : $CONFIG['charset'];
echo <<< EOT
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html>
<head>
<title>{$title}</title>
<meta http-equiv="content-type" content="text/html; charset={$charset}" />
<link rel="stylesheet" href="css/coppermine.css" type="text/css" />
<link rel="stylesheet" href="{$THEME_DIR}style.css" type="text/css" />
</head>
<body class="tableb" scroll="auto" marginwidth="0" marginheight="0">

EOT;
if (!is_object($cpgshop)) $cpgshop = new cpgShop();

// check no item and logged in
cpgTool::check_enabled();
cpgTool::check_cart($cpgshop);
cpgTool::check_user();

/* moved into if($result)
if ($cart_total < $CONFIG['cpgshop_discount_min_basket']) {
	cpg_die(ERROR, $lang_cs_error['small_basket'], __FILE__, __LINE__);
}
*/

// TEMPLATE
$tpl_code  		= cpgTemplate::get('blog_discount_code');
$element   		= cpgTemplate::extract($tpl_code, 'element');
$footer  		= cpgTemplate::extract($tpl_code, 'footer');
$form  			= cpgTemplate::extract($tpl_code, 'form');

$show_input = true;

//display form and starttable
echo cpgTemplate::set($form, array(
	'{ACTION}'		=>	'index.php?file=cpgshop/cpgshop_discount_code',
));
starttable('100%', $lang_cs_cart['enter_code'], 1);

//check if submitted and do the calc
if(cpgTool::post_var('task')){
	// first we check if the form token is valid
	if (!checkFormToken()) {
		cpg_die(ERROR, $lang_errors['invalid_form_token'], __FILE__, __LINE__);
	}
	if ($code=cpgTool::post_var('discount_code','getAlnum')) {

		$result = cpgDB::fetchRow("SELECT did, discount, currency, expires, created FROM {$CONFIG['TABLE_CS_DISCOUNT']} WHERE number='".cpgTool::encode_data($code)."' AND valid='1';");
		if($result){
			//first check if the cart value is enough to apply the discount
			$cart_total = cpgTool::price_all($cpgshop->cart);
			if ($cart_total < $result['discount'] || $cart_total < $CONFIG['cpgshop_discount_min_basket']) {
				//cart value smaller than the discount || cart value smaller than the configs min basket size -> shop more
				$cookie['discount']['code'] = null;
				$cpgshop->edit_profile($cookie);
				$prefix = cpg_fetch_icon('stop', 0).$lang_cs_error['small_basket'];
			} elseif(!$result['expires'] || ($result['expires'] && cpgTool::discount_expired($result['expires'], $result['created']))){
				//we have a valid code and do not need to show the form
				$show_input = false;
				echo cpgTemplate::set($element, array(
					'{INPUT}'	=>	cpg_fetch_icon('OK', 0).sprintf($lang_cs_cart['code_OK'], $result['discount'], $currency_symbol[$result['currency']]),
				));
				$cookie['discount']['code'] = cpgTool::encode_data($code);
				$cpgshop->edit_profile($cookie);

			} else {
			//code not valid - expired
			$cookie['discount']['code'] = null;
			$cpgshop->edit_profile($cookie);
			$prefix = cpg_fetch_icon('stop', 0).$lang_cs_cart['code_expired'];
			}
		} else {
			//no result - code not valid
			$cookie['discount']['code'] = null;
			$cpgshop->edit_profile($cookie);
			$prefix = cpg_fetch_icon('stop', 0).$lang_cs_cart['code_not_valid'];
		}
	}
}
//do we need to shop the input field
if($show_input){
	echo cpgTemplate::set($element, array(
		'{INPUT}'	=>	$prefix.HTMLelement::text_input('discount_code'),
	));
	HTMLelement::spacer();
	$button = "<input class=\"button\" style=\"font-size: 1.2em;\" type=\"submit\" value=\"{$lang_cs_cart['verify']}\">";
}

//display the footer
list($timestamp, $form_token) = getFormToken();
echo cpgTemplate::set($footer, array(
	'{TOKEN}'		=>	$form_token,
	'{TIMESTAMP}'	=>	$timestamp,
	'{CLOSE}'		=>	$lang_cs_cart['close'],
	'{BUTTON}'		=>	$button,
));

endtable();
echo "</html>";
