<?php
/*********************************************
 cpgShop Plugin for Coppermine Photo Gallery
 ********************************************
 written by Thomas Lange
 based on cpgmart by foulu

 ********************************************
 * @file $Id: HTMLelement.class.php 82 2012-07-11 12:57:31Z Stramm $
 * @author $Author: Stramm $
 * @version $Revision: 82 $
 * @lastrevision $Date: 2012-07-11 14:57:31 +0200 (Mi, 11. Jul 2012) $
 * @modifiedby $LastChangedBy: Stramm $
 * @lastmodified $LastChangedDate: 2012-07-11 14:57:31 +0200 (Mi, 11. Jul 2012) $
 ********************************************
 cpgShop full Version 1.0.6
 **********************************************/


// all HTML element come form here

class HTMLelement {

	//without select boxes, just the final preview... to be used for checkout, order complete, invoice, email etc.
	//type = html_plain, text, array, pdf
	public static function prev_cart($cart, $profile, $type='html_plain') {
		global $CONFIG;
		global $currency_symbol;
		global $lang_cs_cart;

		//depending on the type we load a template
		switch($type){
			case('array'):
			break;
			case('text'):
				$tpl_preview_cart = cpgTemplate::get('blog_preview_cart_txt');
			break;
			case('pdf'):
				$tpl_preview_cart = cpgTemplate::get('blog_preview_cart_pdf');
			break;
			default:
				$tpl_preview_cart = cpgTemplate::get('blog_preview_cart');
		}

		$cart_header      = cpgTemplate::extract($tpl_preview_cart, 'cart_header');
		$cart_element     = cpgTemplate::extract($tpl_preview_cart, 'cart_element');
		$cart_footer      = cpgTemplate::extract($tpl_preview_cart, 'cart_footer');
		// cart header
		$output =  cpgTemplate::set($cart_header, array(
			'{LANG_THUMB}'        => $lang_cs_cart['thumb'],
			'{LANG_NAME}'         => $lang_cs_cart['item_name'],
			'{LANG_PRICE_OPTION}' => $lang_cs_cart['price_n_option'],
			'{LANG_PRICE_EACH}'   => $lang_cs_cart['price_each'],
			'{LANG_QTY}'          => $lang_cs_cart['qty'],
			'{LANG_TYPE}'      	  => $lang_cs_cart['type'],
			'{LANG_PRICE_ALL}'    => $lang_cs_cart['price_all'],
		));
		// cart element
		foreach ($cart as $item_pos => $item_data) {
			$CURRENT_PIC_DATA = cpgTool::get_extended_pic_data($item_data['pid']);

			if ($CURRENT_PIC_DATA['price'] == 0) {
				continue;
			}

			$price_each = cpgTool::price_each($item_data);
			$total += $price_each * $item_data['qty'];

			$type_link = '';
			cpgTool::shipping_item($item_data['price']) ? $del_type = 'down' : $del_type = 'ship';

			$vars = array(
				'{PID}'	        => $item_data['pid'],
				'{NAME}'		=> HTMLelement::item_name($CURRENT_PIC_DATA),
				'{PRICE_EACH}'	=> $currency_symbol[$CONFIG['cpgshop_currency']] ." ".cpgTool::price_format($price_each),
				'{QTY}'			=> $item_data['qty'],
				'{PRICE_ALL}'	=> $currency_symbol[$CONFIG['cpgshop_currency']] ." ".cpgTool::price_format($item_data['qty'] * $price_each),
		);
			//depending on the type we add additional info to the array
			switch($type){
				case('array'):
					break;
				case('text'):
					$type_link = $lang_cs_cart["$del_type"];
					$vars['{LANG_NAME}'] = sprintf("%-24s", $lang_cs_cart['item_name'].':');
					$vars['{LANG_PRICE_OPTION}'] = sprintf("%-24s", $lang_cs_cart['price_n_option'].':');
					$vars['{LANG_PRICE_EACH}'] = sprintf("%-24s", $lang_cs_cart['price_each'].':');
					$vars['{LANG_QTY}'] = sprintf("%-24s", $lang_cs_cart['qty'].':');
					$vars['{LANG_TYPE}'] = sprintf("%-24s", $lang_cs_cart['type'].':');
					$vars['{LANG_PRICE_ALL}'] = sprintf("%-24s", $lang_cs_cart['price_all'].':');
					$vars['{NAME}'] = sprintf("%30s", HTMLelement::item_name($CURRENT_PIC_DATA));
					$vars['{PRICE_ALL}'] = sprintf("%56s", cpgTool::price_format($item_data['qty'] * $price_each)." ".$CONFIG['cpgshop_currency']);
					$vars['{PRICE_EACH}'] = sprintf("%42s", cpgTool::price_format($price_each)." ".$CONFIG['cpgshop_currency']);
					$vars['{QTY}'] = sprintf("%42s", '*'.$item_data['qty']);
					$vars['{TYPE}'] = sprintf("%30s", $type_link);
					$vars['{PRICE}'] = sprintf("%42s", HTMLelement::get_price($item_data['price'],'text'));
					$vars['{OPTION}'] = HTMLelement::get_picoptions_array($CURRENT_PIC_DATA['option'], $item_data['option'], "text");
					break;
				case('pdf'):
					$type_link = $lang_cs_cart["$del_type"];
					$vars['{PRICE}'] = HTMLelement::get_price($item_data['price'],'pdf');
					$vars['{OPTION}'] = HTMLelement::get_picoptions_array($CURRENT_PIC_DATA['option'], $item_data['option'], "pdf");
					$vars['{TYPE}'] = sprintf("%30s", $type_link);
					break;
				default:
					$type_link = "<img src=\"plugins/cpgshop/images/{$del_type}.png\"  alt=\"\" class=\"icon\" border=\"0\" height=\"16\" width=\"16\">";
					$vars['{TYPE}'] = $type_link;
					$vars['{THUMB}'] = HTMLelement::image(get_pic_url($CURRENT_PIC_DATA, "thumb"));
					$vars['{PRICE}'] = HTMLelement::get_price($item_data['price'],'html_plain');
					$vars['{OPTION}'] = HTMLelement::get_picoptions_array($CURRENT_PIC_DATA['option'], $item_data['option'], "html_plain");
			}
			$output .= cpgTemplate::set($cart_element, $vars);
		}

		unset($vars);

		//calculated all needed totals
		$granted_discount = cpgTool::calculate_discount($cart, $profile);
		$gateway_fee = 0;
		$shipping_fee = 0;
		$all = $total-$granted_discount['value']+$profile['gateway']['fee']+$profile['delivery']['fee']+$profile['weight']['fee'];
		$tax = cpgTool::calculate_tax($all);

		//now the lang definition and totals if no html in them,... it's the same for all types
		//html
		switch($type){
			case('array'):
				break;
			case('text'):
				$vars['spacer']['{LANG_TOTAL}'] = '';
				$vars['spacer']['{PRICE_TOTAL}'] = sprintf("%80s",str_repeat('-',12));

				$vars['total']['{LANG_TOTAL}'] = sprintf("%54s", $lang_cs_cart['cart_total']);
				$vars['total']['{PRICE_TOTAL}'] = sprintf("%26s", cpgTool::price_format($total) ." ". $CONFIG['cpgshop_currency']);
				if($granted_discount){
					$vars['discount']['{LANG_TOTAL}'] = sprintf("%54s", $lang_cs_cart['discount_granted']);
					$vars['discount']['{PRICE_TOTAL}'] = sprintf("%26s", '- '.cpgTool::price_format($granted_discount['value'] ." ". $CONFIG['cpgshop_currency']));
				}
				if($profile['gateway']['fee']){
					$name_id = 'cpgshop_'.$profile['gateway']['method'].'_enable';

					$vars['gateway']['{LANG_TOTAL}'] = sprintf("%54s", $lang_cs_cart["$name_id"].' '.$lang_cs_cart['fee']);
					$vars['gateway']['{PRICE_TOTAL}'] = sprintf("%26s", cpgTool::price_format($profile['gateway']['fee']) ." ". $CONFIG['cpgshop_currency']);
				}
				if($profile['delivery']['fee']){
					$vars['delivery']['{LANG_TOTAL}'] = sprintf("%54s", $lang_cs_cart['shipping'].' '.$lang_cs_cart['fee']);
					$vars['delivery']['{PRICE_TOTAL}'] = sprintf("%26s", cpgTool::price_format($profile['delivery']['fee']) ." ". $CONFIG['cpgshop_currency']);
				}
				if($profile['weight']['fee']){
					$vars['weight']['{LANG_TOTAL}'] = sprintf("%54s", $lang_cs_cart['item_addition_ship']);
					$vars['weight']['{PRICE_TOTAL}'] = sprintf("%26s", cpgTool::price_format($profile['weight']['fee']) ." ". $CONFIG['cpgshop_currency']);
				}
				$vars['spacer2']['{LANG_TOTAL}'] = '';
				$vars['spacer2']['{PRICE_TOTAL}'] = sprintf("%80s",str_repeat('-',12));
				$vars['all']['{LANG_TOTAL}'] = sprintf("%54s", $lang_cs_cart['total']);
				$vars['all']['{PRICE_TOTAL}'] = sprintf("%26s", cpgTool::price_format($all) ." ". $CONFIG['cpgshop_currency']);
				$vars['spacer3']['{LANG_TOTAL}'] = '';
				$vars['spacer3']['{PRICE_TOTAL}'] = sprintf("%80s",str_repeat('=',12));
				if($CONFIG['cpgshop_tax_fee']){
					$vars['tax']['{LANG_TOTAL}'] = sprintf("%54s", $lang_cs_cart['tax']);
					$vars['tax']['{PRICE_TOTAL}'] = sprintf("%26s", cpgTool::price_format($tax) ." ". $CONFIG['cpgshop_currency']);
				}
				break;
			case('pdf'):
				//no break, pdf and html look the same
				//break;
			default:
				$vars['total']['{LANG_TOTAL}'] = $lang_cs_cart['cart_total'];
				$vars['total']['{PRICE_TOTAL}'] = $currency_symbol[$CONFIG['cpgshop_currency']] ." ".cpgTool::price_format($total);
				if($granted_discount){
					$vars['discount']['{LANG_TOTAL}'] = $lang_cs_cart['discount_granted'];
					$vars['discount']['{PRICE_TOTAL}'] = '- '.$currency_symbol[$CONFIG['cpgshop_currency']] ." ".cpgTool::price_format($granted_discount['value']);
				}
				if($profile['gateway']['fee']){
					$name_id = 'cpgshop_'.$profile['gateway']['method'].'_enable';

					$vars['gateway']['{LANG_TOTAL}'] = $lang_cs_cart["$name_id"].' '.$lang_cs_cart['fee'];
					$vars['gateway']['{PRICE_TOTAL}'] = $currency_symbol[$CONFIG['cpgshop_currency']] ." ".cpgTool::price_format($profile['gateway']['fee']);
				}
				if($profile['delivery']['fee']){
					$name_id = 'cpgshop_'.$profile['delivery']['method'].'_enable';

					$vars['delivery']['{LANG_TOTAL}'] = $lang_cs_cart['shipping'].' '.$lang_cs_cart['fee'].' ('.$lang_cs_cart["$name_id"].')';
					$vars['delivery']['{PRICE_TOTAL}'] = $currency_symbol[$CONFIG['cpgshop_currency']] ." ".cpgTool::price_format($profile['delivery']['fee']);
				}
				if($profile['weight']['fee']){
					$vars['weight']['{LANG_TOTAL}'] = $lang_cs_cart['item_addition_ship'];
					$vars['weight']['{PRICE_TOTAL}'] = $currency_symbol[$CONFIG['cpgshop_currency']] ." ".cpgTool::price_format($profile['weight']['fee']);
				}
				$vars['all']['{LANG_TOTAL}'] = '<strong>'.$lang_cs_cart['total'].'</strong>';
				$vars['all']['{PRICE_TOTAL}'] = '<strong>'.$currency_symbol[$CONFIG['cpgshop_currency']] ." ".cpgTool::price_format($all).'</strong>';
				if($CONFIG['cpgshop_tax_fee']){
					$vars['tax']['{LANG_TOTAL}'] = $lang_cs_cart['tax'];
					$vars['tax']['{PRICE_TOTAL}'] = $currency_symbol[$CONFIG['cpgshop_currency']] ." ".cpgTool::price_format($tax);
				}
		} //end switch

		foreach($vars as $key => $value) {
			$output .= cpgTemplate::set($cart_footer, $value);
		}
		return $output;
	}
	//similar to prev_cart ... but it returns html and editable data boxes (checkbox, textfields, dropdowns)
	public static function preview_cart($cart_data) {
		global $CONFIG;
		global $currency_symbol;
		global $lang_cs_cart;

		$tpl_preview_cart = cpgTemplate::get('blog_preview_cart');
	    $cart_header      = cpgTemplate::extract($tpl_preview_cart, 'cart_header');
	    $cart_element     = cpgTemplate::extract($tpl_preview_cart, 'cart_element');
	    $cart_footer      = cpgTemplate::extract($tpl_preview_cart, 'cart_footer');
		// cart header
		echo cpgTemplate::set($cart_header, array(
			'{LANG_THUMB}'        => $lang_cs_cart['thumb'],
			'{LANG_NAME}'         => $lang_cs_cart['item_name'],
			'{LANG_PRICE_OPTION}' => $lang_cs_cart['price_n_option'],
			'{LANG_PRICE_EACH}'   => $lang_cs_cart['price_each'],
			'{LANG_QTY}'          => $lang_cs_cart['qty'],
			'{LANG_PRICE_ALL}'    => $lang_cs_cart['price_all'],
		));
		// cart element
		$total = 0;
		foreach ($cart_data as $item_pos => $item_data) {
			$CURRENT_PIC_DATA = cpgTool::get_pic_data($item_data['pid']);
			//if the admin disabled an item, then we have to skip it here, too
			if ($CURRENT_PIC_DATA['price'] == 0) {
				continue;
			}

			$price_each = cpgTool::price_each($item_data);
			$total += $price_each * $item_data['qty'];
			$vars = array(
				'{PID}'	        => $item_data['pid'],
			//	'{CHECK_BOX}'	=> HTMLelement::check_box("pid_".$item_data['pid'], $item_data['pid']),
				'{THUMB}'		=> HTMLelement::image(get_pic_url($CURRENT_PIC_DATA, "thumb")),
				'{NAME}'		=> HTMLelement::item_name($CURRENT_PIC_DATA),
				'{PRICE}'		=> HTMLelement::price_list($CURRENT_PIC_DATA['price'], $item_data['price'], "_".$item_pos, max($CURRENT_PIC_DATA['pwidth'], $CURRENT_PIC_DATA['pheight'])),
				'{OPTION}'		=> HTMLelement::option_list($CURRENT_PIC_DATA['option'], $item_data['option'], "_".$item_pos),
				'{PRICE_EACH}'	=> $currency_symbol[$CONFIG['cpgshop_currency']] ." ".cpgTool::price_format($price_each),
				'{QTY}'			=> HTMLelement::qty_input("qty_".$item_pos, $item_data['qty']),
				'{PRICE_ALL}'	=> $currency_symbol[$CONFIG['cpgshop_currency']] ." ".cpgTool::price_format($item_data['qty'] * $price_each),
			);
			echo cpgTemplate::set($cart_element, $vars);
		}

		// cart footer
		echo cpgTemplate::set($cart_footer, array(
			'{LANG_PRICE_TOTAL}'	=>	$lang_cs_cart['price_total'],
			'{PRICE_TOTAL}'			=>	$currency_symbol[$CONFIG['cpgshop_currency']] ." ".cpgTool::price_format($total),
		));
	}
	//similar to registry form, call input_user_info, check if data is valid(check_user_info)
	public static function edit_address_form($form_data, $prefill){
		global  $lang_cs_profile, $lang_register_php, $icon_array;

		$submit = cpgTool::post_var('submit');
		if (!$submit) {
			self::input_user_info($form_data, $prefill);
		} else {
			if (!self::check_user_info($errors)) {
				self::input_user_info($form_data, '',$errors);
			}
		}
	}
	//edit address -> check the info, add to db
	public static function check_user_info(&$error)
{
	global $CONFIG, $lang_cs_profile, $lang_cs_cart;
	global $lang_register_php, $lang_common;
	global $lang_errors;

	if ($error != '') {
		return false;
	}

	$superCage = Inspekt::makeSuperCage();

		$type = $superCage->post->getEscaped('type');
		//if (!isset($type)) $type='0';
		$title = $superCage->post->getEscaped('title');
		$surename = $superCage->post->getEscaped('surename');
		$lastname = $superCage->post->getEscaped('lastname');
		$street = $superCage->post->getEscaped('street');
		$city = $superCage->post->getEscaped('city');
		$zip = $superCage->post->getEscaped('zip');
		$state = $superCage->post->getEscaped('state');
		$phone = $superCage->post->getEscaped('phone');
		$country = $superCage->post->getEscaped('country');


		//we save the billing address in the users table if not bridged
		if (UDB_INTEGRATION == 'coppermine' && $type == 0 ) {
			$result = cpgDB::runQuery("UPDATE {$CONFIG['TABLE_USERS']} SET title = '$title', surename = '$surename', lastname = '$lastname', street = '$street', city = '$city', zip = '$zip', state = '$state', phone = '$phone', country = '$country' WHERE user_id = '".USER_ID."';");
		} else {
			$data = cpgDB::fetchRow("SELECT sid FROM {$CONFIG['TABLE_CS_ADDRESS']}  WHERE type = {$type} AND user_id ='" . USER_ID . "' ");
			//a shipping address already exists -> update
			if(isset($data['sid'])){
				$result = cpgDB::runQuery("UPDATE {$CONFIG['TABLE_CS_ADDRESS']} SET title = '$title', surename = '$surename', lastname = '$lastname', street = '$street', city = '$city', zip = '$zip', state = '$state', phone = '$phone', country = '$country' WHERE sid = '{$data[sid]}';");

			} else {
				//insert new shipping address
				cpgDB::runQuery("INSERT INTO `{$CONFIG['TABLE_CS_ADDRESS']}`
		    			(sid, user_id, type, title, surename, lastname, street, city, zip, state, phone, country)
		    			VALUES
		    			('','".USER_ID."', '$type', '$title', '$surename','$lastname','$street', '$city', '$zip', '$state', '$phone', '$country');");
			}
		}
		echo "<tr>\n<td class=\"tableb\">\n";
		msg_box($lang_cs_cart['addr_updated'], $lang_cs_cart['addr_updated'], "<span class=\"button\">".$lang_common['continue']."</span>", 'index.php?file=cpgshop/cpgshop_cart&page=verify_address');
		echo "</td>\n</tr>\n";
		//endtable();

	return true;
}
	//edit address -> input form data
	public static function input_user_info($form_data, $prefill, $errors = ''){
		global  $lang_cs_profile, $lang_register_php, $icon_array;


		$superCage = Inspekt::makeSuperCage();

		echo <<< EOT
    <tr>
        <td class="tableb" colspan="2">
            <div id="form_not_submit_top" class="formFieldWarning" style="display:none;">
                {$lang_cs_profile['fill_in']}
            </div>
        </td>
    </tr>

EOT;

		$loopCounter = 0;
		foreach ($form_data as $element) {

			if (empty($element)) {
				continue;
			}

			if ($loopCounter / 2 == floor($loopCounter / 2)) {
				$row_style = 'tableb';
			} else {
				$row_style = 'tableb tableb_alternate';
			}

			$loopCounter++;

			switch ($element[0]) {

				case 'label':

					echo <<< EOT
    <tr>
        <td colspan="2" class="tableh2">
            {$element[1]}
        </td>
    </tr>

EOT;
					break;

				case 'input':

					if ($superCage->post->keyExists($element[1])) {
						$value = $superCage->post->getEscaped($element[1]);
					} else {
						$value = $prefill[$element[1]];
					}

					if (isset($lang_register_php[$element[1].'_warning1'])) {
						$warning1 = '<div id="'.$element[1].'_warning1" class="cpg_message_validation formFieldWarning" style="display:none;">' . $lang_register_php[$element[1].'_warning1'] . '</div>';
					} else {
						$warning1 = '';
					}

					if (isset($lang_register_php[$element[1].'_warning2']) == TRUE) {
						$warning2 = '<div id="'.$element[1].'_warning2" class="cpg_message_validation formFieldWarning" style="display:none;">' . $lang_register_php[$element[1].'_warning2'] . '</div>';
					} else {
						$warning2 = '';
					}

					if ($element[2]) {

						echo <<< EOT
    <tr>
        <td width="40%" class="{$row_style}">
            {$element[2]}
        </td>
        <td width="60%" class="{$row_style}" valign="top">
            <input type="text" style="width: 100%" name="{$element[1]}" id="{$element[1]}" maxlength="{$element[3]}" value="$value" class="textinput" />
            {$warning1}
            {$warning2}
        </td>
    </tr>

EOT;
					}
					break;

				case 'hidden':

					echo <<< EOT
    <tr>
        <td colspan="2" class="{$row_style}">
            <input type="hidden" name="{$element[1]}" id="{$element[1]}" value="{$element[2]}" />
        </td>
    </tr>

EOT;

					break;

				case 'select':

					if ($superCage->post->keyExists($element[1])) {
						$value = $superCage->post->getEscaped($element[1]);
					} else {
						$value = $prefill[$element[1]];
					}

					if (isset($lang_register_php[$element[1].'_warning1'])) {
						$warning1 = '<div id="'.$element[1].'_warning1" class="cpg_message_validation formFieldWarning" style="display:none;">' . $lang_register_php[$element[1].'_warning1'] . '</div>';
					} else {
						$warning1 = '';
					}

					if (isset($lang_register_php[$element[1].'_warning2']) == TRUE) {
						$warning2 = '<div id="'.$element[1].'_warning2" class="cpg_message_validation formFieldWarning" style="display:none;">' . $lang_register_php[$element[1].'_warning2'] . '</div>';
					} else {
						$warning2 = '';
					}

					if ($element[2]) {

						echo <<< EOT
    <tr>
        <td width="40%" class="{$row_style}">
            {$element[2]}
        </td>
        <td width="60%" class="{$row_style}" valign="top">
			<select id="{$element[1]}" name="{$element[1]}" class="listbox" style=\"width: 100%;\">
EOT;
						foreach ($element[3] as $id => $data){
							$id == $value ? $selected= '  selected="selected"' : $selected= '';
							echo "<option value=\"{$id}\" {$selected}>{$data}</option>\n";
						}

						echo <<< EOT
			</select>
            {$warning1}
            {$warning2}
        </td>
    </tr>

EOT;
					}
					break;
					//mod end CPGShop

				default:
					cpg_die(CRITICAL_ERROR, 'Invalid action for form creation ' . $element[0], __FILE__, __LINE__);
 			}//switch
		}//foreach

		echo <<< EOT
		<tr>
		<td class="tablef" colspan="2">
		<div id="form_not_submit_bottom" class="formFieldWarning" style="display:none;">
		{$lang_register_php['form_not_submit']}
		</div>
		   </td>
			</tr>

EOT;

    echo <<< EOT
    <tr>
        <td colspan="2" align="center" class="tablef">
            <button type="submit" class="button" name="submit" id="submit" value="Submit registration">Submit</button>
        </td>
    </tr>
    <tr>
        <td class="tablef" colspan="2">
            <div id="form_not_submit_bottom" class="formFieldWarning" style="display:none;">
                Cancel
            </div>
        </td>
    </tr>

EOT;

	return;
	}
	//grabs the cart and profile array from the db (orders) and creates a pay with paypal button... needs oid
	public static function paypal_button($oid){
		global $CONFIG;
		global $currency_symbol;
		global $lang_cm_error, $lang_cs_cart, $LINEBREAK;

		// check no shop enabled and logged in
		cpgTool::check_enabled();
		cpgTool::check_user();

		//grab profile array from the db
		$result = cpgDB::fetchRow("SELECT user_id, profile, cart FROM {$CONFIG['TABLE_CS_ORDER']} WHERE oid='".(int)$oid."';");
		$profile_data = unserialize($result['profile']);
		$cart_data = unserialize($result['cart']);

		if (!is_array($profile_data)) {
			// something went wrong, initialize to empty array
			$profile_data = array();
		}
		if (!is_array($cart_data)) {
			// something went wrong, initialize to empty array
			$cart_data = array();
		}
		$item_in_cart = count($cart_data);
		if ($item_in_cart == 0) {
			cpg_die(ERROR, $lang_cm_error['no_item'], __FILE__, __LINE__);
		}
		$tpl_check_out = cpgTemplate::get('blog_paypal');
		$form_header   = cpgTemplate::extract($tpl_check_out, 'form_header');

		// real || sand box
		if ($CONFIG['cpgshop_paypal_test_mode'])
			$paypal_address = "https://www.sandbox.paypal.com/cgi-bin/webscr";
		else
			$paypal_address = "https://www.paypal.com/cgi-bin/webscr";
		//ssl enabled?
		if($CONFIG['cpgshop_paypal_ssl_enable'] && $CONFIG['cpgshop_paypal_ssl_adress'] != ''){
			$site_url = $CONFIG['cpgshop_paypal_ssl_adress'];
		} else {
			$site_url = $CONFIG['ecards_more_pic_target'];
		}


		//extra check if user hasn't added a from PayPal not supported currency
		if (!in_array($CONFIG['cpgshop_currency'], array('AUD', 'BRL', 'CAD', 'CHF', 'CZK', 'DKK', 'EUR', 'GBP', 'HKD', 'HUF', 'JPY', 'NOK', 'NZD', 'PLN', 'SEK', 'SGD', 'USD'))) {
			$CONFIG['cpgshop_currency'] = 'EUR';
		}


		/*********************************************************************************************
		 *    Currently these are the supported charsets:                                             *
		 *    big5, euc-jp, euc-kr, euc-tw, gb2312, hz-gb-2312, ibm-862, iso-2022-cn, iso-2022-jp,    *
		 *    iso-2022-kr, iso-8859-1, iso-8859-2, iso-8859-3, iso-8859-4, iso-8859-5, iso-8859-6,    *
		 *    iso-8859-7, iso-8859-8, iso-8859-9, iso-8859-13, iso-8859-15, ko18-r, shift_jis,        *
		 *    utf-7, utf-8, utf-16, utf-16be, utf-16le, utf-16_platformendian, utf-16_oppositeendian, *
		 *    utf-32, utf-32be, utf-32le, utf-32_platformendian, utf-32_oppositeendian, usa-ascii,    *
		 *    windows-1250, windows-1251, windows-1252, windows-1253, windows-1254, windows-1255,     *
		 *    windows-1256, windows-1257, windows-1258, windows-874, windows-949, x-mac-greek,        *
		 *    x-mac-turkish, x-mac-centraleurroman, x-mac-cyrillic, ebcdic-cp-us, ibm-1047            *
		 **********************************************************************************************/

		//need to code state abbr
		//no_shipping=1 : do not prompt for an address -> for sownload
		//no_shipping=2: prompt for address and require -> shipping
		//but that only works if correct state per country is transmitted


		//hidden fields
		$hidden_array = array(
			'cmd' 					=> '_cart',
			'upload'				=> 1,
			'rm'					=> 2,
			'no_shipping'			=> 1,
			'no_note'				=> 1,
			'lc'					=> strtoupper ($profile_data['billing_address']['country']),
			'charset'				=> "iso-8859-1",
			'business'				=> $CONFIG['cpgshop_paypal_email'],
			'return'				=> $CONFIG['ecards_more_pic_target']."index.php?file=cpgmart/cpgshop_cart&page=paid",
			'notify_url'			=> $site_url."index.php?file=cpgshop/cpgshop_cart&page=ipn",
			'invoice'				=> $oid,
			'custom'				=> $result['user_id'],
			'currency_code'			=> $CONFIG['cpgshop_currency'],
			'handling_cart'			=> cpgTool::price_format($profile_data['gateway']['fee'] + $profile_data['delivery']['fee'] + $profile_data['weight']['fee']),
			'discount_amount_cart'	=> cpgTool::price_format($profile_data['discount']['value']),
			'bn'					=> SHOP_VERSION."_US",
	);

		//the items in the cart
		$item_pos = 0;
		foreach ($cart_data as $item_data) {
			$CURRENT_PIC_DATA = cpgTool::get_pic_data($item_data['pid']);
			$item_pos++;
			// main item
			$hidden_array["item_name_".$item_pos] = HTMLelement::item_name($CURRENT_PIC_DATA);
			$hidden_array["amount_".$item_pos] = cpgTool::price_format(cpgTool::price_each($item_data));
			$hidden_array["quantity_".$item_pos] = $item_data['qty'];
			$hidden_array["item_number_".$item_pos] = $item_pos;
			// options
			$option_pos = 0;
			foreach ($item_data['option'] as $option_id => $option_value) {
				$option_data = cpgDB::fetchRow("SELECT title, title_array, value_array, currency FROM `{$CONFIG['TABLE_CS_OPTION']}` WHERE oid = '$option_id' LIMIT 1;");
				$option_data['title_array'] = cpgTool::decode_data($option_data['title_array']);
				$option_data['value_array'] = cpgTool::decode_data($option_data['value_array']);
				foreach ($option_data['title_array'] as $title_key => $title_value) {
					$option_combine[] = array($option_data['value_array'][$title_key], $option_data['title_array'][$title_key]);
					$option_combine[$option_value][0] = cpgTool::price_format(cpgTool::to_config_currency($option_combine[$option_value][0], $option_data['currency']));
				}
				$hidden_array["on".$option_pos."_".$item_pos] = $option_data['title'];
				$hidden_array["os".$option_pos."_".$item_pos] = $option_combine[$option_value][1];
				$option_pos++;
			}
		}

		require_once('plugins'.DS.'cpgshop'.DS.'libs'.DS.'cpgPayPal.class.php');
		$paypal = new cpgshop_paypal_emp_class($CONFIG['cpgshop_paypal_encrypt_certid'], $CONFIG['cpgshop_paypal_encrypt_path'].$CONFIG['cpgshop_paypal_encrypt_pubk_own'], $CONFIG['cpgshop_paypal_encrypt_path'].$CONFIG['cpgshop_paypal_encrypt_privk_own'], $CONFIG['cpgshop_paypal_encrypt_path'].$CONFIG['cpgshop_paypal_encrypt_pubk_paypal'], './'.$CONFIG['fullpath'].'edit');

		if ($CONFIG['cpgshop_paypal_encrypt_enable']){
			$hidden_elements = self::hidden('cmd', '_s-xclick');
			$hidden_elements .= self::hidden('encrypted', $paypal->encryptButton($hidden_array));

		} else {
			$data = "";
			foreach ($hidden_array as $key => $value) {
				if ($value != "") {
					$data .= "$key=$value".$LINEBREAK;
					$hidden_elements .= self::hidden($key , $value);
				}
			}
		}

		// checkout button
		$pp_button = starttable();
		$pp_button .= cpgTemplate::set($form_header, array(
			'{PAYPAL_ADDRESS}'	=>	$paypal_address,
			'{HIDDEN}'			=>	$hidden_elements,
		    '{LANG_SUBMIT}' 	=>	$lang_cs_cart['pay_with_pp'],
		));
		$pp_button .= endtable();

		return $pp_button;
	}
	//displays messages (takes an array as text, too)
	public static function message($title, $text)	{
		global $CONFIG;
		$message = cpgTemplate::get('element_message');
		starttable($CONFIG['picture_table_width'], $title);
		if (!is_array($text))
			echo cpgTemplate::set($message, array('{MESSAGE}'=>$text));
		else {
			foreach ($text as $item) {
				echo cpgTemplate::set($message, array('{MESSAGE}'=>$item));
			}
		}
		endtable();
	}
	public static function hidden($name, $value) {
		return "<input type=\"hidden\" name=\"$name\" value=\"$value\" />\n";
	}
	//used in config -> makes a input text field
	public static function textfield($name, $value){
		return '<input type="text" class="textinput"  name="'.$name.'" id="'.$name.'" value="'.$value.'" />';
	}
	public static function radio2($name, $value, $checked, $extra="", $text) {
		return "<input type=\"radio\" name=\"$name\" id=\"$name\" value=\"$value\" $extra $checked> $text" ;
	}
	public static function radio($name, $value="") {
		switch ($value) {
			case 1:
				return "<input type=\"radio\" name=\"$name\" value=\"1\" checked=\"checked\"> Y<input type=\"radio\" name=\"$name\" value=\"0\" /> N\n";
				break;
			case 0:
				return "<input type=\"radio\" name=\"$name\" value=\"1\"> Y<input type=\"radio\" name=\"$name\" value=\"0\" checked=\"checked\" /> N\n";
				break;
			default:
				return "<input type=\"radio\" name=\"$name\" value=\"1\"> Y<input type=\"radio\" name=\"$name\" value=\"0\" /> N\n";
		}
	}
	public static function qty_input($name, $value="") {
		return "<input class=\"textinput\" type=\"text\" name=\"$name\" size=\"3\" value=\"$value\" />\n";
	}
	public static function text_input($name, $value="") {
		return "<input class=\"textinput\" type=\"text\" name=\"$name\" style=\"width: 100%\" value=\"$value\" />\n";
	}
	public static function text_area($name, $value="", $cols='50', $rows='5') {
		return "<textarea class=\"textinput\" name=\"$name\" value=\"\" cols=\"$cols\" rows=\"$rows\">$value</textarea>\n";
	}
	//returns a dropdown $name = select name, $value array = array with key and value, default= selected key, first = if the first entry should be a 'please select' entry
	public static function simple_select($name, $value_array, $default=null, $width='100%') {
		global $CONFIG;
		$html = "";
		$html .= "<select name=\"$name\" id=\"$name\" class=\"listbox\" style=\"width: $width;\">\n";
		foreach ($value_array as $key => $title) {
			if (isset($default) && $default == $key) {
				$html .= "<option value=\"$key\" selected=\"selected\">$title</option>\n";
			} else {
				$html .= "<option value=\"$key\">$title</option>\n";
			}
		}
		$html .= "</select>\n";
		return $html;
	}
	public static function advance_select($name, $value_array, $default='') {
		global $CONFIG;
		global $currency_symbol;
		$html = "";
		$html .= "<select name=\"$name\" class=\"listbox\" style=\"width: 100%;\">\n";
		foreach ($value_array as $id => $data) {
			// different in currency ?
			// format
			$data[0] = cpgTool::price_format(cpgTool::to_config_currency($data[0], $data[2]));
			if ($id == $default)
				$html .= "<option value=\"$id\" selected=\"selected\">{$currency_symbol[$CONFIG['cpgshop_currency']]} {$data[0]} ({$data[1]})</option>\n";
			else
				$html .= "<option value=\"$id\">{$currency_symbol[$CONFIG['cpgshop_currency']]} {$data[0]} ({$data[1]})</option>\n";
		}
		$html .= "</select>\n";
		return $html;
	}
	public static function multiple_select($name, $value_array, $default=array(), $size=5) {
		global $CONFIG;
		$html = "";
		$html .= "<select name=\"{$name}[]\" class=\"listbox\" multiple=\"multiple\" size=\"$size\" style=\"width: 100%;\">\n";
		foreach ($value_array as $value => $title) {
			if (in_array($value, $default))
				$html .= "<option value=\"$value\" selected=\"selected\">$title</option>\n";
			else
				$html .= "<option value=\"$value\">$title</option>\n";
		}
		$html .= "</select>\n";
		return $html;
	}
	public static function check_box($name, $value, $checked = '') {
		return "<input type=\"checkbox\" name=\"$name\" value=\"$value\" $checked>";
	}
	//returns an array with the selected optionset title, title, price, currency of a certain pic
	//can return html, text etc as well
	public static function get_picoptions_array($optionset_id, $item_options_arr, $type="html_plain") {
		global $CONFIG;
		global $currency_symbol;
		global $lang_cs_cart;

		$optionset_id = (int)$optionset_id;

		$option_set = cpgDB::fetchRow("SELECT * FROM `{$CONFIG['TABLE_CS_OPTIONSET']}` WHERE oid = '$optionset_id' LIMIT 1;");
		$option_array = cpgTool::decode_data($option_set['option_array']);
		$counter = 1;
		foreach($item_options_arr as $option_id => $onumber) {
			$option_data = cpgDB::fetchRow("SELECT title, title_array, value_array, currency FROM `{$CONFIG['TABLE_CS_OPTION']}` WHERE oid = '$option_id' LIMIT 1;");

			$option_data['title_array']	= cpgTool::decode_data($option_data['title_array']);
			$option_data['value_array']	= cpgTool::decode_data($option_data['value_array']);
			switch($type){
				case('array'):
					$result[] = array($option_data['title'], $option_data['title_array'][$onumber],$option_data['value_array'][$onumber],$ONFIG['cpgshop_currency']);
				break;
				case('text'):

					$counter < count($item_options_arr) ? $lf = "\n" : $lf="";
					$result .= sprintf("%-40s","\t{$option_data['title']} -> {$option_data['title_array'][$onumber]}");
					$result .= 	sprintf("%19s",cpgTool::price_format($option_data['value_array'][$onumber]). ' ' .$CONFIG['cpgshop_currency']).$lf;
					$counter++;
				break;
				case('pdf'):
					$result .= "<small>\n<table style=\"font-size:x-small;\">\n<tr>\n<td class=\"\" valign=\"middle\" style=\"text-align: right;\">{$lang_cs_cart['option_price']} -> {$option_data['title']}:&nbsp;</td>\n<td class=\"\">{$option_data['title_array'][$onumber]} -> {$currency_symbol[$CONFIG['cpgshop_currency']]} ".cpgTool::price_format($option_data['value_array'][$onumber])."</td>\n</tr>\n</table>\n</small>\n";
				break;
				default:
					$result .= "<small>\n<table style=\"font-size:x-small;\">\n<tr>\n<td class=\"tableh2\" valign=\"middle\" style=\"text-align: right;\">{$lang_cs_cart['option_price']} -> {$option_data['title']}:&nbsp;</td>\n<td class=\"tableb\">{$option_data['title_array'][$onumber]} -> {$currency_symbol[$CONFIG['cpgshop_currency']]} ".cpgTool::price_format($option_data['value_array'][$onumber])."</td>\n</tr>\n</table>\n</small>\n";
			}
		}
	return $result;
	}
	//returns an array, text, html ...
	public static function get_price($price_id="", $type="html_plain") {
		global $CONFIG;
		global $currency_symbol;
		global $lang_cs_cart;

		$price_id = (int)$price_id;

		$price_data = cpgDB::fetchRow("SELECT pid, title, value, currency FROM `{$CONFIG['TABLE_CS_PRICE']}` WHERE pid = '{$price_id}' LIMIT 1;");
		switch($type){
			case('array'):
				$result = $price_data;
				break;
			case('text'):
				$result = sprintf("%42s",$price_data['title'].' '.$price_data['value']." ".$CONFIG['cpgshop_currency']);
				break;
			case('pdf'):
				$result = $price_data['title'].": ".$currency_symbol[$CONFIG['cpgshop_currency']]." ".$price_data['value'];
				break;
			default:
				$result = $price_data['title'].": ".$currency_symbol[$CONFIG['cpgshop_currency']]." ".$price_data['value'];
		}
		return $result;
	}
	public static function price_list($id, $default="", $extra="", $max="") {

		global $CONFIG;
		global $currency_symbol;

		$id = (int)$id;
		$price_set = cpgDB::fetchRow("SELECT * FROM `{$CONFIG['TABLE_CS_PRICESET']}` WHERE pid = '$id' LIMIT 1;");
		$price_array = cpgTool::decode_data($price_set['price_array']);

		foreach ($price_array as $price_id) {
			$price_data = cpgDB::fetchRow("SELECT pid, title, value, currency, type, size FROM `{$CONFIG['TABLE_CS_PRICE']}` WHERE pid = '{$price_id}' LIMIT 1;");
			//$curr_pic_size = cpgDB::fetchRow("SELECT pwidth, pheight FROM `{$CONFIG['TABLE_PICTURES']}` WHERE pid = '{$price_data['pid']}' LIMIT 1;");

			//add the price only if if's print or if it's a download, if the size is smaller than the pics max(width/height)
			if(!$price_data['size'] || ($price_data['size'] <= $max))
				$price_combine[$price_data['pid']] =  array($price_data['value'], $price_data['title'], $CONFIG['cpgshop_currency']);
		}
		return self::advance_select('price'.$extra, $price_combine, $default);
	}
	public static function option_list($id, $default_array=array(), $extra="") {
		global $CONFIG;
		global $currency_symbol;
		$id = (int)$id;
		$html = "";
		$option_set = cpgDB::fetchRow("SELECT * FROM `{$CONFIG['TABLE_CS_OPTIONSET']}` WHERE oid = '$id' LIMIT 1;");
		$option_array = cpgTool::decode_data($option_set['option_array']);
		$html .= "<table class=\"maintable\" width=\"100%\" border=\"0\" cellspacing=\"1\" cellpadding=\"0\">\n";
		foreach($option_array as $option_id) {
			$option_data = cpgDB::fetchRow("SELECT title, title_array, value_array, currency FROM `{$CONFIG['TABLE_CS_OPTION']}` WHERE oid = '$option_id' LIMIT 1;");
			$option_data['title_array']	= cpgTool::decode_data($option_data['title_array']);
			$option_data['value_array']	= cpgTool::decode_data($option_data['value_array']);
			$option_combine= array();
			//unset($option_combine);
			foreach ($option_data['title_array'] as $title_key => $title_value) {
				$option_combine[] = array($option_data['value_array'][$title_key],$option_data['title_array'][$title_key], $CONFIG['cpgshop_currency']);
			}
			$html .= "<tr>\n<td class=\"tableh2\" valign=\"middle\" style=\"text-align: right;\">{$option_data['title']}&nbsp;</td>\n<td class=\"tableb\">".self::advance_select("option_".$option_id.$extra, $option_combine, $default_array[$option_id])."</td>\n</tr>\n";
		}
		$html .= "</table>\n";
		return $html;
	}
	public static function plain_price_list($price_id_array) {
		global $CONFIG;
		global $currency_symbol;
		if (!is_array($price_id_array)) $price_id_array = cpgTool::decode_data($price_id_array);
		$html = "";
		$html .= "<table class=\"maintable\" width=\"100%\" border=\"0\" cellspacing=\"1\" cellpadding=\"0\">\n";
		foreach ($price_id_array as $price_id) {
			$price_data = cpgDB::fetchRow("SELECT title, value, currency FROM `{$CONFIG['TABLE_CS_PRICE']}` WHERE pid='$price_id';");
			$html .= "<tr>\n<td class=\"tableb_alternate\" valign=\"middle\" width=\"20%\">{$price_data['title']}&nbsp;</td>\n<td class=\"tableb\" width=\"70%\">{$price_data['value']}</td>\n<td class=\"tableb\" width=\"10%\">{$currency_symbol[$CONFIG['cpgshop_currency']]}</td>\n</tr>\n";
		}
		$html .= "</table>\n";
		return $html;
	}
	public static function plain_option_list($option_id_array) {
		global $CONFIG;
		global $currency_symbol;
		if (!is_array($option_id_array)) $option_id_array = cpgTool::decode_data($option_id_array);
		$html = "";
		$html .= "<table class=\"maintable\" width=\"100%\" border=\"0\" cellspacing=\"1\" cellpadding=\"0\">\n";
		foreach ($option_id_array as $option_id) {
			$option_data = cpgDB::fetchRow("SELECT title, title_array, value_array, currency FROM `{$CONFIG['TABLE_CS_OPTION']}` WHERE oid='$option_id';");
			$option_data['title_array'] = cpgTool::decode_data($option_data['title_array']);
			$option_data['value_array'] = cpgTool::decode_data($option_data['value_array']);
			$combine_array = array_combine($option_data['title_array'], $option_data['value_array']);
			$sub_html = self::plain_option($combine_array);
			$html .= "<tr>\n<td class=\"tableb_alternate\" valign=\"middle\" width=\"30%\" align=\"center\">{$option_data['title']}&nbsp;</td>\n<td class=\"tableb\" width=\"60%\">$sub_html</td>\n<td class=\"tableb\" width=\"10%\" align=\"center\">{$currency_symbol[$CONFIG['cpgshop_currency']]}</td>\n</tr>\n";
		}
		$html .= "</table>\n";
		return $html;
	}
	public static function plain_option($combine_array) {
		$sub_html = "<table class=\"maintable\" width=\"100%\" border=\"0\" cellspacing=\"1\" cellpadding=\"0\">\n";
		foreach ($combine_array as $title => $value) {
			$value = cpgTool::price_format($value);
			$sub_html .= "<tr>\n<td class=\"tableb_alternate\" width=\"40%\">$title</td>\n<td class=\"tableb\" width=\"60%\">$value</td>\n</tr>\n";
		}
		$sub_html .= "</table>\n";
		return $sub_html;
	}
	public static function price_list_title($id) {
		global $CONFIG;
		$id = (int)$id;
		return cpgDB::fetchVar("SELECT title FROM `{$CONFIG['TABLE_CS_PRICESET']}` WHERE pid = '$id' LIMIT 1;");
	}
	public static function option_list_title($id) {
		global $CONFIG;
		$id = (int)$id;
		return cpgDB::fetchVar("SELECT title FROM `{$CONFIG['TABLE_CS_OPTIONSET']}` WHERE oid = '$id' LIMIT 1;");
	}
	public static function item_price_list($item_price) {
		global $CONFIG;
		global $currency_symbol;
		$html = "";
		$html .= "<table class=\"maintable\" width=\"100%\" border=\"0\" cellspacing=\"1\" cellpadding=\"0\">\n";
		$price_data = cpgDB::fetchRow("SELECT title, value, currency  FROM `{$CONFIG['TABLE_CS_PRICE']}` WHERE pid = '$item_price' LIMIT 1;");
		//$price_data['value'] =
		$price_data['value'] = cpgTool::price_format(cpgTool::to_config_currency($price_data['value'], $price_data['currency']));
		$html .= "<tr>\n<td class=\"tableb_alternate\" width=\"30%\">{$price_data['title']}</td>\n<td class=\"tableb\" width=\"70%\">{$currency_symbol[$CONFIG['cpgshop_currency']]} {$price_data['value']}</td>\n</tr>\n";
		$html .= "</table>\n";
		return $html;
	}
	public static function item_option_list($item_option) {
		global $CONFIG;
		global $currency_symbol;
		$html = "";
		$html .= "<table class=\"maintable\" width=\"100%\" border=\"0\" cellspacing=\"1\" cellpadding=\"0\">\n";
		foreach ($item_option as $option_id => $option_value) {
			$option_data = cpgDB::fetchRow("SELECT title, title_array, value_array, currency FROM `{$CONFIG['TABLE_CS_OPTION']}` WHERE oid = '$option_id' LIMIT 1;");
			$option_data['title_array'] = cpgTool::decode_data($option_data['title_array']);
			$option_data['value_array'] = cpgTool::decode_data($option_data['value_array']);
			foreach ($option_data['title_array'] as $title_key => $title_value) {
				$option_combine[] = array($option_data['value_array'][$title_key], $option_data['title_array'][$title_key]);
				$option_combine[$option_value][0] = cpgTool::price_format(cpgTool::to_config_currency($option_combine[$option_value][0], $option_data['currency']));
			}
			$html .= "<tr>\n<td class=\"tableb_alternate\" width=\"30%\">{$option_data['title']}</td>\n<td class=\"tableb\" width=\"40%\">{$option_combine[$option_value][1]}</td>\n<td class=\"tableb\" width=\"30%\">{$currency_symbol[$CONFIG['cpgshop_currency']]} {$option_combine[$option_value][0]}</td>\n</tr>\n";
		}
		$html .= "</table>\n";
		return $html;
	}
	public static function price_set_list($name, $default="") {
		global $CONFIG;
		$price_set_array = cpgDB::fetchRowset("SELECT * FROM `{$CONFIG['TABLE_CS_PRICESET']}`;");
		$value_array = array();
		foreach ($price_set_array as $price_set) {
			$value_array[$price_set['pid']] = $price_set['title'];
		}
		return self::simple_select($name, $value_array, $default);
	}
	public static function option_set_list($name, $default="") {
		global $CONFIG;
		$option_set_array = cpgDB::fetchRowset("SELECT * FROM `{$CONFIG['TABLE_CS_OPTIONSET']}`;");
		$value_array = array();
		foreach ($option_set_array as $option_set) {
			$value_array[$option_set['oid']] = $option_set['title'];
		}
		return self::simple_select($name, $value_array, $default);
	}
	public static function apply_simple_text($template, $text) {
		return cpgTemplate::set($template, array('{TEXT}'=>$text));
	}
	public static function simple_text($colspan="1", $class="tableb", $is_center=false) {
		if ($is_center)	{
			return "<tr><td class=\"$class\" colspan=\"$colspan\" align=\"center\">{TEXT}</td></tr>";
		} else {
			return "<tr><td class=\"$class\" colspan=\"$colspan\">{TEXT}</td></tr>";
		}
	}
	public static function spacer($height=10)	{
		echo "<img src=\"images/spacer.gif\" height=\"$height\" width=\"100%\">\n";
	}
	public static function image($image_link, $size = 0.75) {
		global $CONFIG;
		$image_info = getimagesize($image_link);
		$image_info[0] = round($image_info[0] * $size);
		$image_info[1] = round($image_info[1] * $size);
		if ((int)$image_info[0] == 0) $image_info[0] = $CONFIG['thumb_width'] * $size;
		if ((int)$image_info[1] == 0) $image_info[1] = $CONFIG['thumb_width'] * $size;

		return "<img class=\"image\" src=\"$image_link\" width=\"{$image_info[0]}\" height=\"{$image_info[1]}\">";
	}
	public static function link($link, $text, $class="") {
		if ($class)
			return "<a class=\"$class\" href=\"$link\">$text</a>";
		else
			return "<a href=\"$link\">$text</a>";
	}
	public static function item_name($CURRENT_PIC_DATA) {
		return $CURRENT_PIC_DATA['pid']."|".$CURRENT_PIC_DATA['filename'];
	}
	public static function item_name_enhanced($CURRENT_PIC_DATA) {
		return $CURRENT_PIC_DATA['pid']."|".$CURRENT_PIC_DATA['filename']."<br>".
				$CURRENT_PIC_DATA['aid']."|".$CURRENT_PIC_DATA['title'];
	}

}
