<?php
/*********************************************
 cpgShop Plugin for Coppermine Photo Gallery
 ********************************************
 written by Thomas Lange
 based on cpgmart by foulu

 ********************************************
 * @file $Id: cpgShop.class.php 82 2012-07-11 12:57:31Z Stramm $
 * @author $Author: Stramm $
 * @version $Revision: 82 $
 * @lastrevision $Date: 2012-07-11 14:57:31 +0200 (Mi, 11. Jul 2012) $
 * @modifiedby $LastChangedBy: Stramm $
 * @lastmodified $LastChangedDate: 2012-07-11 14:57:31 +0200 (Mi, 11. Jul 2012) $
 ********************************************
 cpgShop full Version 1.0.6
 **********************************************/

class cpgShop {
	public $cart = [];
	
 	/**
 	* @desc load cart data from cookie
 	*/
  	function __construct() {
 		global $CONFIG;

 		$superCage = Inspekt::makeSuperCage();
 		if ($superCage->cookie->keyExists($CONFIG['cookie_name'].'_cpgshop')) {
 			$data = cpgTool::decode_data($superCage->cookie->getRaw($CONFIG['cookie_name'].'_cpgshop'));

			if ($data['cart_id'] > 0) {

 				if($cart_data = cpgDB::fetchRow("SELECT cart FROM `{$CONFIG['TABLE_CS_CART']}` WHERE cid='{$data['cart_id']}' AND save=0 LIMIT 1;")){

					$cart_data = cpgTool::decode_data($cart_data['cart']);
 					$this->cart = $cart_data['cart'];
 					$this->profile = $cart_data['profile'];
 					$this->cart_id = $data['cart_id'];
					unset ($cart_data);
 				} else {
 					$this->cart_id = false;
 				}
 			}

 		} else {
 			$this->cart_id = false;
 		}
 	}
	function __destruct() {
		unset($this->cart);
		unset($this->profile);
	}
	/**
	* @desc add item to cart
	*/
 	function add_item($item_data) {
 		// check if item ID exists || or not
 		$check = false;
 		foreach ($this->cart as $key => $item) {
 			if ($item['pid'] == $item_data['pid'] && $item['price'] == $item_data['price'] && $item['option'] == $item_data['option']) {
 				$check = true;
 				// update because ...
 				$this->cart[$key]['qty']++;
			}
		}
		// add if false
		if (!$check) $this->cart[] = $item_data;
		$this->double_check();
	}
 	/**
	* @desc modify an item
	*/
	function edit_item($item_pos, $item_data) {
		$this->cart[$item_pos] = $item_data;
		$this->double_check();
	}
 	/**
 	 * @desc modify profile
 	 */
 	function edit_profile($profile_data) {
 		//save over existing key
 		foreach ($profile_data as $key => $data) {
 			$this->profile["$key"] = $data;
 		}
 		self::save();
		return;
 	}
 	/**
	* @desc remove an item
	*/
	function remove_item($item_pos) {
		unset($this->cart[$item_pos]);
	}
	/**
	* @desc save cart to cookie
	*/
 	function save() {
 		global $CONFIG;

		$data['cart'] = $this->cart;
		$data['profile'] = $this->profile;
		$data = cpgTool::encode_data($data);

 		if($this->cart_id) {
 			$result = cpgDB::runQuery("INSERT INTO `{$CONFIG['TABLE_CS_CART']}` (cid,cart,ctime) VALUES ('".$this->cart_id."','{$data}','".localised_timestamp()."')  ON DUPLICATE KEY UPDATE cart='{$data}', ctime='".localised_timestamp()."';");
 		} else {
 			$cookie_data = array();
 			$result = cpgDB::runQuery("INSERT INTO `{$CONFIG['TABLE_CS_CART']}` (cart,ctime) VALUES ('{$data}','".localised_timestamp()."');");
 			$cookie_data['cart_id'] = cpgDB::insertID();
 			$cookie_data = cpgTool::encode_data($cookie_data);
 			setcookie($CONFIG['cookie_name'].'_cpgshop', $cookie_data, time()+86400*30, $CONFIG['cookie_path']);
		}
	}
	/**
	* @desc flush the data
	*/
	function flush() {
		global $CONFIG;
	    unset($this->cart);
	    unset($this->profile);
		unset($this->cart_id);
	    setcookie($CONFIG['cookie_name'].'_cpgshop', "", time()-3600, $CONFIG['cookie_path']);
	}
	/**
	* @desc check if double
	*/
	function double_check() {
		$item_in_cart = count($this->cart);
		$pos_array = array();
		foreach ($this->cart as $key => $item) {
			$pos_array[] = $key;
		}
		for ($i=0;$i<=($item_in_cart-2);$i++) {
			for ($j=$i+1;$j<=($item_in_cart-1);$j++) {
				if ($this->cart[$pos_array[$i]]['pid'] == $this->cart[$pos_array[$j]]['pid'] && $this->cart[$pos_array[$i]]['price'] == $this->cart[$pos_array[$j]]['price'] && $this->cart[$pos_array[$i]]['option'] == $this->cart[$pos_array[$j]]['option']) {
					$this->cart[$pos_array[$i]]['qty'] += $this->cart[$pos_array[$j]]['qty'];
					$this->cart[$pos_array[$j]]['qty'] = 0;
				}
			}
		}
		foreach ($this->cart as $key => $item) {
			if ($item['qty'] == 0) unset($this->cart[$key]);
		}
	}
}
