<?php
/*********************************************
 cpgShop Plugin for Coppermine Photo Gallery
 ********************************************
 written by Thomas Lange
 based on cpgmart by foulu

 ********************************************
 * @file $Id: cpgHTML.class.php 82 2012-07-11 12:57:31Z Stramm $
 * @author $Author: Stramm $
 * @version $Revision: 82 $
 * @lastrevision $Date: 2012-07-11 14:57:31 +0200 (Mi, 11. Jul 2012) $
 * @modifiedby $LastChangedBy: Stramm $
 * @lastmodified $LastChangedDate: 2012-07-11 14:57:31 +0200 (Mi, 11. Jul 2012) $
 ********************************************
 cpgShop full Version 1.0.6
 **********************************************/

class cpgHTML {
    // -----------------------------------------------------------------------------------------
    // VIEW CART
    // -----------------------------------------------------------------------------------------
    public static function view_cart()
    {
        global $CONFIG;
        global $currency_symbol;
        global $lang_cs_cart, $lang_cs_error;
        global $cpgshop;

        if (!is_object($cpgshop)) $cpgshop = new cpgShop();
        // get ACTION
        if (cpgTool::post_var('task') == false) {
            $task = cpgTool::get_var('task');
        } else {
            $task = cpgTool::post_var('task');
        }
        $tpl_view_cart = cpgTemplate::get('blog_view_cart');
        $cart_header = cpgTemplate::extract($tpl_view_cart, 'cart_header');
        $cart_element = cpgTemplate::extract($tpl_view_cart, 'cart_element');
        $cart_footer = cpgTemplate::extract($tpl_view_cart, 'cart_footer');
        $cart_form = cpgTemplate::extract($tpl_view_cart, 'cart_form');
        $cart_form_end = cpgTemplate::extract($tpl_view_cart, 'cart_form_end');
        $no_item = cpgTemplate::extract($tpl_view_cart, 'no_item');
        switch ($task) {
            // update cart
            case "add_item":
                // pid
                $pid = (int)cpgTool::post_var("id");
                // get cart option == little tricky
                $option_array = cpgTool::get_option_array_from_pid($pid);
                $option = array();
                foreach ($option_array as $option_id) {
                    $option[$option_id] = cpgTool::post_var("option_" . $option_id);
                }
                // vars
                $cpgshop->add_item(array(
                        'pid' => $pid,
                        'price' => cpgTool::post_var("price"),
                        'option' => $option,
                        'qty' => 1,
                        ));
                $cpgshop->save();

            	//if CONFIG option set return to the pic instead of showing the cart
            	if(!$CONFIG['cpgshop_cart_after_add']) {
            		// getting info for 'continue shopping' button
            		$cage_SERVER = Inspekt::makeServerCage();
            		$referer = $cage_SERVER->getRaw('HTTP_REFERER');

					cpgRedirectPage($referer, $lang_cs_cart['item_added'], $lang_cs_cart['item_added'], 0, 'success');

					//pageheader($caption, "<META http-equiv=\"refresh\" content=\"1;url=$referer\">");
            		//msg_box($lang_cs_cart['item_added'], $lang_cs_cart['item_added'], $lang_cs_cart['home_page'], $referer, "success");
            		//pagefooter();
            		exit;
            	}
                break;
            case "edit":
                // update cart
                $superCage = Inspekt::makeSuperCage();
                $pos_array = $superCage->post->getInt('pos_array');
                // id is the array numbering of the form, pos the item number within the carts cookie, pid the picture id
                // here we read the id and pos from the pos_array
                foreach ($pos_array as $id => $pos) { // get id and pos from the array, loop
                    $pid = cpgTool::post_var("pid_" . $pos); //get pid (from hidden input)
                    // if the checkbox has a value (checked) of the pid, then we delete that item
                    if (cpgTool::post_var("delete_" . $pos) == $pid) {
                        // remove
                        $cpgshop->remove_item($pos);
                    } else { // edit hit but delete checkbox has no value
                        // update the items in the cart
                        $current_item_data['pid'] = $pid;
                        $current_item_data['price'] = cpgTool::post_var("price_" . $pos);
                        $current_item_data['qty'] = cpgTool::post_var("qty_" . $pos, 'getRaw');
                        $option_array = cpgTool::get_option_array_from_pid($pid);
                        $current_item_data['option'] = array();
                        foreach ($option_array as $option_id) {
                            $current_item_data['option'][$option_id] = cpgTool::post_var("option_" . $option_id . "_" . $pos);
                        }
                        $cpgshop->edit_item($id, $current_item_data);
                    }
                }
                // save ^^
                $cpgshop->save();
                break;
        }

        // view cart
        cpgTool::check_enabled();
        cpgTool::check_cart($cpgshop);
        // cart_form start
        echo cpgTemplate::set($cart_form, '');

        starttable($CONFIG['picture_table_width'], $lang_cs_cart['view_cart_title'], 8);
        // cart header
        echo cpgTemplate::set($cart_header, array(
                '{LANG_DEL}' => $lang_cs_cart['delete'],
                '{LANG_THUMB}' => $lang_cs_cart['thumb'],
                '{LANG_NAME}' => $lang_cs_cart['item_name'],
                '{LANG_PRICE_OPTION}' => $lang_cs_cart['price_n_option'],
                '{LANG_PRICE_EACH}' => $lang_cs_cart['price_each'],
                '{LANG_QTY}' => $lang_cs_cart['qty'],
                '{LANG_TYPE}' => $lang_cs_cart['type'],
                '{LANG_PRICE_ALL}' => $lang_cs_cart['price_all'],
                ));
        // cart body
        $total = 0;
        foreach ($cpgshop->cart as $item_pos => $item_data) {
            $CURRENT_PIC_DATA = cpgTool::get_pic_data($item_data['pid']);
     		//if the admin disabled an item, then we have to skip it here, too
			if ($CURRENT_PIC_DATA['price'] == 0) {
        		continue;
        	}

            $price_each = cpgTool::price_each($item_data);
            // icon and link for shipping, download
            $type_link = '';
            cpgTool::shipping_item($item_data['price']) ? $type = 'down' : $type = 'ship';
            // calculate shipping link just for shipping icons
            if ($CONFIG['cpgshop_show_fees_calc']) {
                $type_link = $calc_fees = "<a href=\"javascript:MM_openBrWindow('index.php?file=cpgshop/cpgshop_calc_shipping','" . uniqid(rand()) . "','scrollbars=yes,toolbar=no,status=no,locationbar=no,resizable=yes,width=360,height=480');\">";
                $calc_fees .= '(' . $lang_cs_cart['calc_fees'] . ")</a>";

                $type_link .= "<img src=\"plugins/cpgshop/images/{$type}.png\"  alt=\"\" class=\"icon\" border=\"0\" height=\"16\" width=\"16\"></a>";
                $calc_fees_spacer = " :: ";
            } else {
                // just show the icons
                $type_link = "<img src=\"plugins/cpgshop/images/{$type}.png\"  alt=\"\" class=\"icon\" border=\"0\" height=\"16\" width=\"16\">";
            }
            // create the array for the template
            $total += $price_each * $item_data['qty'];
            $vars = array(
                '{PID}' => $item_data['pid'],
                '{POS}' => $item_pos,
                '{TYPE}' => $type_link,
                '{CHECK_BOX}' => HTMLelement::check_box("delete_" . $item_pos, $item_data['pid']),
                '{THUMB}' => HTMLelement::image(get_pic_url($CURRENT_PIC_DATA, "thumb")),
                '{NAME}' => HTMLelement::item_name($CURRENT_PIC_DATA),
                '{PRICE}' => HTMLelement::price_list($CURRENT_PIC_DATA['price'], $item_data['price'], "_" . $item_pos, max($CURRENT_PIC_DATA['pwidth'],$CURRENT_PIC_DATA['pheight'])),
                '{OPTION}' => HTMLelement::option_list($CURRENT_PIC_DATA['option'], $item_data['option'], "_" . $item_pos),
                '{PRICE_EACH}' => $currency_symbol[$CONFIG['cpgshop_currency']] . " " . cpgTool::price_format($price_each),
                '{QTY}' => HTMLelement::qty_input("qty_" . $item_pos, $item_data['qty']),
                '{PRICE_ALL}' => $currency_symbol[$CONFIG['cpgshop_currency']] . " " . cpgTool::price_format($item_data['qty'] * $price_each),
                );
            echo cpgTemplate::set($cart_element, $vars);
        }
        // cart_footer
        // if (count($cpgshop->cart) != 0){
        // getting info for 'continue shopping' button
        $cage_SERVER = Inspekt::makeServerCage();
        $referer = $cage_SERVER->getRaw('HTTP_REFERER');

        $granted_discount = cpgTool::calculate_discount($cpgshop->cart, $cpgshop->profile);
        if ($granted_discount) {
            $all = $currency_symbol[$CONFIG['cpgshop_currency']] . " " . cpgTool::price_format($total);
            $total -= $granted_discount['value'];
            $html_discount = '- ' . $currency_symbol[$CONFIG['cpgshop_currency']] . " " . cpgTool::price_format($granted_discount['value']);
            $lang_discount = $lang_cs_cart['discount_granted'];
        }
        if ($CONFIG['cpgshop_tax_fee']) {
            $tax = $currency_symbol[$CONFIG['cpgshop_currency']] . " " . cpgTool::price_format(cpgTool::calculate_tax($total));
            $tax = $calc_fees_spacer . ' ' . sprintf($lang_cs_cart['contains_tax'], (int)$CONFIG['cpgshop_tax_fee'] . '%', $tax);
        }

        echo cpgTemplate::set($cart_footer, array(
                '{LANG_PRICE_TOTAL}' => $lang_cs_cart['price_total'],
                '{PRICE_TOTAL}' => $currency_symbol[$CONFIG['cpgshop_currency']] . " " . cpgTool::price_format($total),
                '{LANG_SUBMIT}' => $lang_cs_cart['edit_cart'],
                '{PRICE_ALL}' => $all,
                '{PRICE_DISCOUNT}' => $html_discount,
                '{LANG_DISCOUNT}' => $lang_discount,
                // '{LANG_CONTINUE}'     	=>	$lang_cs_cart['continue_shopping'],
                '{REFERER}' => $referer,
                '{CALC_FEES}' => $calc_fees,
                '{TAX}' => $tax,
                '{LANG_CHECK_OUT}' => $lang_cs_cart['check_out'],
                '{LANG_HOME_PAGE}' => $lang_cs_cart['home_page'],
                ));
        // }
        endtable();
        // cart form end
        echo cpgTemplate::set($cart_form_end, '');

        return;
    }
    // -----------------------------------------------------------------------------------------
    // VERIFY ADDRESS
    // -----------------------------------------------------------------------------------------
    public static function verify_address()
    {
        global $CONFIG;
        global $lang_cs_cart, $lang_cs_error, $lang_cs_profile, $lang_register_php;
        global $cpgshop;
        global $currency_symbol;

        if (!is_object($cpgshop)) $cpgshop = new cpgShop();
        // check no item and logged in
        cpgTool::check_enabled();
        cpgTool::check_cart($cpgshop);
        cpgTool::check_user();
    	cpgTool::check_min_order($cpgshop);
    	// vars amd arrays
        $warning = false;
        $warning_ship = false;
        $warning_country = 0;
        $cookie = array();
        // html output of billing address
        $tpl_address = cpgTemplate::get('blog_verify_address');
        $header = cpgTemplate::extract($tpl_address, 'header');
        $footer = cpgTemplate::extract($tpl_address, 'footer');
        $element = cpgTemplate::extract($tpl_address, 'element');
        $element_ship = cpgTemplate::extract($tpl_address, 'element_ship');
        $verify_form = cpgTemplate::extract($tpl_address, 'verify_form');
        $verify_form_end = cpgTemplate::extract($tpl_address, 'verify_form_end');
        // get the users profile data and check if all fields are filled in, display a message
        $user_data = cpgTool::get_user_info(USER_ID);
        $html = cpgTool::verify_billingshipping_info('billing', $user_data);
        // verify shipping form - billing address
        echo cpgTemplate::set($verify_form, '');

        starttable($CONFIG['picture_table_width'], cpg_fetch_icon('info') . ' ' . $lang_cs_cart['verify_address_title'], 3);
        echo cpgTemplate::set($header, '');
        echo cpgTemplate::set($element, array(
                '{ADDRESS}' => $html,
                '{DESC}' => "<strong>{$lang_cs_cart['address_data']}</strong><br>{$lang_cs_cart['contact_address']}",
                '{EDIT_PROFILE}' => $lang_cs_cart['edit_address'],
                '{BUTTON_LINK}' => "index.php?file=cpgshop/cpgshop_cart&page=edit_address&type=0",
                ));
        endtable();
        // before displaying the shipping address check if the cart ships
        // is an element in the card that needs shipping... or are all elements for download
        if (cpgTool::cart_is_ship($cpgshop->cart)) {
            // the blue info box
            msg_box($lang_cs_cart['shipping_addr'], $lang_cs_cart['shipping_addr_txt'], "<span class=\"button button_normalfont\">" . $lang_cs_cart['shipping_addr_create'] . "</span>", "index.php?file=cpgshop/cpgshop_cart&page=edit_address&type=1", 'info');
            // first query the shipping address
            $shipping_data = cpgDB::fetchRow("SELECT sid, title, surename, lastname, street, city, zip, state, phone, country FROM {$CONFIG['TABLE_CS_ADDRESS']} WHERE type='1' AND user_id ='" . USER_ID . "' LIMIT 1;");

            if (!$shipping_data) {
                $shipping_data = $user_data;
            }
            // let it verify and create the table cells for it
            $html = cpgTool::verify_billingshipping_info('shipping', $shipping_data);
            // now get the countries to ship to and the shipping prices (shop config)
            $country_to = cpgDB::fetchRow("SELECT cid, english_name, native_name, abbr, shipping, type FROM {$CONFIG['TABLE_CS_COUNTRY']}  WHERE abbr ='" . $shipping_data['country'] . "' ", $shipping_data['cid']);
            // if the shipping address country is not in the to_ship country table, display a warning
            if (!$country_to['cid']) {
                $popup = 'javascript:;" onclick="MM_openBrWindow(\'index.php?file=cpgshop/cpgshop_countrylist\',\'' . uniqid(rand()) . '\',\'scrollbars=yes,toolbar=no,status=no,locationbar=no,resizable=yes,width=360,height=480\')';
                msg_box($lang_cs_cart['error'], $lang_cs_cart['no_shipping'], "<span class=\"button\">" . $lang_cs_cart['no_shipping_button'] . "</span>", $popup, 'error');
                // that we save in the cookie... later we can check for a valid to ship country
                $warning_country = '1';
            } else {
                $warning_country = '0';
            }
            // shipping address descriptive text in fieldset
            $desc = <<< EOT
					<strong>{$lang_cs_cart['shipping_address_data']}</strong><br>
					{$lang_cs_cart['shipping_address']}
EOT;
            // start output
            starttable($CONFIG['picture_table_width'], cpg_fetch_icon('info') . ' ' . $lang_cs_cart['verify_address_title'], 3);
            echo cpgTemplate::set($header, '');
            echo cpgTemplate::set($element_ship, array(
                    '{ADDRESS}' => $html,
                    '{DESC}' => $desc,
                    '{EDIT_PROFILE}' => $lang_cs_cart['shipping_addr_create'],
                    '{DELETE_SHIPPING_ADDR}' => $lang_cs_cart['del_shipping_addr'],
                    '{BUTTON_LINK}' => "index.php?file=cpgshop/cpgshop_cart&page=edit_address&type=1",
                    '{BUTTON_LINK_DEL}' => "index.php?file=cpgshop/cpgshop_cart&page=edit_address&task=delsph",
                    ));
            endtable();
        } // end cart is shipping)
        starttable($CONFIG['picture_table_width'], '', 1);
        echo cpgTemplate::set($footer, array(
                '{LANG_SUBMIT}' => $lang_cs_cart['step2'],
                '{LANG_GO_BACK}' => $lang_cs_cart['go_back'],
                ));

        endtable();
        // cart form end
        echo cpgTemplate::set($verify_form_end, '');
        HTMLelement::spacer();
        // write cookie data
        $cookie['billing_address'] = $user_data;
        $cookie['shipping_address'] = $shipping_data;
        $cookie['shipping_price'] = $country_to;
        $cookie['warning'] = $warning_country;

        $cpgshop->edit_profile($cookie);
        return;
    }
    // -----------------------------------------------------------------------------------------
    // EDIT/ ADD ADDRESS --- atm used for shipping address
    // -----------------------------------------------------------------------------------------
    public static function edit_address()
    {
        global $CONFIG;
        global $lang_cs_profile, $lang_common, $lang_cs_cart, $lang_cs_error, $icon_array, $cpg_udb, $user_id, $cpgshop;

        if (!is_object($cpgshop)) $cpgshop = new cpgShop();
        // check no item and logged in
        cpgTool::check_enabled();
        cpgTool::check_cart($cpgshop);
        cpgTool::check_user();
        // delete shipping address
        $task = cpgTool::get_var('task');
        if ($task == 'delsph') {
            $result = cpgDB::runQuery("DELETE FROM `{$CONFIG['TABLE_CS_ADDRESS']}` WHERE type = '1' AND user_id = '" . USER_ID . "' LIMIT 1;");
            if ($result) {
                msg_box($lang_cs_cart['success'], $lang_cs_cart['shipping_adr_deleted'], "<span class=\"button button_normalfont\">" . $lang_common['continue'] . "</span>", "index.php?file=cpgshop/cpgshop_cart&page=verify_address", 'success');
            }
        } else {
            // shipping or billing address
            if (cpgTool::post_var('type') == false) {
                $type = cpgTool::get_var('type');
            } else {
                $type = cpgTool::post_var('type');
            }
            if (!$type) $type = '0'; //get/post don't like 0 so we set to 0 if null
            if (UDB_INTEGRATION == 'coppermine' && $type == 0) {
                $prefill = $cpg_udb->get_user_infos(USER_ID);
            } else {
                $prefill = cpgDB::fetchRow("SELECT sid, title, surename, lastname, street, city, zip, state, phone, country FROM {$CONFIG['TABLE_CS_ADDRESS']}  WHERE type ='" . $type . "'  AND user_id ='" . USER_ID . "' ");
            }

            $required = cpgTool::required_fields();
            foreach($prefill as $key => $data) {
                if ($key == 'country') {
                    $data = cpgTool::country_by_code($data);
                }
                if ($key == 'title') {
                    $data = $lang_cs_profile["$data"];
                }
                if ($required[$key] == 1) {
                    $lang_cs_profile[$key] .= "<span class=\"smallfont\"> *</span>";
                }
            }

            $def_array = cpgTool::profile_definition_array();
            $form_data[] = array('select', 'title', $icon_array['blank'] . $lang_cs_profile['title'], cpgTool::profile_titles());
            foreach ($def_array as $key) {
                if ($key == 'country' || $key == 'title') continue;
                $form_data[] = array('input', $key, $icon_array['blank'] . $lang_cs_profile["$key"], 255);
            }
            $form_data[] = array('select', 'country', $icon_array['blank'] . $lang_cs_profile['country'], cpgTool::countries());
            $form_data[] = array('hidden', 'type', $type);

            echo <<<EOT
	    		<form name="cpgform" id="cpgform" method="post" action="index.php?file=cpgshop/cpgshop_cart&page=edit_address&type={$type}" onsubmit="return checkRegisterFormSubmit();">

EOT;
            starttable($CONFIG['picture_table_width'], $lang_cs_profile[$type], 2);
            HTMLelement::edit_address_form($form_data, $prefill);
            endtable();
            echo <<<EOT
	    		</form>
EOT;
        }
        return;
    }
    // -----------------------------------------------------------------------------------------
    // SELECT GATEWAY AND SHIPPING
    // -----------------------------------------------------------------------------------------
    public static function select_gateway()
    {
        global $CONFIG;
        global $lang_cs_cart, $lang_cs_error;
        global $cpgshop;
        global $currency_symbol;

        if (!is_object($cpgshop)) $cpgshop = new cpgShop();
        // check no item and logged in
        cpgTool::check_enabled();
        cpgTool::check_cart($cpgshop);
        cpgTool::check_user();
    	cpgTool::check_min_order($cpgshop);
    	// is an element in the card that needs shipping... or are all elements for download
        if (cpgTool::cart_is_ship($cpgshop->cart))
            $delivery_mode = true;
        else
            $delivery_mode = false;

    	//free download? Then we don't need a gateway, discounts etc and redirect to the next page
    	if (cpgTool::check_free_download($cpgshop)) {
    		//redurect to next page

    		$targetAddress="index.php?file=cpgshop/cpgshop_cart&page=check_out";
    		//$header_location = (@preg_match('/Microsoft|WebSTAR|Xitami/', getenv('SERVER_SOFTWARE'))) ? 'Refresh: 0; URL=' : 'Location: ';
    		pageheader('', "<META http-equiv=\"refresh\" content=\"0;url=$targetAddress\">");
    		pagefooter();
			exit;
		}

        // verify the last form (verify_address)
        $verify_array = cpgTool::verify_address($delivery_mode);
        if (isset($verify_array)) {
            $message = "{$lang_cs_cart['adr_error']}\n<br><ul>";

            foreach($verify_array as $error) {
                $message .= "<li>{$lang_cs_cart[$error]}";
            }
            $message .= "</ul><br>\n<input onclick=\"window.location.href='index.php?file=cpgshop/cpgshop_cart&page=verify_address';\" class=\"button\" type=\"button\" value=\"{$lang_cs_cart['go_back']}\"\>";

            cpg_die(ERROR, $message, __FILE__, __LINE__);
        }
        // TEMPLATE
        $tpl_calc_ship = cpgTemplate::get('blog_gateway_shipping');
        $script = cpgTemplate::extract($tpl_calc_ship, 'script');
        $select = cpgTemplate::extract($tpl_calc_ship, 'select');
        $footer = cpgTemplate::extract($tpl_calc_ship, 'footer');
        $cart_form = cpgTemplate::extract($tpl_calc_ship, 'cart_form');
        $cart_form_end = cpgTemplate::extract($tpl_calc_ship, 'cart_form_end');
        // prepare gateway delivery and country array for select function  call
        $gateway = cpgTool::used_gateway_delivery_array(cpgTool::gateway_definition_array(), false, $delivery_mode);

        if ($delivery_mode) {
            // get the additional shipping that may be defined for a price
            $weight_shipping = cpgTool::is_max_weight_fee($cpgshop->cart);

            $delivery = cpgTool::used_gateway_delivery_array(cpgTool::delivery_definition_array());
            $standard_delivery[1] = $delivery['name'][1];
            // add a first entry --- select country etc
            array_unshift($delivery['name'], $lang_cs_cart['select_delivery']);
            array_unshift($standard_delivery, $lang_cs_cart['select_delivery']);
            array_unshift($delivery['js'], '0.0');
        }
        array_unshift($gateway['name'], $lang_cs_cart['select_gateway']);
        // first the js array key was directly added in the used_gateway_delivery_array function... but if a gateway is disabled in config that gives problems
        // adding the js array key
        if ($delivery_mode) {
            array_walk($delivery['js'], 'cpgTool::array_prefix');
            $cid = $cpgshop->profile['shipping_price']['cid'];
            $country_fee = cpgDB::fetchRow("SELECT english_name, native_name, shipping FROM `{$CONFIG['TABLE_CS_COUNTRY']}` WHERE cid = '{$cid}' LIMIT 1;");
        }
        array_walk($gateway['js'], 'cpgTool::array_prefix');
        // prepare the javascript
        $js_var = "var gateway = {" . implode(",", $gateway['js']) . "};";
        $js_var .= "\nvar total = \"{$lang_cs_cart['total']}:\";\nvar gateway_fee = \"{$lang_cs_cart['gateway_fee']}:\";";
        $js_var .= "\nvar country_charge = \"{$lang_cs_cart['country_charge']}:\";\nvar delivery_lang = \"{$lang_cs_cart['delivery']}:\";";
        $js_var .= "\nvar currency_symbol = \"" . $currency_symbol[$CONFIG['cpgshop_currency']] . " \";";
        if ($delivery_mode) {
            $js_var .= "\nvar country = " . $country_fee['shipping'] . ";";
            $js_var .= "\nvar delivery = {" . implode(",", $delivery['js']) . "};";
            $js_var .= "\nvar standard_delivery = {0:0.0,1:" . $delivery['fee'][1] . "};";
            $js_var .= "\nvar weight_delivery = $weight_shipping;";
        }

        $js_clause = cpgTool::used_gateways_js($gateway['override']);

        $tpl_script = cpgTemplate::get('blog_gateway_script');
        $script_deliver = cpgTemplate::extract($tpl_script, 'script_deliver');
        $script_down = cpgTemplate::extract($tpl_script, 'script_down');

        if ($delivery_mode) {
            $js = cpgTemplate::set($script_deliver, array(
                    '{JS_VAR}' => $js_var,
                    '{JS_CLAUSE0}' => $js_clause[0],
                    '{JS_CLAUSE1}' => $js_clause[1]
                    ));
        } else {
            $js = cpgTemplate::set($script_down, array(
                    '{JS_VAR}' => $js_var,
                    ));
        }

        if ($weight_shipping > 0) {
            $lang_weight = $lang_cs_cart['weight_charge'] . ':';
            $weight_shipping = $currency_symbol[$CONFIG['cpgshop_currency']] . ' ' . cpgTool::price_format($weight_shipping);
        } else {
            $lang_weight = '';
            $weight_shipping = '';
        }

        if ($country_fee['shipping'] != 0) {
            $lang_country = $lang_cs_cart['country_charge'] . ' (' . $country_fee['english_name'] . '):';
            $country_shipping = $currency_symbol[$CONFIG['cpgshop_currency']] . ' ' . cpgTool::price_format($country_fee['shipping']);
        } else {
            $lang_country = '';
            $country_shipping = '';
        }

        if ($delivery_mode) {
            $select_delivery = HTMLelement::simple_select('deliverymethod', $delivery['name']);
            $select_delivery_standard = HTMLelement::simple_select('deliverymethod_standard', $standard_delivery);
            $lang_delivery = $lang_cs_cart['select_delivery'];
        }

        echo cpgTemplate::set($script, array(
                '{JS}' => $js
                ));
        msg_box($lang_cs_cart['gateway_header'], $lang_cs_cart['gateway_msg_txt'], '', 'info');
        // discount calc
        switch ($CONFIG['cpgshop_discount_enable']) {
            case 3:
                // discount code: -> show the button
                if (cpgTool::price_all($cpgshop->cart) >= $CONFIG['cpgshop_discount_min_basket']) {
                    $discount_button = "<input onclick=\"MM_openBrWindow('index.php?file=cpgshop/cpgshop_discount_code','" . uniqid(rand()) . "','scrollbars=yes,toolbar=no,status=no,locationbar=no,resizable=yes,width=360,height=240');\" class=\"button button_normalfont\" type=\"button\" value=\"{$lang_cs_cart['discount']}\">";
                } else {
                    $discount_button = '';
                }
                break;
            default:
                // all other discount methods... display the discount
                if ($granted_discount = cpgTool::calculate_discount($cpgshop->cart, $cpgshop->profile))
                    $discount_button = sprintf($lang_cs_cart['granted_discount'], cpgTool::price_format($granted_discount['value']), $currency_symbol[$CONFIG['cpgshop_currency']]);
        } // switch
        // cart _form
        echo cpgTemplate::set($cart_form, '');

        starttable($CONFIG['picture_table_width'], cpg_fetch_icon('info') . ' ' . $lang_cs_cart['gateway_header'], 2);

        echo cpgTemplate::set($select, array(
                '{DISCOUNT_BUTTON}' => $discount_button,
                '{WEIGHT_COST}' => $weight_shipping,
                '{WEIGHT_NAME}' => $lang_weight,
                '{COUNTRY_COST}' => $country_shipping,
                '{COUNTRY_NAME}' => $lang_country,
                '{SELECT_GATEWAY}' => HTMLelement::simple_select('paymethod', $gateway['name']),
                '{SELECT_DELIVERY}' => $select_delivery,
                '{SELECT_DELIVERY_STANDARD}' => $select_delivery_standard,
                '{LANG_COUNTRY}' => $lang_cs_cart['select_country'],
                '{LANG_GATEWAY}' => $lang_cs_cart['select_gateway'],
                '{LANG_DELIVERY}' => $lang_delivery,
                ));

        echo cpgTemplate::set($footer, array(
                '{LANG_SUBMIT}' => $lang_cs_cart['step3'],
                '{LANG_GO_BACK}' => $lang_cs_cart['go_back'],
                ));
        endtable();
        // cart end_form
        echo cpgTemplate::set($cart_form_end, '');
        return;
    }
    // -----------------------------------------------------------------------------------------
    // CHECK OUT
    // -----------------------------------------------------------------------------------------
    public static function check_out()
    {
        global $CONFIG;
        global $currency_symbol;
        global $lang_cs_cart, $lang_cs_error;
        global $cpgshop;

        if (!is_object($cpgshop)) $cpgshop = new cpgShop();
        // check no item and logged in
        cpgTool::check_enabled();
        cpgTool::check_cart($cpgshop);
        cpgTool::check_user();
    	cpgTool::check_min_order($cpgshop);

    	if (cpgTool::check_free_download($cpgshop)) {
    		$free_download = true;
    		// define a back button for the die box
    		$back_button = "<input onclick=\"window.location.href='index.php?file=cpgshop/cpgshop_cart&page=verify_address';\" class=\"button\" type=\"button\" value=\"{$lang_cs_cart['go_back']}\">";
    		$go_back_target = 'verify_address';
		} else {
    		$free_download = false;
	        // define a back button for the die box
	        $back_button = "<input onclick=\"window.location.href='index.php?file=cpgshop/cpgshop_cart&page=select_gateway';\" class=\"button\" type=\"button\" value=\"{$lang_cs_cart['go_back']}\">";
    		$go_back_target = 'select_gateway';
		}

        /**
        *
        * @verify gateway form
        */
        // first we need to know as usual if there's an to ship item in the basket
        // if so (true), we check shipping
        if (cpgTool::cart_is_ship($cpgshop->cart))
            $delivery_mode = true;
        else
            $delivery_mode = false;

		//if we have no free download do the gateway check
    	if (!$free_download) {

			// check if the gateway has been selected
	        $pay_method = (int)cpgTool::post_var('paymethod');
	    	//check post event (from select gateway page and check the cookie when coming from the thank you page - tos not agreed)
	    	if (!$pay_method){
	    		if($cpgshop->profile['gateway']['method']=='')
				cpg_die(ERROR, $lang_cs_cart['die_gateway'] . $back_button, __FILE__, __LINE__);
	    	}
	         // get the gateway definition array... and hence the ids
	        $gateway_array = cpgTool::used_gateway_delivery_array(cpgTool::gateway_definition_array(), false, $delivery_mode);

			// redo the steps in the prev form, unshift, then get with the select option id the CONFIG[key]
	        array_unshift($gateway_array['key'], ' ');
	    	if($pay_method){
	 			$cookie['gateway']['method'] = $value = $gateway_array['key']["$pay_method"];
	    	} else {
	    		$cookie['gateway']['method'] = $value = $cpgshop->profile['gateway']['method'];
	    	}
	        unset($gateway_array);

	        $key = 'cpgshop_' . $value . '_enable';
	        $key_fee_enable = 'cpgshop_' . $value . '_fee_enable';
	        $key_fee = 'cpgshop_' . $value . '_fee';
	        $key_override = 'cpgshop_' . $value . '_override';
	        // we now know if there's an override for that paymethod (only standard delivery)
	        // if so, we don't need to check the standard delivery dropdown as it's mandatory
	        if (!$CONFIG["$key"]) {
	            cpg_die(ERROR, $lang_cs_cart['die_gateway_enabled'] . $back_button, __FILE__, __LINE__);
	        }
	        // get the fee
	        if ($CONFIG["$key_fee_enable"]) {
	            $cookie['gateway']['fee'] = $CONFIG["$key_fee"];
	        }
    	} //end gateway check if no free download

        // if we have a shipping item in the basket -> do the delivery checking
        if ($delivery_mode) {
            // is override enabled? Then we just need to set standard as delivery method and skip the delivery part
            if ($CONFIG["$key_override"]) {
                $cookie['delivery']['method'] = $value = 'standard';
            } else {
                // get deliverymethod from form (ID)
                $delivery_method = cpgTool::post_var('deliverymethod');
            	if (!$delivery_method){
            		if($cpgshop->profile['delivery']['method']=='')
            			cpg_die(ERROR, $lang_cs_cart['die_delivery'] . $back_button, __FILE__, __LINE__);
            	}
                // get the delivery definition array... and hence the ids from there - to be able to compare we have to reconstruct
                $delivery_array = cpgTool::used_gateway_delivery_array(cpgTool::delivery_definition_array());
                // redo the steps in the prev form, unshift, then get with the select option id the CONFIG[key]
                array_unshift($delivery_array['key'], ' ');
            	if($delivery_method){
                	$cookie['delivery']['method'] = $value = $delivery_array['key']["$delivery_method"];
            	} else {
            		$cookie['delivery']['method'] = $value = $cpgshop->profile['delivery']['method'];
            	}

                unset($delivery_array);
            }

            $key = 'cpgshop_' . $value . '_enable';
            $key_fee_enable = 'cpgshop_' . $value . '_fee_enable';
            $key_fee = 'cpgshop_' . $value . '_fee';

            if (!$CONFIG["$key"]) {
                cpg_die(ERROR, $lang_cs_cart['die_delivery'] . $back_button, __FILE__, __LINE__);
            }
            // get the fee
            if ($CONFIG["$key_fee_enable"]) {
                $cookie['delivery']['fee'] = $CONFIG["$key_fee"];
            }
            // get the additional shipping that may be defined for a price
            if ($weight_shipping = cpgTool::is_max_weight_fee($cpgshop->cart)) {
                $cookie['weight']['fee'] = $weight_shipping;
            }
        } else { // no delivery mode... pure download
            $cookie['delivery']['method'] = 'download';
        }
        // add to the cookie delivery method, weight shipping and gateway
        $cpgshop->edit_profile($cookie);
        unset($cookie);
        /**
        *
        * @output cart and totals
        */
        $tpl_check_out = 	cpgTemplate::get('blog_check_out');
        $form_header = 		cpgTemplate::extract($tpl_check_out, 'form_header');
        $form_footer = 		cpgTemplate::extract($tpl_check_out, 'form_footer');
        $element = 			cpgTemplate::extract($tpl_check_out, 'element');
        $element_down = 	cpgTemplate::extract($tpl_check_out, 'element_down');
    	$tos = 				cpgTemplate::extract($tpl_check_out, 'terms');

 		//prepare the TOS if necessary
    	if($CONFIG['cpgshop_tos']){

    		$popup = '<a onclick="MM_openBrWindow(\'index.php?file=cpgshop/cpgshop_tos\',\'' . uniqid(rand()) . '\',\'scrollbars=yes,toolbar=no,status=no,locationbar=no,resizable=yes,width=600,height=480\')"><u>'.$lang_cs_cart['tos_link_text'].'</u></a>';



    		$tos = cpgTemplate::set($tos, array(
    	       	'{TOS_TEXT}' => $lang_cs_cart['tos_text'],
    	       	'{TOS_TITLE}' => $lang_cs_cart['tos_title'],
				'{TOS_LINK}' => $popup,
    		));
    	} else {
    		$tos = '';
    	}

	   	// view cart in plain format
        echo cpgTemplate::set($form_header, '');
        starttable($CONFIG['picture_table_width'], $lang_cs_cart['check_out_title'], 7);
        echo HTMLelement::prev_cart($cpgshop->cart, $cpgshop->profile, 'html_plain');
        endtable();
        HTMLelement::spacer();
        // end output cart and totals
        /**
        *
        * @output billing and shipping address
        */
        $user_data = cpgTool::get_user_info(USER_ID);
        $html_billing = cpgTool::verify_billingshipping_info('none', $user_data);
        $shipping_data = cpgDB::fetchRow("SELECT sid, title, surename, lastname, street, city, zip, state, phone, country FROM {$CONFIG['TABLE_CS_ADDRESS']} WHERE type='1' AND user_id ='" . USER_ID . "' LIMIT 1;");
        if (!$shipping_data) {
            $shipping_data = $user_data;
        }
        $html_shipping = cpgTool::verify_billingshipping_info('shipping', $shipping_data);

        $delivery_mode ? $elem_type = 'element': $elem_type = 'element_down';

        starttable($CONFIG['picture_table_width']);
        echo cpgTemplate::set($$elem_type, array(
                '{ADDRESS_BILLING}' => $html_billing,
                '{ADDRESS_SHIPPING}' => $html_shipping,
                '{LANG_BILLING}' => $lang_cs_cart['address_data'],
                '{LANG_SHIPPING}' => $lang_cs_cart['shipping_addr'],
                '{LANG_TEXT}' => $lang_cs_cart['additional_info'],
                '{TEXTFIELD}' => HTMLElement::text_area('additional_info', '', 50, 5),
        		'{TOS}' => $tos,
        ));
        endtable();
        // output footer - submit button
        starttable($CONFIG['picture_table_width']);
        echo cpgTemplate::set($form_footer, array(
                '{SITE_URL}' => $CONFIG['ecards_more_pic_target'],
                '{LANG_SUBMIT}' => $lang_cs_cart['step4'],
                '{LANG_GO_BACK}' => $lang_cs_cart['go_back'],
                '{GO_BACK_TARGET}' => $go_back_target,
                ));
        endtable();
        return;
    }
    // -----------------------------------------------------------------------------------------
    // THANK YOU
    // -----------------------------------------------------------------------------------------
    public static function thank_you()
    {
        global $CONFIG, $LINEBREAK;
        global $lang_cs_cart, $lang_cs_error, $lang_cs_profile, $lang_date;
        global $cpgshop, $cpg_udb;
        global $currency_symbol;
        // all the usual standard checks
        if (!is_object($cpgshop)) $cpgshop = new cpgShop();

		//check tos
    	if($CONFIG['cpgshop_tos']){
	     	$back_button = "<input onclick=\"window.location.href='index.php?file=cpgshop/cpgshop_cart&page=check_out';\" class=\"button button_normalfont\" type=\"button\" value=\"{$lang_cs_cart['go_back']}\">";
	    	if (!cpgTool::post_var('tos'))
	    		cpg_die(ERROR, $lang_cs_cart['die_tos'] . $back_button, __FILE__, __LINE__);
    		else {
    			$tos = 1; //true
    		}
		}

        // check no item and logged in
        cpgTool::check_enabled();
        cpgTool::check_cart($cpgshop);
        cpgTool::check_user();
    	cpgTool::check_min_order($cpgshop);
    	// is an element in the card that needs shipping... or are all elements for download
        if (cpgTool::cart_is_ship($cpgshop->cart))
            $delivery_mode = true;
        else
            $delivery_mode = false;
    	//if it's a free download, we do not need the gateway check
    	if (cpgTool::check_free_download($cpgshop)) {
    		$free_download = true;
    	} else {
    		$free_download = false;
    	}


        // error message head
        // verify the addresses in the db - missing entries, valid shipping country
        $verify_array = cpgTool::verify_address($delivery_mode);
        if (isset($verify_array)) {
            $message = "{$lang_cs_cart['adr_error']}\n<br><ul>";
            foreach($verify_array as $error) {
                $message .= "<li>{$lang_cs_cart[$error]}";
            }
            $message .= "</ul><br>\n<input onclick=\"window.location.href='index.php?file=cpgshop/cpgshop_cart&page=verify_address';\" class=\"button button_normalfont\" type=\"button\" value=\"{$lang_cs_cart['go_back']}\"\>";

            cpg_die(ERROR, $message, __FILE__, __LINE__);
        }
        // step2 of address verification: compare cookie <-> db
        $user_data = cpgTool::get_user_info(USER_ID);
        $shipping_data = cpgDB::fetchRow("SELECT sid, surename, lastname, street, city, zip, state, country FROM {$CONFIG['TABLE_CS_ADDRESS']} WHERE type='1' AND user_id ='" . USER_ID . "' LIMIT 1;");
        if (!$shipping_data) {
            $shipping_data = $user_data;
        }

        foreach ($user_data as $key => $value) {
            if ($value != $cpgshop->profile['billing_address']["$key"]) {
                $warning = true;
            }
            if ($delivery_mode) { // if we don't ship we don't check the address
                foreach ($shipping_data as $key => $value) {
                    if ($value != $cpgshop->profile['shipping_address']["$key"]) {
                        $warning = true;
                    }
                }
            }
            if ($warning) {
                $message = "{$lang_cs_cart['adr_error']}\n<br><ul>";
                $message .= "<li>{$lang_cs_cart['err_data_inconsist']}";
                $message .= "</ul><br>\n<input onclick=\"window.location.href='index.php?file=cpgshop/cpgshop_cart&page=verify_address';\" class=\"button button_normalfont\" type=\"button\" value=\"{$lang_cs_cart['go_back']}\"\>";
                cpg_die(ERROR, $message, __FILE__, __LINE__);
            }
        }
        // step3 gateway and delivery plausibility
        if ($delivery_mode) {
            // first get the weight addition fee cart versus database
            if ($weight_shipping = cpgTool::is_max_weight_fee($cpgshop->cart)) {
                // then compare that value from the price table with what we've saved in the cookie
                if ($cpgshop->profile['weight']['fee'] != $weight_shipping) {
                    $message = "{$lang_cs_cart['modif_error']}\n<br><ul>";
                    $message .= "<li>{$lang_cs_cart['err_data_modified']}";
                    $message .= "</ul><br>\n<input onclick=\"window.location.href='index.php?file=cpgshop/cpgshop_cart&page=view_cart';\" class=\"button button_normalfont\" type=\"button\" value=\"{$lang_cs_cart['go_back']}\"\>";
                    cpg_die(ERROR, $message, __FILE__, __LINE__);
                }
            }
        }
		// 2 gateway fee
    	if(!$free_download) {
	        $value = $cpgshop->profile['gateway']['method'];
	        $key = 'cpgshop_' . $value . '_enable';
	        $key_fee_enable = 'cpgshop_' . $value . '_fee_enable';
	        $key_fee = 'cpgshop_' . $value . '_fee';
	        $key_override = 'cpgshop_' . $value . '_override';
	        // no selected gateway in cookie || gateway not enabled in config || gateway fee different in cookie nad config
	        if (!isset ($cpgshop->profile['gateway']['fee'])) $cpgshop->profile['gateway']['fee'] = '0.0';
			//if fee isn't enabled, we set it to 0 to be able to check consist. - if in admin here is a value, then this value would be considered
			if (!$CONFIG[$key_fee_enable]) $CONFIG["$key_fee"] = 0.0;;


			if (!$value || ($CONFIG["$key_fee"] != $cpgshop->profile['gateway']['fee'])) {
	            // we use the same warning message than above ($delivery mode)
	            $message = "{$lang_cs_cart['modif_error']}\n<br><ul>";
	            $message .= "<li>{$lang_cs_cart['err_data_modified']}";
	            $message .= "</ul><br>\n<input onclick=\"window.location.href='index.php?file=cpgshop/cpgshop_cart&page=view_cart';\" class=\"button button_normalfont\" type=\"button\" value=\"{$lang_cs_cart['go_back']}\"\>";
	            cpg_die(ERROR, $message.$CONFIG["$key_fee"]." - ".$cpgshop->profile['gateway']['fee'], __FILE__, __LINE__);
	        }
    	}
        // 3 delivery fee and method
        $value = $cpgshop->profile['delivery']['method'];
        $key_del = 'cpgshop_' . $value . '_enable';
        $key_fee_enable_del = 'cpgshop_' . $value . '_fee_enable';
        $key_fee_del = 'cpgshop_' . $value . '_fee';
        $warning = false;
        // do we have an item that needs shipping?
        if ($delivery_mode) {
            // is override enabled for the gateway
            // if override and the cooky delivery method isn't standard || cookie delivery fee != Config delivery fee
            if (!isset ($cpgshop->profile['delivery']['fee'])) $cpgshop->profile['delivery']['fee'] = '0';
            if ($CONFIG["$key_override"]) {
                if ($value != 'standard' || $CONFIG["$key_fee_del"] != $cpgshop->profile['delivery']['fee']) {
                    $warning = true;
                }
                // shipping method not enabled || Config fee != cookie fee
            } elseif (!$CONFIG["$key_fee_enable_del"] || $CONFIG["$key_fee_del"] != $cpgshop->profile['delivery']['fee']) {
                // $warning = true;
            }
        }

        if ($warning) {
            // we use the same warning message than above ($delivery mode)
            $message = "{$lang_cs_cart['modif_error']}\n<br><ul>";
            $message .= "<li>{$lang_cs_cart['err_data_modified']}";
            $message .= "</ul><br>\n<input onclick=\"window.location.href='index.php?file=cpgshop/cpgshop_cart&page=view_cart';\" class=\"button button_normalfont\" type=\"button\" value=\"{$lang_cs_cart['go_back']}\"\>";
            cpg_die(ERROR, $message, __FILE__, __LINE__);
        }
        // 4. discount... we just check the discount code... value and item discount get calculated before adding the values to the db
        $granted_discount = cpgTool::calculate_discount($cpgshop->cart, $cpgshop->profile);
        $cookie['discount'] = $cpgshop->profile['discount'];
        $cookie['discount']['value'] = $granted_discount['value'];
        $cookie['discount']['currency'] = $CONFIG['cpgshop_currency'];
        $cookie['discount']['cpgshop_discount_enable'] = $CONFIG['cpgshop_discount_enable'];
        $cookie['discount']['cpgshop_discount_min_basket'] = $CONFIG['cpgshop_discount_min_basket'];
        $cookie['discount']['cpgshop_discount_value'] = $CONFIG['cpgshop_discount_value'];
        $cookie['discount']['cpgshop_discount_trigger'] = $CONFIG['cpgshop_discount_trigger'];
        $cookie['discount']['set'] = 1;
        // updating the cookie so that we can save $cpgshop->profile into the db
        $cpgshop->edit_profile($cookie);
        // 5. additional info entered by the user in checkout form - encode it
        $additional_info = cpgTool::encode_data(cpgTool::post_var('additional_info'));
        // check if pure download, shipping or both
        $shipping = 0;
        $download = 0;
        foreach($cpgshop->cart as $pid) {
            $type = cpgTool::shipping_item($pid['price']);
            if (($type ^ 0)) {
                $download = 1;
            }
            if (($type ^ 1)) {
                $shipping = 1;
            }
        }

        /* we have
		1. discount
		   $granted_discount['value']
			$granted_discount['currency']
		2. $delivery_mode
		   true - false
		3. delivery method, fee
		   $cpgshop->profile['delivery']['method']
		   $CONFIG["$key_fee_del"]
		4. gateway method, fee
		   $cpgshop->profile['gateway']['method']
		   $CONFIG["$key_fee"]
		5. weight addition fee
		   $weight_shipping
		6. billing address
		   $user_data
		7. shipping address
		   $shipping_data
		8. additional info by the user
		*/

        $gross = $CONFIG["$key_fee_del"] + $CONFIG["$key_fee"] + $weight_shipping - $granted_discount['value'] + cpgTool::price_all($cpgshop->cart);
        $item_count = count($cpgshop->cart);
        $time = localised_timestamp();
        // insert the order into the orders table
        $result = cpgDB::runQuery("INSERT INTO `{$CONFIG['TABLE_CS_ORDER']}`
		    			(`oid`, `user_id`, `user_name`, `gross`, `item_count`, `cart`, `profile`, `time`, `status`, `txnid`, `payment`, `delivery`, `tax`, `log`, `note`, `tos`, `cdown`, `cship`, `paid`, `sent`, `new`, `archive`)
		    			VALUES
		    			('','" . USER_ID . "', '" . USER_NAME . "', '" . (float)$gross . "', '" . (int)$item_count . "', '" . serialize($cpgshop->cart) . "','" . serialize($cpgshop->profile) . "','" . $time . "', 'ordered', '', '" . $cpgshop->profile['gateway']['method'] . "', '" . $cpgshop->profile['delivery']['method'] . "', '" . (float)$CONFIG['cpgshop_tax_fee'] . "', '', '$additional_info', '" . $tos . "', '" . $download . "', '" . $shipping . "', '', '', '1', '1');");
        // order id
        $oid = cpg_db_insert_id();
        // we generate a hash from oid, user_id, time to later be able verify valid downloads
        $hash = md5($oid . USER_ID . $time);
        $result2 = cpgDB::runQuery("UPDATE {$CONFIG['TABLE_CS_ORDER']} SET hash = '" . $hash . "' WHERE oid = '" . $oid . "';");
        // if we have a discount code... mark the code in the discount table used
        // doing that after the emailing... !!!
        if ($CONFIG['cpgshop_discount_enable'] == 3) {
            $result2 = cpgDB::runQuery("UPDATE {$CONFIG['TABLE_CS_DISCOUNT']} SET valid = '0', user_id = '" . USER_ID . "', order_id = '" . $oid . "' WHERE number='" . $cpgshop->profile['discount']['code'] . "';");
        }

        if ($result) {
            // grab the thank you text
            $thank_text = cpgDB::runQuery("SELECT name, text FROM `{$CONFIG['TABLE_CS_DOCS']}` WHERE name LIKE 'checkout_thankyou_%';");
            while (($row = cpg_db_fetch_assoc($thank_text))) {
                $THANK[$row['name']] = $row['text'];
            }
            cpg_db_free_result($result);

            $gateway_extra_text = $THANK['checkout_thankyou_' . $cpgshop->profile['gateway']['method']];
            // atm we just need that to populate the paypal button
            switch ($cpgshop->profile['gateway']['method']) {
                case ('paypal'):
                    $billing_extra_info = "{$LINEBREAK}<div align=\"center\">" . HTMLElement::paypal_button($oid) . "</div>";
                    break;
                case ('wire'):
                    $billing_info_array = array($lang_cs_cart['wire_routing'] . ':' => html_entity_decode($CONFIG['cpgshop_wire_routing']),
                        $lang_cs_cart['wire_account'] . ':' => html_entity_decode($CONFIG['cpgshop_wire_account']),
                        $lang_cs_cart['wire_bank'] . ':' => html_entity_decode($CONFIG['cpgshop_wire_bank']),
                        $lang_cs_cart['wire_bank_address'] . ':' => html_entity_decode($CONFIG['cpgshop_wire_bank_address']),
                        $lang_cs_cart['wire_swift'] . ':' => html_entity_decode($CONFIG['cpgshop_wire_swift']),
                        );
                    $gateway_extra_text .= "</td></tr><tr><td><table width=\"80%\"align=\"center\">";
                    foreach($billing_info_array as $key => $data) {
                        if ($key)
                            $gateway_extra_text .= "<tr><td width=\"50%\" align=\"right\"><strong>{$key}</strong></td><td width=\"50%\">{$data}</td></tr>\n";
                    }

                    $gateway_extra_text .= "</table></td></tr><tr><td class=\"thank_you\">";

                    break;
                case ('cod'):
                    break;
                default: ;
            		//free download
            		$billing_extra_info = "{$LINEBREAK}<div align=\"center\">" . $lang_cs_cart['free_download'] . "</div>";
            } // switch
            // output thank you msg
            $output = cpgTemplate::set(html_entity_decode($THANK['checkout_thankyou_page']), array(
                    '{SITENAME}' => $CONFIG['gallery_name'],
                    '{GATEWAY_INFO}' => $gateway_extra_text,
                    ));
            $output .= $billing_extra_info;
            // send the order confirmation emails to admin and user
            $confirm_mail = cpgTool::cpgshop_order_confirmation_mail(USER_ID, $oid, $cpgshop->cart, $cpgshop->profile);
        	//delete the cart from db
        	cpgDB::runQuery ("DELETE FROM {$CONFIG['TABLE_CS_CART']} WHERE cid='".$cpgshop->cart_id."'");
            // unset the cookie
            $cpgshop->flush();
        } else {
            cpg_die(ERROR, $lang_cs_cart['die_delivery'] . $back_button, __FILE__, __LINE__);
        }


    	if($free_download) {
    		//if it's a free download create the download dir and send emails
    		cpgDB::runQuery ("UPDATE {$CONFIG['TABLE_CS_ORDER']} SET paid='1' WHERE oid ='" . $oid . "' LIMIT 1;");
    		// state change email to user - paid
    		cpgTool::email_state_change(USER_ID, $oid, 'state_change_paid');

			if (cpgTool::ipn_download_dir(USER_ID, $oid, true)) {
        			if ($CONFIG['cpgshop_states_auto_move']) {
     				// send state changed email
    				cpgTool::email_state_change(USER_ID, $oid, 'state_change_downloaded');
    				// check if not shipping but just to download... in that case we can move to sent
    					$result = cpgDB::runQuery(("UPDATE {$CONFIG['TABLE_CS_ORDER']} SET archive = '4' WHERE oid ='" . $oid . "'"));

    			}
    		}
    	}

        // finally output the tahnk you text
        starttable('', $lang_cs_cart['thank_you_title']);
        echo HTMLelement::apply_simple_text(HTMLelement::simple_text(1, 'thank_you'), $output);
        endtable();
        return;
    }
    // -----------------------------------------------------------------------------------------
    // PAYPAL IPN
    // -----------------------------------------------------------------------------------------
    public static function ipn()
    {
        global $CONFIG;
        global $currency_symbol;
        global $lang_cpgshop_ipn, $lang_date;

        require_once('plugins' . DS . 'cpgshop' . DS . 'libs' . DS . 'cpgPayPal.class.php');
        require_once('include' . DS . 'mailer.inc.php');

        $p = new cpgshop_paypal_class;
        if ($p->cpgshop_validate_ipn()) { // VERIFIED
            // user has paid and transaction has been verified
            // create the admin email body
            $date = cpgDB::fetchRow("SELECT time FROM `{$CONFIG['TABLE_CS_ORDER']}` WHERE oid='" . (int)(trim($p->ipn_data['invoice'])) . "';");
            $template = cpgDB::fetchRow("SELECT text FROM `{$CONFIG['TABLE_CS_DOCS']}` WHERE name='ipn_admin_mail_txt';");
            $template_vars = array(
                '{PAYER_EMAIL}' => $p->ipn_data['payer_email'],
                '{DATE}' => $date = localised_date($date['time'], $lang_date['log']),
                );
            $body = nl2br(strtr($template['text'], $template_vars));

            foreach ($p->ipn_data as $key => $value) {
                $body .= $key . ':' . " \t$value\n";
                $$key = $value;
            }
            // just to make it easy
            $invoice = (int)(trim($invoice));
            // log and paid status
            // auto move to box paid
            $box = ($CONFIG['cpgshop_states_auto_move']) ? 2 : 1;
            $results = cpgDB::runQuery ("INSERT INTO {$CONFIG['TABLE_CS_PAYPAL_LOG']} ( `invoice`, `pp_fee`, `pp_currency`, `log` ) VALUES ( '$invoice', '" . $p->ipn_data['mc_fee'] . "', '" . $p->ipn_data['mc_currency'] . "', '" . cpgTool::encode_data($p->ipn_data) . "' );");
            $results = cpgDB::runQuery(("UPDATE {$CONFIG['TABLE_CS_ORDER']} SET txnid = '" . $p->ipn_data['txn_id'] . "', status='" . $p->ipn_data['payment_status'] . "', archive='" . $box . "' WHERE oid ='" . $invoice . "';"));

            switch ($p->ipn_data['payment_status']) {
                case 'Completed':
                    // error messages from function photo_shop_ipn_download()
                    $error = &$ERROR;
                    // just grabbing gross price from the shop table in order to compare with the gross from paypal
                    $result = cpgDB::fetchRow("SELECT gross, user_id, cdown, cship FROM {$CONFIG['TABLE_CS_ORDER']} WHERE oid='" . $invoice . "' LIMIT 1;");
                    $gross = $result['gross'];
                    $uid = $result['user_id'];
                    // check if invoice AND gross AND seller_email AND currency match, else spoofed data
                    // if ((strtolower(trim($p->ipn_data['business'])) == trim($CONFIG['photo_shop_paypal_email'])) && (trim($p->ipn_data['mc_currency']) == trim($CONFIG['photo_shop_paypal_currency'])) && (trim($p->ipn_data['mc_gross']) == trim($gross))) {
                    if ((strtolower(trim($p->ipn_data['business'])) == trim($CONFIG['cpgshop_paypal_email'])) && (trim($p->ipn_data['mc_currency']) == trim($CONFIG['cpgshop_currency'])) && (trim($p->ipn_data['mc_gross']) == trim($gross))) {
                        cpgDB::runQuery ("UPDATE {$CONFIG['TABLE_CS_ORDER']} SET paid='1' WHERE oid ='" . $invoice . "' LIMIT 1;");
                        // state change email to user - paid
                        cpgTool::email_state_change($uid, $invoice, 'state_change_paid');
                        // if we set download instead of prints
                        if ($CONFIG['cpgshop_download_enable']) {
                            // first check if we have items to download, if yes, create down dir, send passwords etc
                            if ($result['cdown']) {
                                // create download folder, htaccess, htpasswd, resize images and copy them to download folder
                                if (cpgTool::ipn_download_dir($uid, $invoice, true)) {
                                    // success, do the auto move check and email the admin
                                    // mark the item as downloaded
                                    // cpgDB::runQuery ("UPDATE {$CONFIG['TABLE_CS_ORDER']} SET sentd='1' WHERE oid ='".$invoice."' LIMIT 1;");
                                    if ($CONFIG['cpgshop_states_auto_move']) {
                                        // query some data... we need to do that outside the if cause we need for state change emails the uid
                                        // $result = cpgDB::fetchRow("SELECT user_id, cdown, cship, sent, sentd FROM {$CONFIG['TABLE_CS_ORDER']} WHERE oid='".$invoice."';");
                                        // send state changed email
                                        cpgTool::email_state_change($uid, $invoice, 'state_change_downloaded');
                                        // check if not shipping but just to download... in that case we can move to sent
                                        if (!$result['cship'] && $result['cdown']) {
                                            $result2 = cpgDB::runQuery(("UPDATE {$CONFIG['TABLE_CS_ORDER']} SET archive = '4' WHERE oid ='" . $invoice . "'"));
                                        }
                                    }

                                    cpgTool::cpgshop_mail('admin', $lang_cpgshop_ipn['ipn_email_admin_ipn_download_success'] . " [$date]", nl2br(make_clickable($error . $body)), 'text/plain', $CONFIG['gallery_name'], $CONFIG['cpgshop_notify_email'], $body);
                                } else {
                                    cpgTool::cpgshop_mail('admin', $lang_cpgshop_ipn['ipn_email_admin_ipn_download_problem'] . " [$date]", nl2br(make_clickable($error . $body)), 'text/plain', $CONFIG['gallery_name'], $CONFIG['cpgshop_notify_email'], $body);
                                }
                            }
                        } else { // email admin, order is paid... prints need to be sent
                            cpgTool::cpgshop_mail('admin', $lang_cpgshop_ipn['ipn_email_admin_ipn_success'] . " [$date]", nl2br(make_clickable($error . $body)), 'text/plain', $CONFIG['gallery_name'], $CONFIG['cpgshop_notify_email'], $body);
                        }
                    } else {
                        $body = $lang_cpgshop_ipn['ipn_email_manipulated'] . $body;
                        cpgTool::cpgshop_mail('admin', $lang_cpgshop_ipn['ipn_email_admin_ipn_failed'] . " [$date]", nl2br(make_clickable($body)), 'text/plain', $CONFIG['gallery_name'], $CONFIG['cpgshop_notify_email'], $body);
                    }
                    break;

                case 'Pending':
                    $body = $lang_cpgshop_ipn['ipn_email_pending'] . $body;
                    cpgTool::cpgshop_mail('admin', $p->ipn_data['payment_status'] . $lang_cpgshop_ipn['ipn_email_admin_ipn_failed'] . " [$date]", nl2br(make_clickable($body)), 'text/plain', $CONFIG['gallery_name'], $CONFIG['cpgshop_notify_email'], $body);
                    break;
                case 'Failed':
                    // this will only happen in case of echeck.
                    $body = $lang_cpgshop_ipn['ipn_email_failed'] . $body;
                    cpgTool::cpgshop_mail('admin', $lang_cpgshop_ipn['ipn_email_admin_ipn_failed'] . " [$date]", nl2br(make_clickable($body)), 'text/plain', $CONFIG['gallery_name'], $CONFIG['cpgshop_notify_email'], $body);
                    break;

                case 'Denied':
                    $body = $lang_cpgshop_ipn['ipn_email_denied'] . $body;
                    cpgTool::cpgshop_mail('admin', $lang_cpgshop_ipn['ipn_email_admin_ipn_failed'] . " [$date]", nl2br(make_clickable($body)), 'text/plain', $CONFIG['gallery_name'], $CONFIG['cpgshop_notify_email'], $body);
                    break;

                case 'Refunded':
                    $body = $lang_cpgshop_ipn['ipn_email_refunded'] . $body;
                    cpgTool::cpgshop_mail('admin', $lang_cpgshop_ipn['ipn_email_admin_ipn_failed'] . " [$date]", nl2br(make_clickable($body)), 'text/plain', $CONFIG['gallery_name'], $CONFIG['cpgshop_notify_email'], $body);
                    break;

                case 'Canceled':
                    // mark the payment as dispute cancelled
                    $body = $lang_cpgshop_ipn['ipn_email_canc-rev'] . $body;
                    cpgTool::cpgshop_mail('admin', $lang_cpgshop_ipn['ipn_email_admin_ipn_failed'] . " [$date]", nl2br(make_clickable($body)), 'text/plain', $CONFIG['gallery_name'], $CONFIG['cpgshop_notify_email'], $body);
                    break;

                default:
                    // order is not good
                    $body = $lang_cpgshop_ipn['ipn_email_unknown'] . $p->ipn_data['payment_status'];
                    cpgTool::cpgshop_mail('admin', $lang_cpgshop_ipn['ipn_email_admin_ipn_failed'], nl2br(make_clickable($body)), 'text/plain', $CONFIG['gallery_name'], $CONFIG['cpgshop_notify_email'], $body);
                    break;
            } // end switch
        } else { // Paypal didn't verify
            $body = $lang_cpgshop_ipn['ipn_email_invalid'] . $p->ipn_response;
            cpgTool::cpgshop_mail('admin', $lang_cpgshop_ipn['ipn_email_admin_ipn_failed'], nl2br(make_clickable($body)), 'text/plain', $CONFIG['gallery_name'], $CONFIG['cpgshop_notify_email'], $body);
        }

        return;
    }
    // -----------------------------------------------------------------------------------------
    // ORDER HISTORY
    // -----------------------------------------------------------------------------------------
    public static function history()
    {
        global $CONFIG;
        global $currency_symbol;
        global $lang_cs_order, $lang_cs_common, $lang_cs_cart, $lang_cs_error, $lang_cs_profile;
        global $lang_date;
        global $cpg_udb;
        // check if the user is logged in
        cpgTool::check_user();

        $display = cpgTool::request_var('display');
        $oid = (int)cpgTool::get_var('order');
        $task = cpgTool::request_var('task');
        // pagination
        if (cpgTool::request_var('start') == true) {
            $start = cpgTool::request_var('start');
        } else {
            $start = 0;
        }

        if (cpgTool::request_var('count') == true) {
            $count = cpgTool::request_var('count');
        } else {
            $count = 25;
        }
        // sorting
        $sort_codes = array(
            'oid_d' => 'oid DESC',
            'oid_a' => 'oid ASC',
            );
        $sort = (!isset($sort) || !isset($sort_codes[$sort])) ? 'oid_d' : $sort;

        $lb = "<select name=\"sort_listbox\" class=\"listbox\" onchange=\"if(this.options[this.selectedIndex].value) window.location.href='index.php?file=cpgshop/cpgshop_config&amp;page=order&amp;box=$box&amp;start=$start&amp;count=$count&amp;sort='+this.options[this.selectedIndex].value;\">\n";
        foreach($sort_codes as $key => $value) {
            $selected = ($key == $sort) ? 'selected="selected"' : "";
            $lb .= "        <option value=\"" . $key . "\" $selected>" . $lang_cs_order[$key] . "</option>\n";
        }
        $lb .= "</select>\n";

        $s1 = $count == 1 ? 'selected="selected"' : '';
        $s50 = $count == 50 ? 'selected="selected"' : '';
        $s75 = $count == 75 ? 'selected="selected"' : '';
        $s100 = $count == 100 ? 'selected="selected"' : '';
        // pagination end
        // TEMPLATE
        $tpl_order = cpgTemplate::get('blog_history');
        $order_title = cpgTemplate::extract($tpl_order, 'order_title');
        $order_element = cpgTemplate::extract($tpl_order, 'order_element');
        $order_footer = cpgTemplate::extract($tpl_order, 'order_footer');
        $order_legend = cpgTemplate::extract($tpl_order, 'order_legend');

        switch ($task) {
            case "resend_pwd":
                if (cpgTool::ipn_send_password(USER_ID, $oid)) {
                    HTMLelement::message($lang_cs_common['message'], sprintf($lang_cs_order['resend_pwd_succ'], $oid));
                    HTMLelement::spacer();
                }
                break;
            case "cancel_order":
            	if ($CONFIG['cpgshop_customer_cancel']) {
	            	$result = cpgDB::fetchRow("SELECT paid, sent, sentd, printed FROM {$CONFIG['TABLE_CS_ORDER']} WHERE oid='" . $oid . "' AND user_id='" . USER_ID . "' AND archive < '5';");

					if(!$result['paid'] && !$result['sent'] && !$result['sentd'] && !$result['printed']){
		            	$result2 = cpgDB::runQuery("UPDATE {$CONFIG['TABLE_CS_ORDER']} SET archive = '5' WHERE oid ='" . $oid . "' AND user_id='".USER_ID."';");
		            	if ($result2) {
		            		require_once('include'.DS.'mailer.inc.php');

		            		$result_text = cpgDB::runQuery("SELECT name, text FROM `{$CONFIG['TABLE_CS_DOCS']}` WHERE name LIKE 'email_cancel_order_user_%' LIMIT 3;");
		            		while ( ($row = cpg_db_fetch_assoc($result_text)) ) {
		            			$MAIL[$row['name']] = $row['text'];
		            		}
		            		cpg_db_free_result($result_text);
		            		//get user info --> from the order address table
		            		$user_info = cpgTool::get_user_info(USER_ID);
		            		//user email and user name
		            		$user_email = $cpg_udb->get_user_infos(USER_ID);
		            		//fetch order hash
		            		$template_vars = array(
		            			'{TITLE}' => $lang_cs_profile["{$user_info['title']}"], //$user_info['title'],
		            			'{USER_NAME}' => $user_email['user_name'],
		            			'{NAME}' => $user_info['surename']. ' ' . $user_info['lastname'],
		            			'{SITENAME}' => $CONFIG['gallery_name'],
		            			'{OID}' => $oid,
		            		);
		            		$html_mail=cpgTemplate::set(html_entity_decode($MAIL['email_cancel_order_user_html']), $template_vars);
		            		$txt_mail=cpgTemplate::set(html_entity_decode($MAIL['email_cancel_order_user_txt']), $template_vars);

		            		if(cpgTool::cpgshop_mail($user_email['user_email'], $MAIL['email_cancel_order_user_subj'], $html_mail, 'text/html','','',$txt_mail )){
								HTMLelement::message($lang_cs_common['message'], sprintf($lang_cs_order['cancel_order_succ'], $oid));
			            		HTMLelement::spacer();
		            		}
		            	}
	            	}
				}
            	break;
            case "resend_invoice":
                $result = cpgDB::fetchRow("SELECT profile, cart FROM {$CONFIG['TABLE_CS_ORDER']} WHERE oid='" . $oid . "' AND user_id='" . USER_ID . "' LIMIT 1;");

                $profile_data = unserialize($result['profile']);
                $cart_data = unserialize($result['cart']);

                if (cpgTool::cpgshop_order_confirmation_mail(USER_ID, $oid, $cart_data, $profile_data, false)) {
                    HTMLelement::message($lang_cs_common['message'], sprintf($lang_cs_order['resend_invoice_succ'], $oid));
                    HTMLelement::spacer();
                }
                unset($result);
                break;
            default:
                break;
        } //end switch
        // to display the single order
        if ($display == 'view_act') {
            // grab profile array from the db
            $result = cpgDB::fetchRow("SELECT profile, cart, note, time, dtime, cdown, cship, paid, sent, sentd, printed, new, archive, status, dpwd, hash FROM {$CONFIG['TABLE_CS_ORDER']} WHERE oid='" . $oid . "' AND user_id='" . USER_ID . "' AND archive < '5';");

            $profile_data = unserialize($result['profile']);
            $cart_data = unserialize($result['cart']);
            $user_info = $cpg_udb->get_user_infos(USER_ID);

            $additional_info = (cpgTool::decode_data($result['note']));
            if ($cart_data) {
                $order_address = cpgTemplate::extract($tpl_order, 'order_address');
                $billing_address = cpgTool::verify_billingshipping_info('', $profile_data['billing_address']);
                $order_back = cpgTemplate::extract($tpl_order, 'back_button');
                $order_action = cpgTemplate::extract($tpl_order, 'action_buttons');

                if ($profile_data['delivery']['method'] == 'download') {
                    $shipping_address = $billing_address;
                } else {
                    $shipping_address = cpgTool::verify_billingshipping_info('', $profile_data['shipping_address']);
                }
                // check if pure download, shipping or both
                $shipping = $result['cship'];
                $download = $result['cdown'];;

                if ($download && $shipping) $spacer = " :: ";
                // create icons and set/ unset buttons
                $button_link = "index.php?file=cpgshop/cpgshop_cart&amp;page=history&amp;sort=" . $sort . '&amp;start=' . $start . '&amp;order=' . $oid . '&amp;count=' . $count ;
                $view_act = "&amp;display=view_act";

                $icon_booked = " {$lang_cs_order['b']}<img src=\"plugins/cpgshop/images/s_" . ($result['paid'] ? 'pos' : 'neg') . ".gif\" alt=\"\" border=\"0\" /><br />";
                if ($shipping) {
                    $icon_sent = " {$lang_cs_order['s']}<img src=\"plugins/cpgshop/images/s_" . ($result['sent'] ? 'pos' : 'neg') . ".gif\" alt=\"\" border=\"0\" /><br />";
                } else $icon_sent = '';
                if ($download) {
                    $icon_down = " {$lang_cs_order['d']}<img src=\"plugins/cpgshop/images/s_" . ($result['sentd'] ? 'pos' : 'neg') . ".gif\" alt=\"\" border=\"0\" /><br />";
                } else $icon_down = '';
                if ($CONFIG['cpgshop_extra_states'] && $shipping) {
                    $icon_print = " {$lang_cs_order['p']}<img src=\"plugins/cpgshop/images/s_" . ($result['printed'] ? 'pos' : 'neg') . ".gif\" alt=\"\" border=\"0\" /><br />";
                } else $icon_print = '';
                // paypal status
                $paypal_status = '';
                if ($profile_data['gateway']['method'] == 'paypal' && $CONFIG['cpgshop_paypal_use_ipn']) {
                    $paypal_status = "<strong>{$lang_cs_order['paypal_status']}:</strong> {$result['status']}<br>";
                }
                // create the action buttons for the detailed view
                $resend_invoice = "<input onclick=\"window.location.href='{$button_link}&amp;task=resend_invoice&amp;display=view_act'\" class=\"button largefont\" type=\"button\" value=\"{$lang_cs_order['resend_invoice']}\">";

				if($CONFIG['cpgshop_customer_cancel'] && !$result['paid'] && !$result['sent'] && !$result['sentd'] && !$result['printed'] && $result['archive'] != 5){
					$cancel_button = "<input onclick=\"window.location.href='{$button_link}&amp;task=cancel_order&amp;display=view_act&amp;order={$oid}'\" class=\"button largefont\" type=\"button\" value=\"{$lang_cs_order['cancel_order']}\">";
            	}
				if ($CONFIG['cpgshop_download_enable'] == '1') {
                    if ($download) {
                        if ($result['dpwd']) {
                            $resend_pwd_button = "<input onclick=\"window.location.href='{$button_link}&amp;task=resend_pwd&amp;display=view_act'\" class=\"button largefont\" type=\"button\" value=\"{$lang_cs_order['resend_pwd']}\">";
                        }
                        if ($result['paid']) {
                            $download_items = "<input onclick=\"window.location.href='index.php?file=cpgshop/cpgshop_cart&amp;page=process&amp;order=" . $oid . "&amp;hash=" . $result['hash'] . "' \" class=\"button largefont\" type=\"button\" value=\"{$lang_cs_order['download_order']}\">";;
                        }
                    }
                }
                // download time (dir created)
                if ($result['dtime'] != 0) {
                    $dtime = localised_date($result['dtime'], $lang_date['log']);
                    $lang_dtime = $lang_cs_order['download_time'];
                } else {
                    $dtime = '';
                    $lang_dtime = '';
                }

                if (!$result['paid']) {
                    switch ($profile_data['gateway']['method']) {
                        case ('paypal'):
                            $gateway_extra_text = "{$LINEBREAK}<div align=\"center\">" . HTMLElement::paypal_button($oid) . "</div>";
                            break;
                        case ('wire'):
                            $billing_info_array = array($lang_cs_cart['wire_routing'] . ':' => html_entity_decode($CONFIG['cpgshop_wire_routing']),
                                $lang_cs_cart['wire_account'] . ':' => html_entity_decode($CONFIG['cpgshop_wire_account']),
                                $lang_cs_cart['wire_bank'] . ':' => html_entity_decode($CONFIG['cpgshop_wire_bank']),
                                $lang_cs_cart['wire_bank_address'] . ':' => html_entity_decode($CONFIG['cpgshop_wire_bank_address']),
                                $lang_cs_cart['wire_swift'] . ':' => html_entity_decode($CONFIG['cpgshop_wire_swift']),
                                );
                            $gateway_extra_text .= "<table width=\"100%\"align=\"center\">";
                            foreach($billing_info_array as $key => $data) {
                                if ($key)
                                    $gateway_extra_text .= "<tr><td width=\"50%\" align=\"right\"><strong>{$key}</strong></td><td width=\"50%\">{$data}</td></tr>\n";
                            }
                            $gateway_extra_text .= "</table>";

                            break;
                        case ('cod'):
                            break;
                        default: ;
                    } // switch
                } else {
                    // display order paid
                    $gateway_extra_text = $lang_cs_cart['order_paid'];
                }
                // start with the output of the back button
                starttable($CONFIG['picture_table_width'], $lang_cs_order['order_detail'] . ': ' . sprintf($lang_cs_order['orderid'], $oid, $date)); // .$lang_cs_order['orderid'] . ' ' . $oid . ' - ' . $date);
                echo cpgTemplate::set($order_back, array(
                        '{BACK}' => "<input onclick=\"window.location.href='{$button_link}'\" class=\"button largefont\" type=\"button\" value=\"{$lang_cs_order['back']}\">",
                        ));
                endtable();
                // output address lists and info
                starttable();
                echo cpgTemplate::set($order_address, array(
                        '{ICON_B}' => $icon_booked,
                        '{ICON_P}' => $icon_print,
                        '{ICON_S}' => $icon_sent,
                        '{ICON_D}' => $icon_down,
                        '{LEGEND}' => $lang_cs_order['legend'],
                        '{DELIVERY_METHOD}' => ($profile_data['delivery']['method'] == 'download') ? $lang_cs_order['download'] : $lang_cs_cart['cpgshop_' . $profile_data['delivery']['method'] . '_enable'],
                        '{GATEWAY_METHOD}' => $lang_cs_cart['cpgshop_' . $profile_data['gateway']['method'] . '_enable'],
                        '{LANG_DELIVERY_METHOD}' => $lang_cs_order['delivery_method'],
                        '{LANG_GATEWAY_METHOD}' => $lang_cs_order['gateway_method'],
                        '{LANG_TYPE_SHIPPING}' => $lang_cs_order['cart_type'],
                        '{LANG_DOWNLOADED}' => $lang_dtime,
                        '{DATE}' => $dtime,
                        '{TYPE_SHIPPING}' => $download ? $lang_cs_order['download_items'] : '',
                        '{TYPE_DOWNLOAD}' => $shipping ? $spacer . $lang_cs_order['shipping_items'] : '',
                        '{PAYPAL_STATUS}' => $paypal_status,
                        '{ADDRESS_BILLING}' => $billing_address,
                        '{ADDRESS_SHIPPING}' => $shipping_address,
                        '{LANG_BILLING}' => $lang_cs_order['address_data'],
                        '{LANG_SHIPPING}' => $lang_cs_order['shipping_addr'],
                        '{LANG_INFO}' => $lang_cs_order['information'],
                        '{PAYMENT_INFO}' => $gateway_extra_text,
                        '{LANG_PAYMENT_INFO}' => $lang_cs_cart['payment_info'],
                        ));
                endtable();
                // action button table
                starttable();
                echo cpgTemplate::set($order_action, array(
                        '{BUTTON_LIST}' => $download_items . $resend_pwd_button . $resend_invoice . $cancel_button,
                        ));
                endtable();

                starttable();
                // echo cpgTool::verify_billingshipping_info('',$profile_data['gateway']);
                echo HTMLelement::prev_cart($cart_data, $profile_data, 'html_plain');
                HTMLelement::spacer();
                endtable();

                starttable();
                echo cpgTemplate::set($order_back, array(
                        '{BACK}' => "<input onclick=\"window.location.href='{$button_link}'\" class=\"button largefont\" type=\"button\" value=\"{$lang_cs_order['back']}\">",
                        ));
                endtable();
                return;
            }
        }
        // main
        starttable($CONFIG['picture_table_width'], $lang_cs_order['order_title'], 2);
        // starttable($CONFIG['picture_table_width'], $lang_cs_order['order_title'] . ' :: ' . "<a href=\"index.php?file=cpgshop/cpgshop_config&page=order&box=".($box ^ 1) ."\">{$lang_cs_order[$box]}</a>", 4);
        echo cpgTemplate::set($order_title, array(
                '{LANG_STATUS}' => $lang_cs_order['order_status'],
                '{LANG_ORDER}' => $lang_cs_order['order_detail'],
                '{LANG_USER}' => $lang_cs_order['username'],
                ));
        $order_array = cpgDB::fetchRowset("SELECT oid, user_name, cart, gross, item_count, time, status, txnid, payment, delivery, tax, note, cdown, cship, paid, sent, sentd, printed, new, archive FROM `{$CONFIG['TABLE_CS_ORDER']}` WHERE user_id = '" . USER_ID . "' AND archive < '5' ORDER BY " . $sort_codes[$sort] . " LIMIT $start, $count;");
        // getting the pic count for pagination
        $sql = "SELECT COUNT(*) FROM {$CONFIG['TABLE_CS_ORDER']} WHERE user_id = '" . USER_ID . "' AND archive < '5';";
        $result = cpgDB::runQuery($sql);

        list($order_count) = cpg_db_fetch_row($result, true);

        $order_count_text = sprintf($lang_cs_common['n_pic'], $order_count);
        // pagination
        $next_target = "index.php?file=cpgshop/cpgshop_cart&amp;page=history&amp;sort=" . $sort . '&amp;start=' . ($start + $count) . '&amp;count=' . $count ;
        $prev_target = "index.php?file=cpgshop/cpgshop_cart&amp;page=history&amp;sort=" . $sort . '&amp;start=' . max(0, $start - $count) . '&amp;count=' . $count ;

        if ($start + $count < $order_count) {
            $next_link = "<a href=\"$next_target\"><strong>{$lang_cs_common['see_next']}</strong></a>&nbsp;&nbsp;-&nbsp;&nbsp;";
        } else {
            $next_link = '';
        }

        if ($start > 0) {
            $prev_link = "<a href=\"$prev_target\"><strong>{$lang_cs_common['see_prev']}</strong></a>&nbsp;&nbsp;-&nbsp;&nbsp;";
        } else {
            $prev_link = '';
        }
        $sel = <<<EOT
            <strong>$order_count_text</strong>&nbsp;&nbsp;-&nbsp;&nbsp;
            $prev_link
            $next_link
            <strong>{$lang_cs_common['n_of_pic_to_disp']}</strong>
	        <select onchange="if(this.options[this.selectedIndex].value) window.location.href='index.php?file=cpgshop/cpgshop_config&amp;page=order&amp;sort=$sort&amp;box=$box&amp;start=$start&amp;count='+this.options[this.selectedIndex].value;"  name="count" class="listbox">
	               <option value="25">25</option>
	               <option value="1" $s1>1</option>
	               <option value="50" $s50>50</option>
	               <option value="75" $s75>75</option>
	               <option value="100" $s100>100</option>
	       	</select>
EOT;
        // end pagination
        // to download and / or shipping -> display info -> and icons sent / unsent -  downloaded or not
        foreach ($order_array as $order) {
            // check if pure download, shipping or both in the cart of the actual order
            $shipping = $order['cship'];
            $download = $order['cdown'];
            // create icons
            $icon_paid = "{$lang_cs_order['b']}<img src=\"plugins/cpgshop/images/s_" . ($order['paid'] ? 'pos' : 'neg') . ".gif\" alt=\"\" border=\"0\" /><br />";
            if ($shipping)
                $icon_sent = "{$lang_cs_order['s']}<img src=\"plugins/cpgshop/images/s_" . ($order['sent'] ? 'pos' : 'neg') . ".gif\" alt=\"\" border=\"0\" /><br />";
            else $icon_sent = '';
            if ($download)
                $icon_down = "{$lang_cs_order['d']}<img src=\"plugins/cpgshop/images/s_" . ($order['sentd'] ? 'pos' : 'neg') . ".gif\" alt=\"\" border=\"0\" /><br />";
            else $icon_down = '';
            if ($CONFIG['cpgshop_extra_states'] && $shipping)
                $icon_print = " {$lang_cs_order['p']}<img src=\"plugins/cpgshop/images/s_" . ($order['printed'] ? 'pos' : 'neg') . ".gif\" alt=\"\" border=\"0\" /><br />";
            else $icon_print = '';
            // output everything
            echo cpgTemplate::set($order_element, array(
                    '{ICON_B}' => $icon_paid,
                    '{ICON_S}' => $icon_sent,
                    '{ICON_P}' => $icon_print,
                    '{ICON_D}' => $icon_down,
                    '{ORDER_DATE}' => localised_date($order['time'], $lang_date['log']),
                    '{ITEM_COUNT}' => $lang_cs_order['noitems'] . ': ' . $order['item_count'],
                    '{GROSS}' => sprintf($lang_cs_order['gross'], $currency_symbol[$CONFIG['cpgshop_currency']] . ' ' . $order['gross']),
                    '{LINK}' => "index.php?file=cpgshop/cpgshop_cart&amp;page=history&amp;display=view_act&amp;order={$order['oid']}&amp;start={$start}&amp;count={$count}&amp;sort={$sort}",
                    '{OID}' => $order['oid'],
            		'{ORDER_ID}' => $lang_cs_order['orderid'] . ': ' . $order['oid'],
                    ));
        }
        if (!$order_array) echo "<tr><td colspan=\"4\" class=\"tableb_alternate\" align=\"center\"> {$lang_cs_error['nothing_display']}</td></tr>";

        endtable();
        starttable();

        $hidden = HTMLElement::hidden('start', $start);
        $hidden .= HTMLElement::hidden('count', $count);
        $hidden .= HTMLElement::hidden('sort', $sort);

        echo cpgTemplate::set($order_footer, array(
                '{SORT_BY}' => $lang_cs_order['sort_by'] . ' ' . $lb,
                '{PAGINATION}' => $sel,
                '{HIDDEN}' => $hidden,
                ));

        endtable();
        starttable();
        echo cpgTemplate::set($order_legend, array(
                '{LEGEND}' => $lang_cs_order['legend'],
                ));
        endtable();

        return;
    }
	// -----------------------------------------------------------------------------------------
	// ORDER HISTORY
	// -----------------------------------------------------------------------------------------
	public static function save_cart()
	{
		global $CONFIG;
		global $currency_symbol;
		global $lang_cs_cart, $lang_cs_error, $lang_cs_common, $lang_cs_save_cart;
		global $lang_date;
		global $cpg_udb, $cpgshop;
		// check if the user is logged in
		cpgTool::check_user();
		// view cart
		cpgTool::check_enabled();

		// get ACTION
		if (cpgTool::post_var('task') == false) {
			$task = cpgTool::get_var('task');
		} else {
			$task = cpgTool::post_var('task');
		}


		// TEMPLATE
		$tpl_save = cpgTemplate::get('blog_save_cart');
		$this_title = cpgTemplate::extract($tpl_save, 'title');
		$element = cpgTemplate::extract($tpl_save, 'element');
		$page_nav = cpgTemplate::extract($tpl_save, 'page_nav');
		$control = cpgTemplate::extract($tpl_save, 'control');
		$control_end = cpgTemplate::extract($tpl_save, 'control_end');
		$element_m = str_replace('tableb', 'tableh2', $element);
		$message = cpgTemplate::get('element_message');
		// task -> action
		switch ($task) {
			case 'del_act':
				// which one will be delete
				$superCage = Inspekt::makeSuperCage();
				$id_array = $superCage->post->getInt('id');

				$msg = array();
				foreach ($id_array as $delete_id) {
					cpgDB::runQuery("DELETE FROM `{$CONFIG['TABLE_CS_CART']}` WHERE cid = '$delete_id' LIMIT 1;");
					$msg[] = sprintf($lang_cs_cart['del_cart_draft_success'], $delete_id);
				}
				HTMLelement::message($lang_cs_common['message'], $msg);
				HTMLelement::spacer();
				break;

			case 'new_act':
				//check if there are items in cart
				cpgTool::check_cart($cpgshop);

				//check max to save
				$sql = "SELECT COUNT(*) FROM {$CONFIG['TABLE_CS_CART']} WHERE save='1' AND user_id='".USER_ID."';";
				$result = cpgDB::runQuery($sql);

				list($save_count) = cpg_db_fetch_row($result, true);
				if($save_count >= $CONFIG['cpgshop_cart_save_max']) {
					cpg_die(ERROR, $lang_cs_cart['max_to_save_reached'], __FILE__, __LINE__);
				}

				$data['cart'] = $cpgshop->cart;
				$data = cpgTool::encode_data($data);

				$result = cpgDB::runQuery("INSERT INTO `{$CONFIG['TABLE_CS_CART']}` (user_id,cart,ctime,save) VALUES ('".USER_ID."', '{$data}', '".localised_timestamp()."', '1');");

				// success message
				HTMLelement::message($lang_cs_common['message'], sprintf($lang_cs_cart['draft_create_success'], $title));
				HTMLelement::spacer();
				break;

			case 'load_act':
				$superCage = Inspekt::makeSuperCage();
				$id = $superCage->get->getInt('id');

				if ($id > 0) {
					$sql = "SELECT cart FROM `{$CONFIG['TABLE_CS_CART']}` WHERE cid='{$id}' AND save=1 AND user_id=".USER_ID." LIMIT 1;";

					if($cart_data_restore = cpgDB::fetchRow("SELECT cart FROM `{$CONFIG['TABLE_CS_CART']}` WHERE cid='{$id}' AND save=1 AND user_id=".USER_ID." LIMIT 1;")){
						$cookie_data = array();
						$result = cpgDB::runQuery("INSERT INTO `{$CONFIG['TABLE_CS_CART']}` (cart,ctime) VALUES ('".$cart_data_restore['cart']."','".localised_timestamp()."');");
						$cookie_data['cart_id'] = cpgDB::insertID();
						$cookie_data = cpgTool::encode_data($cookie_data);
						setcookie($CONFIG['cookie_name'].'_cpgshop', $cookie_data, time()+86400*30, $CONFIG['cookie_path']);
						$msg[] = sprintf($lang_cs_cart['load_cart_draft_success'], $id);
						//now redirect to cart
						cpgRedirectPage("index.php?file=cpgshop/cpgshop_cart&page=view_cart", $lang_cs_cart['cart_restored'], $lang_cs_cart['cart_restored'], 0, 'success');
					} else {
						$msg[] = sprintf($lang_cs_cart['load_cart_draft_failed'], $id);
					}
					HTMLelement::message($lang_cs_common['message'], $msg);
					HTMLelement::spacer();
				}
				break;
		}
		// pagination
		if (cpgTool::get_var('start') == true) {
			$start = cpgTool::get_var('start');
		} else {
			$start = 0;
		}

		if (cpgTool::get_var('count') == true) {
			$count = cpgTool::get_var('count');
		} else {
			$count = 25;
		}
		$s1 = $count == 1 ? 'selected="selected"' : '';
		$s50 = $count == 50 ? 'selected="selected"' : '';
		$s75 = $count == 75 ? 'selected="selected"' : '';
		$s100 = $count == 100 ? 'selected="selected"' : '';

		$action = "index.php?file=cpgshop/cpgshop_cart&page=save_cart&amp;start=" . $start . "&amp;count=" . $count ;

		$save_array = cpgDB::fetchRowset("SELECT cid, user_id, ctime FROM `{$CONFIG['TABLE_CS_CART']}` WHERE save='1' AND user_id='".USER_ID."' ORDER BY ctime DESC LIMIT $start, $count;");
		// getting the pic count for pagination
		$sql = "SELECT COUNT(*) FROM {$CONFIG['TABLE_CS_CART']} WHERE save='1' AND user_id='".USER_ID."';";
		$result = cpgDB::runQuery($sql);

		list($save_count) = cpg_db_fetch_row($result, true);

		$save_count_text = sprintf($lang_cs_edit_pic['n_pic'], $save_count);
		// pagination
		$next_target = "index.php?file=cpgshop/cpgshop_cart&page=save_cart&amp;start=" . ($start + $count) . '&amp;count=' . $count ;
		$prev_target = "index.php?file=cpgshop/cpgshop_cart&page=save_cart&amp;start=" . max(0, $start - $count) . '&amp;count=' . $count ;
		// editing an album
		if ($start + $count < $save_count) {
			$next_link = "<a href=\"$next_target\"><strong>{$lang_cs_common['see_next']}</strong></a>&nbsp;&nbsp;-&nbsp;&nbsp;";
		} else {
			$next_link = '';
		}

		if ($start > 0) {
			$prev_link = "<a href=\"$prev_target\"><strong>{$lang_cs_common['see_prev']}</strong></a>&nbsp;&nbsp;-&nbsp;&nbsp;";
		} else {
			$prev_link = '';
		}
		$sel = <<<EOT
            <strong>$save_count_text</strong>&nbsp;&nbsp;-&nbsp;&nbsp;
            $prev_link
            $next_link
            <strong>{$lang_cs_common['n_of_pic_to_disp']}</strong>
	        <select onchange="if(this.options[this.selectedIndex].value) window.location.href='index.php?file=cpgshop/cpgshop_cart&page=save_cart&amp;start=$start&amp;count='+this.options[this.selectedIndex].value;"  name="count" class="listbox">
	               <option value="25">25</option>
	               <option value="1" $s1>1</option>
	               <option value="50" $s50>50</option>
	               <option value="75" $s75>75</option>
	               <option value="100" $s100>100</option>
	       	</select>
EOT;
		// starttable
		starttable($CONFIG['picture_table_width'], $lang_cs_save_cart['switch_discount'], 7);

		// control box
		echo cpgTemplate::set($control, array(
			'{LANG_NEW}' => $lang_cs_cart['new_draft'],
			'{LANG_DEL}' => $lang_cs_cart['del_draft'],
			'{LANG_LOAD}' => $lang_cs_cart['load_draft'],
			'{LANG_SURE}' => $lang_cs_cart['are_you_sure'],
			'{LANG_SHORT_HELP}' => $lang_cs_cart['save_cart_short_help']
		));
		// title
		echo cpgTemplate::set($this_title, array(
			'{LANG_TOGGLE_ALL}' => $lang_cs_common['toggle_all'],
			'{LANG_TIME}' => $lang_cs_cart['time_saved'],
		));
		// drafts list
		if (count($save_array) == 0)
			echo HTMLelement::apply_simple_text(HTMLelement::simple_text(4), $lang_cs_cart['no_saved_drafts']);


		foreach ($save_array as $save) {
			$time_link =  "<a onclick=\"window.location.href='index.php?file=cpgshop/cpgshop_cart&page=save_cart&task=load_act&id={$save['cid']}'\" style=\"cursor: pointer;\">" . localised_date($save['ctime'], $lang_date['comment']) ."</a>";
			$vars = array(
			'{CHECK_BOX}' => HTMLelement::check_box("id[]", $save['cid']),
			'{TIME}' => $time_link,
			);
			echo cpgTemplate::set($element, $vars);
		}
		// page nav
		echo cpgTemplate::set($page_nav, array(
			'{PAGE_NAV}' => $sel,
		));
		echo cpgTemplate::set($control_end, []);
		endtable();
		return;
	}
    // -----------------------------------------------------------------------------------------
    // PROCESS THE DOWNLOADS
    // -----------------------------------------------------------------------------------------
    public static function process()
    {
        global $CONFIG, $cpg_udb;
        global $lang_cs_cart, $lang_cs_common;
        // check if the user is logged in
        cpgTool::check_user();

        if (!$CONFIG['cpgshop_download_enable']) {
            cpg_die(ERROR, $lang_cs_cart['download_not_enabled'], __FILE__, __LINE__);
        }

        $order = (int)cpgTool::request_var('order');
        $hash = cpgTool::request_var('hash');
        $return_lnk = cpgTool::request_var('return_lnk');
        $folderc = cpgTool::request_var('folderc');
        // TEMPLATE
        $tpl_download = cpgTemplate::get('blog_download');
        $title = cpgTemplate::extract($tpl_download, 'title');
        $element = cpgTemplate::extract($tpl_download, 'element');
        $footer = cpgTemplate::extract($tpl_download, 'footer');

        if (is_numeric($order)) {
            // first get the order id using the hash
            $sql = "SELECT oid, user_id, cart, cship, cdown, paid, hash, time FROM {$CONFIG['TABLE_CS_ORDER']} WHERE oid='$order' LIMIT 1;";
            $order_data = cpgDB::fetchRow($sql);

            $cart_data = unserialize($order_data['cart']);
            // if there's no download item or the hash doesn't match or the USER_ID is not the user id matching the order (or no admin)
            if (!GALLERY_ADMIN_MODE) {
                if ($hash != md5($order_data['oid'] . $order_data['user_id'] . $order_data['time']) || !$order_data['cdown'] || !$order_data['paid'] || (USER_ID != $order_data['user_id'])) {
                    cpg_die(ERROR, $lang_cs_cart['not_validated'], __FILE__, __LINE__);
                }
            }
            // define path
            $dest_dir = $CONFIG['fullpath'] . 'downloads/' . $order_data['user_id'] . '_' . $order_data['oid'] . '/';

            if (!is_dir($dest_dir && $folderc == 'do')) {
                // create the folder
            }
            if (!is_dir($dest_dir)) { // download dir doesn't exist... die
                if ($folderc != 'do') {
                    $warning_link = 1;
                    if (GALLERY_ADMIN_MODE) {
                        $link = "<input onclick=\"var answer=confirm('{$lang_cs_common[are_you_sure]}');if (answer) window.location.href='index.php?file=cpgshop/cpgshop_cart&amp;page=process&order={$order}&amp;hash={$hash}&amp;return_lnk={$return_lnk}&amp;folderc=do';\" class=\"button\" type=\"button\" value=\"{$lang_cs_cart['download_continue']}\">";
                        msg_box(sprintf($lang_cs_cart['no_folder_admin'], $dest_dir), sprintf($lang_cs_cart['no_folder_admin'], $dest_dir) . " <br /><br /> {$link}", '' , '' , 'info');
                        pagefooter();
                        die();
                    } else { // if it's a user do not display a sophisticated error message and no continue button to admin site
                        $link = "<input onclick=\"window.location.href='index.php?file=cpgshop/cpgshop_cart&amp;page=process&order={$order}&amp;hash={$hash}&amp;folderc=do';\" class=\"button\" type=\"button\" value=\"{$lang_cs_cart['download_continue']}\">";
                        msg_box($lang_cs_cart['no_folder_user'], $lang_cs_cart['no_folder_user'] . "<br /><br />{$link}", $lang_cs_cart['continue_download'], "index.php", '100%');
                        pagefooter();
                        die();
                    }
                } else {
                    // create download folder, htaccess, htpasswd, resize images and copy them to download folder
                    if (cpgTool::ipn_download_dir($order_data['user_id'], $order, true)) {
                        // success, do the auto move check and email the admin
                        // mark the item as downloaded
                        // cpgDB::runQuery ("UPDATE {$CONFIG['TABLE_CS_ORDER']} SET sentd='1' WHERE oid ='".$order."' LIMIT 1;");
                        if ($CONFIG['cpgshop_states_auto_move']) {
                            // send state changed email
                            cpgTool::email_state_change($order_data['user_id'], $order, 'state_change_downloaded');
                            // check if not shipping but just to download... in that case we can move to sent
                            if (!$order_data['cship'] && $order_data['cdown']) {
                                $result2 = cpgDB::runQuery(("UPDATE {$CONFIG['TABLE_CS_ORDER']} SET archive = '4' WHERE oid ='" . $order . "'"));
                            } // auto move do
                        } //is auto move enabled
                    } // create download dir
                } //end else
            } //end is_dir
            $return_lnk_check = false;

            starttable($CONFIG['picture_table_width'], $lang_cs_cart['prep_down'], 3);
            echo cpgTemplate::set($title, array(
                    '{LANG_STATUS}' => $lang_cs_cart['status'],
                    '{LANG_FILE}' => $lang_cs_cart['file'],
                    '{LANG_RESULT}' => $lang_cs_cart['result'],
                    '{LANG_PREP}' => $lang_cs_cart['prep_down'],
                    ));

            foreach($cart_data as $value) {
                // grab the desired resize width from the price table and if it is a download item
                $sql = "SELECT size, type FROM {$CONFIG['TABLE_CS_PRICE']} WHERE pid='" . $value['price'] . "' LIMIT 1;";
                $pic_size = cpgDB::fetchRow($sql);

                $sql = "SELECT filepath, filename, filesize, pwidth, pheight, title FROM {$CONFIG['TABLE_PICTURES']} WHERE pid='" . $value['pid'] . "' LIMIT 1;";
                $pic_data = cpgDB::fetchRow($sql);
                if ($pic_size['type'] == 1) { // it's a download item
                    // get the pic filename, path etc
                    // check if it already has been created and exists in the download folder... if so, then offer download link
                    $display_continue_button = false;
                    // if the same filename exists in different pathes, we add the pathpart to the filename to make it unique
                    $filename_pfx = $pic_data['filepath'];
                    // clean up the path, remove / \ and all the special chars, remove 'userpics', the uid+10000 is sufficient
                    $filename_pfx = eregi_replace($CONFIG['userpics'], '', $filename_pfx);
                    $filename_pfx = eregi_replace("[^[:alnum:]+]", "", $filename_pfx);

                    $filename = $pic_size['size'] . "_" . $filename_pfx . "_" . $pic_data['filename'];
                    $image = $CONFIG['fullpath'] . $pic_data['filepath'] . $pic_data['filename'];
                    $orig = $CONFIG['fullpath'] . $pic_data['filepath'] . $CONFIG['orig_pfx'] . $pic_data['filename'];

                    if (file_exists($dest_dir . $filename)) {
                        // file already exists => show download link
                        $el_desc = HTMLElement::image('images/batch/ok_small.png', 1);
                        $el_link = HTMLElement::link($dest_dir . $filename, $lang_cs_cart['download_file']);
                    } else { // file doesn't exist in download folder... then create it
                        // we now need to display a continue button... page refresh, all images created, for all a download link
                        $display_continue_button = true;
                        // first check if we have a orig as base image
                        if (file_exists($orig)) {
                            // if we have a orig file, use that instead
                            $image = $orig;
                        }
                        $el_desc = $lang_cs_cart['creating_image'];
                        $el_link = "<img src=\"index.php?file=cpgshop/cpgshop_addpic&image=" . urlencode($image) . "&size=" . urlencode($pic_size['size']) . "&amp;destination=" . ($dest_dir . $filename) . "&amp;order=" . ($order) . "&amp;hash=" . $hash . "&amp;reload=" . uniqid('') . "\" height=\"24\" width=\"24\"/>";
                        flush ();
                    }
                } else {
                    // item is for print, no sownload
                    echo "<td>{$lang_photoshop_ipn['ipn_for_print']}</td><td></td></tr>\n\n";
                    $el_desc = $lang_cs_cart['for_print'];
                    $el_link = '';
                    $return_lnk_check = true;
                }

                echo cpgTemplate::set($element, array(
                        '{FILE_NAME}' => $pic_data['filename'],
                        '{FILE_ID}' => $value['pid'],
                        '{DESC}' => $el_desc,
                        '{LINK}' => $el_link,
                        ));
            }

            endtable();

            if (!$display_continue_button) { // pictures already created
                if ($CONFIG['cpgshop_download_zip']) {

                	$user_info = $cpg_udb->get_user_infos($order_data['user_id']);
                	$zip_file = cpgTemplate::set($CONFIG['cpgshop_download_zip_name'], array(
                	'{ORDER_ID}' => $order,
                	'{USER_ID}' => $order_data['user_id'],
                	'{USER_NAME}' => $user_info['user_name'],
                	'{SITE_NAME}' => $CONFIG['gallery_name'],
                ));

                    if (!file_exists($dest_dir . $zip_file.".zip")) { // zip file doesn't exist... create it
                        require_once('include/archive.php');
                        // Create new zip file in the directory below the current one
                        $test = new zip_file($dest_dir . $zip_file.".zip");
                        // Do not recurse through subdirectories
                        // Do not store file paths in archive
                        // Overwrite existing files
                        // Do not create in mem but on hd
                        $test->set_options(array('overwrite' => 1, 'inmemory' => 0, 'recurse' => 0, 'storepaths' => 0));
                        // Add all jpegs and gifs in the images directory to archive
                        $test->add_files(array("{$dest_dir}/*.*"));
                        $test->exclude_files("{$dest_dir}/*.html");
                        $test->exclude_files("{$dest_dir}/*.htaccess");
                        $test->exclude_files("{$dest_dir}/*.htpasswd");
                        // Create archive in path
                        $test->create_archive();
                    }
                    // display zipo download button
                    msg_box($lang_cs_cart['download_zip'], $lang_cs_cart['download_zip_txt'], "<span class=\"button\">" . $lang_cs_cart['download_zip'] . "</span>", $dest_dir . $zip_file.".zip", 'info');
                }
            }
            // display continue button
            if ($display_continue_button || $return_lnk != '') {
                if ($return_lnk == 'index' && $display_continue_button) {
                    $link = "<input onclick=\"window.location.href='index.php?file=cpgshop/cpgshop_cart&amp;page=process&order={$order}&amp;hash={$hash}&amp;return_lnk=index';\" class=\"button\" type=\"button\" value=\"{$lang_cs_cart['download_continue']}\">";
                    // we're coming here from the admin, but we need to continue further from the creation to the download... carry the admin with
                    msg_box($lang_cs_cart['image_create_finished'], $lang_cs_cart['image_create_finished'] . "<br /><br />" . $link, '', '', 'info');
                } elseif ($return_lnk == 'index' && !$display_continue_button) {
                    $link = "<input onclick=\"window.location.href='index.php?file=cpgshop/cpgshop_config&amp;page=order&amp;display=view_act&amp;order={$order}';\" class=\"button\" type=\"button\" value=\"{$lang_cs_cart['download_continue']}\">";
                    // we came from the admin and now we're on the download page, display continue back to admin
                    msg_box($lang_cs_cart['image_create_finished'], $lang_cs_cart['image_create_finished'] . "<br /><br />" . $link, '', '', 'info');
                } elseif ($display_continue_button) {
                    $link = "<input onclick=\"window.location.href='index.php?file=cpgshop/cpgshop_cart&amp;page=process&order={$order}&amp;hash={$hash}';\" class=\"button\" type=\"button\" value=\"{$lang_cs_cart['download_continue']}\">";
                    // we're a user and get displayed a continue button to the download
                    msg_box($lang_cs_cart['image_create_finished'], $lang_cs_cart['image_create_finished'] . "<br /><br />" . $link, '', '', 'info');
                }
            }
        } else { // no hash, someone probably tries to use this script unauthorized
            cpg_die(ERROR, $lang_photoshop_ipn['ipn_no_order_match'], __FILE__, __LINE__);
        }
    }
    // -----------------------------------------------------------------------------------------
    // ADD TO CART BUTTON
    // -----------------------------------------------------------------------------------------
    public static function add_to_cart($CURRENT_PIC_DATA)
    {
        global $CONFIG, $currency_symbol;
        // return print_r($CURRENT_PIC_DATA);
        global $lang_cs_codebase;
        // in 1.5 we have no select all in get_pic_data... -> need to query price and option separately
        $select_columns = '`option`,`price`';
        $query = "SELECT $select_columns FROM {$CONFIG['TABLE_PICTURES']} WHERE pid={$CURRENT_PIC_DATA['pid']}";
        $result = cpg_db_query($query);
        $pic_data = cpg_db_fetch_assoc($result, true);

        if ((int)$pic_data['price'] == 0) return "";
        $tpl_atc = cpgTemplate::get('blog_add_to_cart');
        if ((int)$pic_data['option'] == 0)
            cpgTemplate::extract($tpl_atc, 'option');
        $vars = array(
            '{ID}' => $CURRENT_PIC_DATA['pid'],
            '{PRICE_TITLE}' => HTMLelement::price_list_title($pic_data['price']),
            '{PRICE}' => HTMLelement::price_list($pic_data['price'],'','',max($CURRENT_PIC_DATA['pwidth'],$CURRENT_PIC_DATA['pheight'])),
            '{OPTION_TITLE}' => HTMLelement::option_list_title($pic_data['option']),
            '{OPTION}' => HTMLelement::option_list($pic_data['option']),
            '{LANG_TITLE}' => $lang_cs_codebase['add_to_cart'],
            '{LANG_SUBMIT}' => $lang_cs_codebase['submit'],
            );
        return cpgTemplate::set($tpl_atc, $vars);
    }
    // -----------------------------------------------------------------------------------------
    // PROCESS PAYPAL HTML ERROR -> todo
    // -----------------------------------------------------------------------------------------
    public static function process_html_error()
    {
        global $CONFIG;
        // do smt ???
        return;
    }
    // -----------------------------------------------------------------------------------------
    // EDIT ONE PIC || OR PICS IN ALBUM
    // -----------------------------------------------------------------------------------------
    public static function edit_pic()
    {
        global $CONFIG;
        global $lang_byte_units, $lang_cs_edit_pic, $lang_cs_error, $lang_cs_common;

        $sql_where_1 = $sql_where_2 = '';

        // get ACTION
        $task = cpgTool::request_var('task');
    	$filter_enabled = cpgTool::request_var('filter_enabled');
    	$filter_aid = cpgTool::request_var('filter_aid');
    	// $task = cpgTool::request_var('task');
     	$pid = (int)cpgTool::get_var('pid');
        $aid = (int)cpgTool::get_var('aid');
        $current_pic_data = 	cpgTool::get_pic_data($pid);

		$tpl_edit_one_pic = 	cpgTemplate::get("blog_edit_pic");
        $begin_form = 			cpgTemplate::extract($tpl_edit_one_pic, "begin_form");
        $paoa = 				cpgTemplate::extract($tpl_edit_one_pic, "paoa");
        $end_form = 			cpgTemplate::extract($tpl_edit_one_pic, "end_form");
        $select_all = 			cpgTemplate::extract($tpl_edit_one_pic, "select_all");
        $page_nav = 			cpgTemplate::extract($tpl_edit_one_pic, "page_nav");
    	$edit_all = 			cpgTemplate::extract($tpl_edit_one_pic, "edit_all");
    	// error if aid & pid = 0
        if ($aid == 0 && $pid == 0) {
            cpg_die(ERROR, $lang_cs_edit_pic['err_no_param']);
        }

    	if ($task == "edit_all" && $aid != 0) {

			if(cpgTool::post_var("add_all")){ //checkbox ticked
	    		$price = cpgTool::post_var("price");
	    		$option = cpgTool::post_var("option");
				cpgDB::runQuery("UPDATE `{$CONFIG['TABLE_PICTURES']}` SET price='$price', `option`='$option' WHERE aid='{$aid}';");
			} else {
				cpgDB::runQuery("UPDATE `{$CONFIG['TABLE_PICTURES']}` SET price='0', `option`='0' WHERE aid='{$aid}';");
			}
    		HTMLelement::message($lang_cs_edit_pic['message'], $lang_cs_edit_pic['edit_success']);
    		HTMLelement::spacer();

		}


        if ($task == "edit_act") {
            $superCage = Inspekt::makeSuperCage();
            // input hidden with pid array to make it possible for inspect to read an array of items
            // compare that hidden input tag with the checkbox array if it's set, we need the pid from the pid array to be able to unset the checkbox
            $pid_array = $superCage->post->getInt('pid_array');

            foreach ($pid_array as $key => $value) {
                // here we read the pid value from the checkbox
                $this_pid = cpgTool::post_var("pid_" . $value);
                // if it has a value (checked) and the value is equal to the identifier , we add the data to the db
                if ((int)$this_pid == $value) {
                    $price = cpgTool::post_var("price_" . $value);
                    $option = cpgTool::post_var("option_" . $value);
                    cpgDB::runQuery("UPDATE `{$CONFIG['TABLE_PICTURES']}` SET price='$price', `option`='$option' WHERE pid='{$value}';");
                } else { // set to 0
                    cpgDB::runQuery("UPDATE `{$CONFIG['TABLE_PICTURES']}` SET price='0', `option`='0' WHERE pid='{$value}';");
                }
            }
            HTMLelement::message($lang_cs_edit_pic['message'], $lang_cs_edit_pic['edit_success']);
            HTMLelement::spacer();
        }

    	starttable($CONFIG['picture_table_width'], $lang_cs_edit_pic['pic_price_option'], 3);

        // get the pic data
        if ($aid != 0) {
            // edit multi pic
            $edit_type = true;

        	//pagination
            if (cpgTool::get_var('start') == true) {
                $start = cpgTool::get_var('start');
            } else {
                $start = 0;
            }

            if (cpgTool::get_var('count') == true) {
                $count = cpgTool::get_var('count');
            } else {
                $count = 25;
            }
            $s1 = $count == 1 ? 'selected="selected"' : '';
            $s50 = $count == 50 ? 'selected="selected"' : '';
            $s75 = $count == 75 ? 'selected="selected"' : '';
            $s100 = $count == 100 ? 'selected="selected"' : '';			//filters
			switch($filter_aid){
				case 'all':
					$where_or_and = "WHERE";
					break;
				default:
					$sql_where_1 = " WHERE aid = '$aid'";
					$where_or_and = "AND";
			} // switch
        	switch($filter_enabled){
        		case 'enabled':
        			$sql_where_2 = " $where_or_and price = '1'";
        			break;
        		case 'disabled':
        			$sql_where_2 = " $where_or_and price != '1'";
        			break;
        		default:

        	} // switch

        	//prepare selects for aid and enabled filter
        	$switch_codes_aid = array(
	        	'filter_aid_aid' 		=> 'aid',
	        	'filter_aid_all' 		=> 'all',
        	);
        	$switch_box_aid = "<select name=\"filter_aid\" class=\"listbox\" onchange=\"if(this.options[this.selectedIndex].value) window.location.href='index.php?file=cpgshop/cpgshop_edit_pic&amp;aid=$aid&amp;count=$count&amp;filter_enabled=$filter_enabled&amp;filter_aid='+this.options[this.selectedIndex].value;\">\n";
        	foreach($switch_codes_aid as $key => $value) {
        		$selected = ($value == $filter_aid) ? 'selected="selected"' : "";
        		$switch_box_aid .= "        <option value=\"" . $value . "\" $selected>" . $lang_cs_edit_pic[$key] . "</option>\n";
        	}
        	$switch_box_aid .= "</select>\n";
			//filter cart enabled
        	$switch_codes_enabled = array(
        		'filter_enabled_all' 			=> 'all',
	        	'filter_enabled_enabled' 		=> 'enabled',
	        	'filter_enabled_disabled' 		=> 'disabled',
        	);
        	$switch_box_enabled = "<select name=\"filter_enabled\" class=\"listbox\" onchange=\"if(this.options[this.selectedIndex].value) window.location.href='index.php?file=cpgshop/cpgshop_edit_pic&amp;aid=$aid&amp;count=$count&amp;filter_aid=$filter_aid&amp;filter_enabled='+this.options[this.selectedIndex].value;\">\n";
        	foreach($switch_codes_enabled as $key => $value) {
        		$selected = ($value == $filter_enabled) ? 'selected="selected"' : "";
        		$switch_box_enabled .= "        <option value=\"" . $value . "\" $selected>" . $lang_cs_edit_pic[$key] . "</option>\n";
        	}
        	$switch_box_enabled .= "</select>\n";

            // pagination


            $sql = "SELECT pid, url_prefix, filename, filepath, price, `option`, pwidth, pheight, filesize, hits, votes"
             . " FROM `{$CONFIG['TABLE_PICTURES']}` $sql_where_1 $sql_where_2"
             . " ORDER BY pid"
             . " LIMIT $start, $count;";
            $pic_data_array = cpgDB::fetchRowset($sql);
            $action = "index.php?file=cpgshop/cpgshop_edit_pic&aid=" . $aid . '&amp;start=' . $start . '&amp;count=' . $count . '&amp;filter_enabled=' . $filter_enabled. '&amp;filter_aid=' . $filter_aid;
            // getting the pic count for pagination
            $sql = "SELECT COUNT(*) FROM {$CONFIG['TABLE_PICTURES']} $sql_where_1 $sql_where_2;";
            $result = cpgDB::runQuery($sql);

            list($pic_count) = cpg_db_fetch_row($result, true);
            $pic_count_text = sprintf($lang_cs_common['n_pic'], $pic_count);
            // pagination
            $next_target = "index.php?file=cpgshop/cpgshop_edit_pic&aid=" . $aid . '&amp;start=' . ($start + $count) . '&amp;count=' . $count . '&amp;filter_enabled=' . $filter_enabled. '&amp;filter_aid=' . $filter_aid;
            $prev_target = "index.php?file=cpgshop/cpgshop_edit_pic&aid=" . $aid . '&amp;start=' . max(0, $start - $count) . '&amp;count=' . $count .'&amp;filter_enabled=' . $filter_enabled. '&amp;filter_aid=' . $filter_aid;
            // editing an album
            if ($start + $count < $pic_count) {
                $next_link = "<a href=\"$next_target\"><strong>{$lang_cs_common['see_next']}</strong></a>&nbsp;&nbsp;-&nbsp;&nbsp;";
            } else {
                $next_link = '';
            }

            if ($start > 0) {
                $prev_link = "<a href=\"$prev_target\"><strong>{$lang_cs_common['see_prev']}</strong></a>&nbsp;&nbsp;-&nbsp;&nbsp;";
            } else {
                $prev_link = '';
            }
            $sel = <<<EOT
            <strong>$pic_count_text</strong>&nbsp;&nbsp;-&nbsp;&nbsp;
            $prev_link
            $next_link
            <strong>{$lang_cs_common['n_of_pic_to_disp']}</strong>
	        <select onchange="if(this.options[this.selectedIndex].value) window.location.href='index.php?file=cpgshop/cpgshop_edit_pic&aid=$aid&amp;start=$start&amp;count='+this.options[this.selectedIndex].value;"  name="count" class="listbox">
	               <option value="25">25</option>
	               <option value="1" $s1>1</option>
	               <option value="50" $s50>50</option>
	               <option value="75" $s75>75</option>
	               <option value="100" $s100>100</option>
	       	</select>
EOT;
$pic_data = $pic_data_array[0];
			//if we vieww an entire album add 'edit all album'
        	echo cpgTemplate::set($edit_all, array(
        	'{CHECK_BOX}' => HTMLelement::check_box("add_all", "1"),
        	'{ACTION}' => $action,
        	'{LANG_EDIT_ALL}' => $lang_cs_edit_pic['edit_all'],
        	'{LANG_PRICE}' => $lang_cs_edit_pic['price'],
        	'{PRICE}' => HTMLelement::price_set_list ('price', $pic_data['price']),
        	'{LANG_OPTION}' => $lang_cs_edit_pic['option'],
        	'{OPTION}' => HTMLelement::option_set_list('option', $pic_data['option']),
        	'{LANG_SUBMIT}' => $lang_cs_edit_pic['edit'],
        ));


        } elseif ($pid != 0) {
            // edit one pic
            $edit_type = false;

            $type = false;
            $sql = "SELECT pid, url_prefix, filename, filepath, price, `option`, pwidth, pheight, filesize, hits, votes"
             . " FROM `{$CONFIG['TABLE_PICTURES']}` WHERE pid = '$pid'"
             . " LIMIT 1;";
            $pic_data_array = cpgDB::fetchRowset($sql);
            $action = "index.php?file=cpgshop/cpgshop_edit_pic&pid=" . $pid;
            // no pagination needed
            $next_link = '';
            $prev_link = '';
        } else {
            cpg_die(ERROR, $lang_cs_error['nothing_display'], __FILE__, __LINE__);
        }

        //starttable($CONFIG['picture_table_width'], $lang_cs_edit_pic['pic_price_option'], 3);
    	// begin edit all


        // begin form
        echo cpgTemplate::set($begin_form, array(
                '{ACTION}' => $action,
            	));
        // if there are more than one pics to edit add a select all checkbox
        if (count($pic_data_array) > 1) {
            echo cpgTemplate::set($select_all, array(
                    '{LANG_TOGGLE_ALL}' => $lang_cs_common['toggle_all'],
                    ));
        }
        // body
        foreach ($pic_data_array as $pic_data) {
            $pic_data['filesize'] = ceil($pic_data['filesize'] / 1024);
            if ((int)$pic_data['price'] != 0) $checked = " checked=\"checked\"";
            else $checked = "";
            echo cpgTemplate::set($paoa, array(
                    '{PID}' => $pic_data['pid'],
                    '{CHECK_BOX}' => HTMLelement::check_box("pid_" . $pic_data['pid'], $pic_data['pid'], $checked),
                    '{FILENAME}' => $pic_data['filename'],
                    '{THUMB}' => HTMLelement::image(get_pic_url($pic_data, "thumb")),
                    '{LANG_FILE_INFO}' => $lang_cs_edit_pic['file_info'],
//                    '{FILE_INFO}' => "{$pic_data['pwidth']} × {$pic_data['pheight']} - {$pic_data['filesize']} votes - {$pic_data['KB']} {$lang_cs_edit_pic['views']} - {$pic_data['votes']} {$lang_cs_edit_pic['votes']}",
                    '{FILE_INFO}' => "{$pic_data['pwidth']} × {$pic_data['pheight']} - {$pic_data['filesize']} {$lang_byte_units[1]} - {$pic_data['hits']} {$lang_cs_edit_pic['views']} - {$pic_data['votes']} {$lang_cs_edit_pic['votes']}",
                    '{LANG_PRICE}' => $lang_cs_edit_pic['price'],
                    '{PRICE}' => HTMLelement::price_set_list ('price_' . $pic_data['pid'], $pic_data['price']),
                    '{LANG_OPTION}' => $lang_cs_edit_pic['option'],
                    '{OPTION}' => HTMLelement::option_set_list('option_' . $pic_data['pid'], $pic_data['option']),
                    ));
        }

        // end form
        echo cpgTemplate::set($end_form, array(
                '{LANG_SUBMIT}' => $lang_cs_edit_pic['edit'],
                ));

        if ($edit_type) { // display paginantion if album view
            echo cpgTemplate::set($page_nav, array(
                    '{PAGE_NAV}' => $sel,
            		'{FILTER_AID}' => $switch_box_aid,
            		'{FILTER_ENABLED}' => $switch_box_enabled,
            ));
        }
        endtable();
        return;
    }
    // -----------------------------------------------------------------------------------------
    // MAIN PAGE
    // -----------------------------------------------------------------------------------------
    public static function mainpage()
    {
        global $CONFIG;
        global $lang_cs_mainpage;
        $tpl_mainpage = cpgTemplate::get('blog_mainpage');
        $title = cpgTemplate::extract($tpl_mainpage, "title");
        $element = cpgTemplate::extract($tpl_mainpage, "element");

    	//springclean - mark expired as invalid
    	if($CONFIG['cpgshop_del_cart_interval'] > 0) {
    		$exp_time = localised_timestamp() - $CONFIG['cpgshop_del_cart_interval'] * 3600;
    		$result = cpgDB::runQuery("DELETE FROM `{$CONFIG['TABLE_CS_CART']}` WHERE save='0' AND (ctime < $exp_time);");
    	}
    	if($CONFIG['cpgshop_del_saved_cart_interval'] > 0) {
    		$exp_time = localised_timestamp() - $CONFIG['cpgshop_del_saved_cart_interval'] * 3600;
    		$result = cpgDB::runQuery("DELETE FROM `{$CONFIG['TABLE_CS_CART']}` WHERE save='1' AND (ctime < $exp_time);");
    	}

        $button_link = "index.php?file=cpgshop/cpgshop_config&amp;page=order";

        $row = cpgDB::fetchRow("SELECT count(*) FROM `{$CONFIG['TABLE_CS_PRICE']}`;");
        $number_of_price = $row['count(*)'];
        $row = cpgDB::fetchRow("SELECT count(*) FROM `{$CONFIG['TABLE_CS_PRICESET']}`;");
        $number_of_priceset = $row['count(*)'];
        $row = cpgDB::fetchRow("SELECT count(*) FROM `{$CONFIG['TABLE_CS_OPTION']}`;");
        $number_of_option = $row['count(*)'];
        $row = cpgDB::fetchRow("SELECT count(*) FROM `{$CONFIG['TABLE_CS_OPTIONSET']}`;");
        $number_of_optionset = $row['count(*)'];

        $row = cpgDB::fetchRow("SELECT count(*) FROM `{$CONFIG['TABLE_CS_ORDER']}`;");
        $number_of_orders = $row['count(*)'];
        $row = cpgDB::fetchRow("SELECT count(*) FROM `{$CONFIG['TABLE_CS_ORDER']}` WHERE new='1';");
        $number_of_new_orders = $row['count(*)'];
        $row = cpgDB::fetchRow("SELECT count(*) FROM `{$CONFIG['TABLE_CS_ORDER']}` WHERE paid='0';");
        $number_of_unpaid_orders = $row['count(*)'];
        $row = cpgDB::fetchRow("SELECT count(*) FROM `{$CONFIG['TABLE_CS_ORDER']}` WHERE sent='0' AND cship='1' AND paid='1' AND printed='1';");
        $number_of_unsent_orders = $row['count(*)'];
        $row = cpgDB::fetchRow("SELECT count(*) FROM `{$CONFIG['TABLE_CS_ORDER']}` WHERE sent='0' AND cship='1' AND paid='1' AND printed='0';");
        $number_of_not_printed_orders = $row['count(*)'];
        starttable($CONFIG['picture_table_width'], $lang_cs_mainpage['main_page_title'], 2);
        echo cpgTemplate::set($title, array('{TITLE}' => $lang_cs_mainpage['stastics']));

        echo cpgTemplate::set($element, array('{TITLE}' => $lang_cs_mainpage['new_orders'], '{VALUE}' => (sprintf($lang_cs_mainpage['num_of_new_orders'], $number_of_new_orders, $number_of_orders)) . ' ' . HTMLElement::link($button_link . '&amp;sort=new_d', $lang_cs_mainpage['view'])));
        echo cpgTemplate::set($element, array('{TITLE}' => $lang_cs_mainpage['unpaid_orders'], '{VALUE}' => (sprintf($lang_cs_mainpage['num_of_unpaid_orders'], $number_of_unpaid_orders)) . ' ' . HTMLElement::link($button_link . '&amp;box=1', $lang_cs_mainpage['view'])));
        echo cpgTemplate::set($element, array('{TITLE}' => $lang_cs_mainpage['unsent_orders'], '{VALUE}' => (sprintf($lang_cs_mainpage['num_of_unsent_orders'], $number_of_unsent_orders)) . ' ' . HTMLElement::link($button_link . '&amp;box=3', $lang_cs_mainpage['view'])));
        echo cpgTemplate::set($element, array('{TITLE}' => $lang_cs_mainpage['not_printed_orders'], '{VALUE}' => (sprintf($lang_cs_mainpage['num_of_not_printed_orders'], $number_of_not_printed_orders)) . ' ' . HTMLElement::link($button_link . '&amp;box=2', $lang_cs_mainpage['view'])));
        // echo cpgTemplate::set($element, array('{TITLE}' =>$lang_cs_mainpage['num_of_order'],'{VALUE}' =>$number_of_orders));
        echo cpgTemplate::set($element, array('{TITLE}' => '&nbsp;', '{VALUE}' => ''));
        echo cpgTemplate::set($element, array('{TITLE}' => $lang_cs_mainpage['num_of_price'], '{VALUE}' => $number_of_price));
        echo cpgTemplate::set($element, array('{TITLE}' => $lang_cs_mainpage['num_of_priceset'], '{VALUE}' => $number_of_priceset));
        echo cpgTemplate::set($element, array('{TITLE}' => $lang_cs_mainpage['num_of_option'], '{VALUE}' => $number_of_option));
        echo cpgTemplate::set($element, array('{TITLE}' => $lang_cs_mainpage['num_of_optionset'], '{VALUE}' => $number_of_optionset));
        endtable();
        return;
    }
    // -----------------------------------------------------------------------------------------
    // CONFIG
    // -----------------------------------------------------------------------------------------
    public static function config()
    {
        global $CONFIG;
        global $currency_symbol;
        global $lang_cs_common, $lang_cs_config;

		$userMessage = '';
		$submit_icon = '<img src="images/icons/ok.png" border="0" alt="" width="16" height="16" class="icon" />';

        require_once('plugins/cpgshop/include/admin.inc.php'); // populate the array for the admin data (could later be done using an XML file)

        $admin_data_array = $CONFIG;

        $update_config = cpgTool::post_var('update_config');
        if ($update_config) {
            // first we check if the form token is valid
            if (!checkFormToken()) {
                cpg_die(ERROR, $lang_errors['invalid_form_token'], __FILE__, __LINE__);
            }
        }

        $output = starttable($CONFIG['picture_table_width'], $lang_cs_config['config_title'] . ' - ' . SHOP_VERSION, 2);
        $output .= '<form action="index.php?file=cpgshop/cpgshop_config&page=config" method="post" name="cpgform" id="cpgform">';

        $sectionLoopCounter = 0;
        foreach ($config_data as $config_section_key => $config_section_value) { // start foreach-loop through the config sections
            foreach ($config_section_value as $adminDataKey => $adminDataValue) {
                if ($update_config) {
                    $evaluate_value = cpgTool::post_var($adminDataKey);
                    // $evaluate_value = $superCage->post->getEscaped($adminDataKey);
                } else {
                    $evaluate_value = $CONFIG[$adminDataKey];
                }

                if ($update_config && ($evaluate_value != $CONFIG[$adminDataKey])) {
                    // A space cannot be stored in the config table since the value field is VARCHAR, so %20 is used instead.
                    if (($adminDataKey == 'keyword_separator') && ($evaluate_value == ' ')) {
                        $evaluate_value = '%20';
                    }
                    // finally, all criteria have been met - let's write the updated data to the database
                    cpgTool::cpg_shop_config_set($adminDataKey, $evaluate_value);
                    $admin_data_array[$adminDataKey] = stripslashes($evaluate_value);
                    $CONFIG[$adminDataKey] = stripslashes($evaluate_value);
                    $userMessage .= '<li style="list-style-image:url(images/icons/ok.png)">' . sprintf($lang_cs_config['edit_config_success'], $lang_cs_config[$adminDataKey]) . '</li>' . $LINEBREAK;
                }
            }

            if ($sectionLoopCounter / 2 == floor($sectionLoopCounter / 2)) {
                $tableRowStyle = 'tableb';
            } else {
                $tableRowStyle = 'tableb tableb_alternate';
            }
            $sectionLoopCounter++;

            $output .= <<< EOT
			<tr>
			<td class="{$tableRowStyle}" colspan="2">
			<span class="detail_head_collapsed">
			{$lang_cs_config[$config_section_key]}
			</span>

			<div id="section{$sectionLoopCounter}" class="detail_body">
			<table align="center" width="100%" cellspacing="1" cellpadding="0" class="maintable" border="0">
EOT;

            $withinSectionLoopCounter = 0;
            foreach ($config_section_value as $key => $value) {
                if ($withinSectionLoopCounter / 2 == floor($withinSectionLoopCounter / 2)) {
                    $cellStyle = 'tableb ';
                } else {
                    $cellStyle = 'tableb tableb_alternate ';
                }
                $withinSectionLoopCounter++;

                if ($value['type'] == 'hidden') {
                    $visibility = ' style="display:none;"';
                    $withinSectionLoopCounter++; // increase the counter, as the hidden row should not be taken into account for style alternation
                } else {
                    $visibility = '';
                }

                $output .= <<< EOT

	                <tr{$visibility}>
	                  <td class="{$cellStyle}" style="vertical-align:top;" width="40%">
	                    <a name="{$key}"></a>
	                    	{$lang_cs_config[$key]}
	                  </td>
	                  <td class="{$cellStyle}" style="vertical-align:top;" width="60%">
EOT;

                switch ($value['type']) {
                    case 'hidden':
                        $output .= HTMLelement::hidden($key, $admin_data_array[$key]);
                        break;
                    case 'textfield':
                        $output .= HTMLelement::textfield($key, $admin_data_array[$key]);
                        break;
                    case 'checkbox':
                        if ($admin_data_array[$key] == 1) {
                            $checked = ' checked="checked"';
                        }
                        $output .= HTMLelement::check_box($key, 1, $checked);
                        break;
                    case 'radio':

                        $optionLoopCounter = 0;
                        foreach ($value['options'] as $option) { // loop through the options array
                            $checked = '';
                            if ($admin_data_array[$key] == $optionLoopCounter) {
                                $checked = ' checked="checked"';
                            }

                            $output .= HTMLelement::radio2($key, $optionLoopCounter, $checked, "id=\"$key.$optionLoopCounter\"", $option);

                            $optionLoopCounter++;
//                            $tabindexCounter++;
                        }

                        break;
                    case 'select':
                        $output .= HTMLelement::simple_select($key, $value['options'], $admin_data_array[$key]);
                        break;

                    default:
                }

                $output .= <<< EOT
				                  </td>
				                </tr>
EOT;
            } // end foreach 2
            $output .= <<< EOT
							</table>
						</div>
					</td>
				</tr>
EOT;
        } // end foreach 1
        // get form token
        list($timestamp, $form_token) = getFormToken();
        $output .= <<<EOT
				<tr>
					<td colspan="2" align="center">
						<input type="hidden" name="form_token" value="{$form_token}" />
						<input type="hidden" name="timestamp" value="{$timestamp}" />
		        		<button type="submit" class="button" name="update_config" value="{$lang_cs_config['edit']}">{$submit_icon}{$lang_cs_config['save']}</button>
					</td>
				</tr>
			</form>
		</table>
EOT;

        if ($userMessage != '') {
            $userMessage = '<ul>' . $LINEBREAK . $userMessage . '</ul>' . $LINEBREAK;
        }
        if ($update_config && $userMessage == '') {
            $userMessage = $lang_cs_config['upd_not_needed'];
        }

        if ($userMessage != '') {
            ob_start();
            starttable('100%', cpg_fetch_icon('info', 2) . $lang_common['information'], 1);

            echo <<< EOT
		    <tr>
		        <td class="tableb">
		          {$userMessage}
		        </td>
		    </tr>
EOT;

        }
        print $output;
        return;
    }
    // -----------------------------------------------------------------------------------------
    // ABOUTS
    // -----------------------------------------------------------------------------------------
    public static function abouts()
    {
        global $CONFIG;
        global $lang_cs_abouts;
        starttable($CONFIG['picture_table_width'], 'Abouts');
        $tpl_about = cpgTemplate::get('blog_simple_data');
        $vars = array(
            '{TEXT}' => 'Abouts ^^ !',
            );
        echo cpgTemplate::set($tpl_about, $vars);
        endtable();
        return;
    }
    // -----------------------------------------------------------------------------------------
    // DOCUMENTS
    // -----------------------------------------------------------------------------------------
    public static function documents()
    {
        global $CONFIG;
        global $currency_symbol;
        global $lang_cs_documents , $lang_cs_common;

		$nav = '';
		$button = '';
        $txt_area = '';

        if (cpgTool::post_var('task') == false) {
            $task = cpgTool::get_var('task');
        } else {
            $task = cpgTool::post_var('task');
        }
        // TEMPLATE
        $tpl_option = cpgTemplate::get('blog_documents');
        $title = cpgTemplate::extract($tpl_option, 'title');
        $navigation = cpgTemplate::extract($tpl_option, 'nav');
        $box = cpgTemplate::extract($tpl_option, 'box');
        // task -> action
        switch ($task) {
            case 'save':
                $txt_area = '';
                $tpl_id = cpgTool::post_var('id');
                $tpl_value = cpgTool::post_var('documents');
                if (cpgDB::runQuery("UPDATE `{$CONFIG['TABLE_CS_DOCS']}` SET text ='{$tpl_value}' WHERE name = '{$tpl_id}' LIMIT 1;")) {
                    $txt_area = "Document {$tpl_id} saved!";
                }
                break;
            case 'edit':
                $tpl_id = cpgTool::get_var('id');
                $tpl_value = cpgDB::fetchRow("SELECT name, text FROM `{$CONFIG['TABLE_CS_DOCS']}` WHERE name = '{$tpl_id}' LIMIT 1;");
                $txt_area = $tpl_id . '<br>' . HTMLElement::text_area("documents", $tpl_value['text'], 80, 30);
                $txt_area .= HTMLELEMENT::hidden('id', $tpl_id);
                $txt_area .= HTMLELEMENT::hidden('task', 'save');
                $button = "<input class=\"button\" type=\"submit\" name=\"submit\" value=\"{$lang_cs_common['modify']}\">";
                break;
        }
        // main page
        starttable($CONFIG['picture_table_width'], $lang_cs_documents['documents'], 2);
        echo cpgTemplate::set($title, array(
                '{DESC}' => $nav,
                ));

        $link_array = cpgDB::fetchRowset("SELECT name FROM `{$CONFIG['TABLE_CS_DOCS']}` ORDER BY name DESC;");
        foreach($link_array as $value) {
            $nav .= "<li><a href=\"index.php?file=cpgshop/cpgshop_config&page=documents&task=edit&id={$value['name']}\">{$value['name']}</a></li>";
        }
        echo cpgTemplate::set($navigation, array(
                '{DOC_LIST}' => $nav,
                ));

        echo cpgTemplate::set($box, array(
                '{TEXT_BOX}' => $txt_area,
                '{SUBMIT}' => $button,
                ));
        endtable();
        return;
    }
    // -----------------------------------------------------------------------------------------
    // COUNTRIES
    // -----------------------------------------------------------------------------------------
    public static function shipping()
    {
        global $CONFIG;
        global $currency_symbol;
        global $lang_cs_common, $lang_cs_shipping;

		$markup_element_id = -1;

        // get ACTION
        if (cpgTool::post_var('task') == false) {
            $task = cpgTool::get_var('task');
        } else {
            $task = cpgTool::post_var('task');
        }
        // TEMPLATE
        $tpl_option = cpgTemplate::get('blog_shipping');
        $this_title = cpgTemplate::extract($tpl_option, 'title');
        $element = cpgTemplate::extract($tpl_option, 'element');
        $element_m = str_replace('tableb', 'tableh2', $element);
        $page_nav = cpgTemplate::extract($tpl_option, 'page_nav');
        $control = cpgTemplate::extract($tpl_option, 'control');
        $control_end = cpgTemplate::extract($tpl_option, 'control_end');
        $aoe = cpgTemplate::extract($tpl_option, 'aoe');
        // task -> action
        switch ($task) {
            case 'new':
                $vars = array(
                    '{GB_TITLE}' => $lang_cs_shipping['add_countries'],
                    '{COUNTRY_SET}' => HTMLelement::multiple_select('abbr', cpgTool::countries()),
                    '{TASK}' => "new_act",
                    '{LANG_COUNTRY}' => $lang_cs_shipping['lang_country'],
                    '{LANG_SUBMIT}' => $lang_cs_common['add'],
                    '{LANG_RESET}' => $lang_cs_common['reset'],
                    // '{LANG_CURRENCY}'	 =>	$lang_cs_common['currency'],
                    // '{CURRENCY}'		 =>	HTMLelement::simple_select("currency", $currency_symbol, $CONFIG['cpgshop_currency']),
                    );
                echo cpgTemplate::set($aoe, $vars);
                HTMLelement::spacer();
                break;
            // add new countries
            case 'new_act':

                $superCage = Inspekt::makeSuperCage();
                $abbr_array = $superCage->post->getRaw('abbr');
                $currency = cpgTool::post_var('currency');

                foreach($abbr_array as $value) {
                    $result = cpgDB::fetchRow("SELECT cid FROM `{$CONFIG['TABLE_CS_COUNTRY']}` WHERE abbr='{$value}' LIMIT 1");
                    if (!isset($result['cid'])) {
                        if (cpgDB::runQuery("INSERT INTO `{$CONFIG['TABLE_CS_COUNTRY']}` (cid, english_name, native_name, abbr, currency) VALUES ('', '" . cpgTool::country_by_code($value) . "', '', '$value', '" . $CONFIG['cpgshop_currency'] . "');")) {
                            $msg[] = sprintf($lang_cs_shipping['add_country_success'], $value);
                        }
                    }
                }
                // success message
                HTMLelement::message($lang_cs_common['message'], $msg);
                HTMLelement::spacer();
                break;
            case 'edit':
                $superCage = Inspekt::makeSuperCage();
                $edit_array = $superCage->post->getInt('edit');

                $english_name = cpgTool::post_var('english_name');
                $native_name = cpgTool::post_var('native_name');
                $shipping = cpgTool::post_var('shipping');

                foreach ($edit_array as $value => $key) {
                    if (cpgDB::runQuery("UPDATE `{$CONFIG['TABLE_CS_COUNTRY']}` SET english_name ='" . $english_name[$key] . "', native_name='" . $native_name[$key] . "', shipping='" . $shipping[$key] . "' WHERE cid = '$key' LIMIT 1;")) {
                        $msg[] = sprintf($lang_cs_shipping['edit_country_success'], $key);
                    }
                }
                HTMLelement::message($lang_cs_common['message'], $msg);
                HTMLelement::spacer();
                break;
            case 'del_shp':

                $superCage = Inspekt::makeSuperCage();
                $id_array = $superCage->post->getInt('id');
                $msg = array();
                foreach ($id_array as $delete_id) {
                    cpgDB::runQuery("DELETE FROM `{$CONFIG['TABLE_CS_COUNTRY']}` WHERE cid = '$delete_id' LIMIT 1;");
                    $msg[] = sprintf($lang_cs_shipping['del_country_success'], $delete_id);
                }
                HTMLelement::message($lang_cs_common['message'], $msg);
                HTMLelement::spacer();
                break;
        }
        // main page
        starttable($CONFIG['picture_table_width'], $lang_cs_shipping['shipping'], 6);
        // control box
        echo cpgTemplate::set($control, array(
                '{LANG_NEW}' => $lang_cs_shipping['add_country'],
                '{LANG_EDIT}' => $lang_cs_shipping['edit_country'],
                '{LANG_DEL}' => $lang_cs_shipping['del_country'],
                '{LANG_SURE}' => $lang_cs_common['are_you_sure'],
                ));
        $shipping_array = cpgDB::fetchRowset("SELECT * FROM `{$CONFIG['TABLE_CS_COUNTRY']}` ORDER BY cid DESC;");
        if (count($shipping_array) == 0) {
            echo HTMLelement::apply_simple_text(HTMLelement::simple_text(4), $lang_cs_shipping['no_shipping']);
        } else { // we have entries to display
            // title
            echo cpgTemplate::set($this_title, array(
                    '{LANG_TOGGLE_ALL}' => $lang_cs_common['toggle_all'],
                    '{COUNTRY_ENGLISH}' => $lang_cs_shipping['country_english'],
                    '{COUNTRY_NATIVE}' => $lang_cs_shipping['country_native'],
                    '{SHIPPING_FEE}' => $lang_cs_shipping['shipping_fee'],
                    '{CURRENCY}' => $lang_cs_shipping['currency'],
                    '{ABBREVIATION}' => $lang_cs_shipping['abbr'],
                    ));
            foreach ($shipping_array as $key => $country) {
                $cid = $country['cid'];
                $vars = array(
                    '{CHECK_BOX}' => HTMLelement::check_box("id[]", $cid),
                    '{HIDDEN}' => HTMLelement::hidden("edit[]", $cid),
                    '{COUNTRY_ENGLISH}' => HTMLelement::text_input("english_name[{$cid}]", $country['english_name']),
                    '{COUNTRY_NATIVE}' => HTMLelement::text_input("native_name[{$cid}]", $country['native_name']),
                    '{SHIPPING_FEE}' => HTMLelement::text_input("shipping[{$cid}]", $country['shipping']),
                    '{ABBREVIATION}' => $country['abbr'],
                    '{CURRENCY}' => $currency_symbol[$CONFIG['cpgshop_currency']],
                    );
                if ($country['cid'] == $markup_element_id)
                    echo cpgTemplate::set($element_m, $vars);
                else
                    echo cpgTemplate::set($element, $vars);
            }
            // page nav
            echo cpgTemplate::set($page_nav, array(
                    '{PAGE_NAV}' => "",
                    ));
            echo cpgTemplate::set($control_end, []);
        } //end else
        endtable();
        return;
    }
    // -----------------------------------------------------------------------------------------
    // DISCOUNTS
    // -----------------------------------------------------------------------------------------
    public static function discount()
    {
        global $CONFIG, $lang_cs_common, $lang_cs_discount;
        global $currency_symbol;

		$markup_element_id = -1;

    	//springclean - mark expired as invalid
     	$result = cpgDB::runQuery("UPDATE `{$CONFIG['TABLE_CS_DISCOUNT']}` SET valid ='2' WHERE valid='1' AND (expires-".localised_timestamp()." <= 0) AND (expires != 0);");

	    // get ACTION
        if (cpgTool::post_var('task') == false) {
            $task = cpgTool::get_var('task');
        } else {
            $task = cpgTool::post_var('task');
        }
        if (cpgTool::post_var('switch') == false) {
            $switch = cpgTool::get_var('switch');
        } else {
            $switch = cpgTool::post_var('switch');
        }

        if (!$switch) $switch = 'valid';
        // active or used
        if ($switch == 'used') {
            $switch_pagination = 'used';
            $type = 0; //for query
             $icon = cpg_fetch_icon('stop', 0);
        } elseif  ($switch == 'valid'){
            $switch_pagination = 'valid';
            $type = 1; //for query
            $icon = cpg_fetch_icon('ok', 0);
        } else {
        	$switch_pagination = 'expired';
        	$type = 2; //for query
        	$icon = cpg_fetch_icon('stop', 0);

        }
        // result sorting
        $switch_codes = array(
            'valid' 	=> '1',
            'used' 		=> '2',
        	'expired' 	=> '3',
        );
        $switch_box = "<select name=\"switch_select\" class=\"listbox\" onchange=\"if(this.options[this.selectedIndex].value) window.location.href='index.php?file=cpgshop/cpgshop_config&amp;page=discount&amp;task=switch&amp;switch='+this.options[this.selectedIndex].value;\">\n";
        foreach($switch_codes as $key => $value) {
            $selected = ($key == $switch) ? 'selected="selected"' : "";
            $switch_box .= "        <option value=\"" . $key . "\" $selected>" . $lang_cs_discount[$key] . "</option>\n";
        }
        $switch_box .= "</select>\n";
        // TEMPLATE
        $tpl_discount = cpgTemplate::get('blog_discount');
        $this_title = cpgTemplate::extract($tpl_discount, 'title');
        $element = cpgTemplate::extract($tpl_discount, 'element');
        $page_nav = cpgTemplate::extract($tpl_discount, 'page_nav');
        $control = cpgTemplate::extract($tpl_discount, 'control');
        $control_end = cpgTemplate::extract($tpl_discount, 'control_end');
        $aoe = cpgTemplate::extract($tpl_discount, 'aoe');
        $element_m = str_replace('tableb', 'tableh2', $element);
        $message = cpgTemplate::get('element_message');
        // task -> action
        switch ($task) {
            case 'del_act':
                // which one will be delete
                $superCage = Inspekt::makeSuperCage();
                $id_array = $superCage->post->getInt('id');

                $msg = array();
                foreach ($id_array as $delete_id) {
                    cpgDB::runQuery("DELETE FROM `{$CONFIG['TABLE_CS_DISCOUNT']}` WHERE did = '$delete_id' LIMIT 1;");
                    $msg[] = sprintf($lang_cs_discount['del_disocunt_success'], $delete_id);
                }
                HTMLelement::message($lang_cs_common['message'], $msg);
                HTMLelement::spacer();
                break;
            case 'new':
            	$exp_arr = array(0=>0,1=>1,2=>2,3=>3,4=>4,5=>5,6=>6,7=>7,10=>10,14=>14,21=>21,30=>30,60=>60,90=>90,180=>180,365=>365);
            	$num_arr = array(1=>1,5=>5,10=>10,25=>25,50=>50,100=>100,250=>250,500=>500,1000=>1000);
                $vars = array(
                    '{GB_TITLE}' => $lang_cs_discount['new_discount_title'],
                    '{TASK}' => "new_act",
                    '{LANG_VALUE}' => $lang_cs_common['value'],
                    '{VALUE}' => HTMLelement::text_input("value", ""),
	                '{EXPIRES}' => HTMLelement::simple_select("expires", $exp_arr, 0),
	                '{LANG_EXPIRES}' => $lang_cs_discount['expires'],
	                '{LANG_NUMBER}' => $lang_cs_common['number'],
                    '{NUMBER}' => HTMLelement::simple_select("number", $num_arr, 5),
                    '{LANG_SUBMIT}' => $lang_cs_common['add'],
                    '{LANG_RESET}' => $lang_cs_common['reset'],
                    );
                echo cpgTemplate::set($aoe, $vars);
                HTMLelement::spacer();
                break;
            case 'new_act':
                $value = cpgTool::price_format(cpgTool::post_var('value'));
                $number = (int)cpgTool::post_var('number');
            	$expires = (int)cpgTool::post_var('expires');

				$current_time = localised_timestamp();
            	if($expires){
            		$exp_time = (($current_time) + $expires * 24 * 60 * 60);
            	} else {
            		$exp_time = 0;
            	}

				for($i = 0; $i < $number; $i++) {
                    $result = cpgDB::runQuery("INSERT INTO `{$CONFIG['TABLE_CS_DISCOUNT']}` (did, number, discount, currency, valid, expires, created, user_id, order_id) VALUES ('', '" . cpgTool::encode_data(cpgTool::make_code($CONFIG['cpgshop_discount_code'])) . "', '$value', '" . $CONFIG['cpgshop_currency'] . "', '1', '$exp_time', '$current_time', '', '');");
                }
                // success message
                HTMLelement::message($lang_cs_common['message'], sprintf($lang_cs_price['add_price_success'], $title));
                HTMLelement::spacer();
                break;
        }
        // pagination
        if (cpgTool::get_var('start') == true) {
            $start = cpgTool::get_var('start');
        } else {
            $start = 0;
        }

        if (cpgTool::get_var('count') == true) {
            $count = cpgTool::get_var('count');
        } else {
            $count = 25;
        }
        $s1 = $count == 1 ? 'selected="selected"' : '';
        $s50 = $count == 50 ? 'selected="selected"' : '';
        $s75 = $count == 75 ? 'selected="selected"' : '';
        $s100 = $count == 100 ? 'selected="selected"' : '';

        $discount_array = cpgDB::fetchRowset("SELECT * FROM `{$CONFIG['TABLE_CS_DISCOUNT']}` WHERE valid='$type' ORDER BY did DESC LIMIT $start, $count;");
        $action = "index.php?file=cpgshop/cpgshop_config&page=discount&switch=" . $switch_pagination . '&amp;start=' . $start . '&amp;count=' . $count ;
        // getting the pic count for pagination
        $sql = "SELECT COUNT(*) FROM {$CONFIG['TABLE_CS_DISCOUNT']} WHERE valid='$type';";
        $result = cpgDB::runQuery($sql);

        list($pic_count) = cpg_db_fetch_row($result, true);

        $pic_count_text = sprintf($lang_cs_common['n_pic'], $pic_count);
        // pagination
        $next_target = "index.php?file=cpgshop/cpgshop_config&page=discount&switch=" . $switch_pagination . '&amp;start=' . ($start + $count) . '&amp;count=' . $count ;
        $prev_target = "index.php?file=cpgshop/cpgshop_config&page=discount&switch=" . $switch_pagination . '&amp;start=' . max(0, $start - $count) . '&amp;count=' . $count ;
        // editing an album
        if ($start + $count < $pic_count) {
            $next_link = "<a href=\"$next_target\"><strong>{$lang_cs_common['see_next']}</strong></a>&nbsp;&nbsp;-&nbsp;&nbsp;";
        } else {
            $next_link = '';
        }

        if ($start > 0) {
            $prev_link = "<a href=\"$prev_target\"><strong>{$lang_cs_common['see_prev']}</strong></a>&nbsp;&nbsp;-&nbsp;&nbsp;";
        } else {
            $prev_link = '';
        }
        $sel = <<<EOT
            <strong>$pic_count_text</strong>&nbsp;&nbsp;-&nbsp;&nbsp;
            $prev_link
            $next_link
            <strong>{$lang_cs_common['n_of_pic_to_disp']}</strong>
	        <select onchange="if(this.options[this.selectedIndex].value) window.location.href='index.php?file=cpgshop/cpgshop_config&page=discount&switch=$switch_pagination&amp;start=$start&amp;count='+this.options[this.selectedIndex].value;"  name="count" class="listbox">
	               <option value="25">25</option>
	               <option value="1" $s1>1</option>
	               <option value="50" $s50>50</option>
	               <option value="75" $s75>75</option>
	               <option value="100" $s100>100</option>
	       	</select>
EOT;
        // starttable
        starttable($CONFIG['picture_table_width'], $lang_cs_discount['switch_discount'] . ': ' . $switch_box, 7);
        // begin form
        echo cpgTemplate::set($begin_form, array(
                '{ACTION}' => $action,
                '{TASK}' => 'edit_act',
                ));
        // control box
        echo cpgTemplate::set($control, array(
                '{LANG_NEW}' => $lang_cs_discount['new_discount'],
                '{LANG_DEL}' => $lang_cs_discount['del_discount'],
                '{LANG_EDIT}' => $lang_cs_discount['edit_discount'],
		        '{LANG_SURE}' => $lang_cs_common['are_you_sure'],
                '{SWITCH_BUTTON}' => ''				// $switch_button,
                ));
        // title
        echo cpgTemplate::set($this_title, array(
                '{LANG_TOGGLE_ALL}' => $lang_cs_common['toggle_all'],
                '{LANG_NUMBER}' => $lang_cs_common['data'],
                '{LANG_DISCOUNT}' => $lang_cs_common['value'],
		        '{LANG_EXP}' => $lang_cs_discount['exp_title'],
                '{LANG_CURRENCY}' => $lang_cs_common['currency'],
                '{LANG_VALID}' => $lang_cs_common['valid'],
                '{LANG_OIDUID}' => $lang_cs_discount['oiduid'],
                ));
        // discount list
        if (count($discount_array) == 0)
        	echo HTMLelement::apply_simple_text(HTMLelement::simple_text(4), $lang_cs_discount['no_discount']);


		foreach ($discount_array as $discount) {
	    	if($discount['user_id'] && $discount['order_id']){
	    		$oiduid = HTMLElement::link('profile.php?uid='.$discount['user_id'], $lang_cs_discount['user']);
	    		$oiduid .= ' / ';
				$oiduid .= HTMLElement::link("index.php?file=cpgshop/cpgshop_config&amp;page=order&amp;display=view_act&amp;oid=" . $discount['order_id'],$lang_cs_discount['order']);
			}

    	if($exp_ret = cpgTool::discount_expired($discount['expires'], $discount['created'])) {
    		$expires = $exp_ret . ' ' . $lang_cs_discount['exp_days'];
    	} else {
    		$expires = $lang_cs_discount['discount_expired'];
    	}
            $vars = array(
                '{CHECK_BOX}' => HTMLelement::check_box("id[]", $discount['did']),
                '{NUMBER}' => cpgTool::decode_data($discount['number']),
                '{DISCOUNT}' => cpgTool::price_format($discount['discount']),
	            '{EXPIRES}' => $expires,
	            '{CURRENCY}' => $currency_symbol[$CONFIG['cpgshop_currency']],
                '{VALID}' => $icon,
                '{OIDUID}' => $oiduid,
                );
            // if used, print the link to order, user profile
            if ($discount['user_id']) {
                $oiduid = HTMLElement::link("profile.php?uid={$discount['user_id']}", $lang_cs_discount['user']);
                $oiduid .= ' :: ';
                $oiduid .= HTMLElement::link("index.php?file=cpgshop/cpgshop_config&amp;page=order&amp;display=view_act&amp;oid={$discount['order_id']}", $lang_cs_discount['order']);
            }

            if ($price['pid'] == $markup_element_id)
                echo cpgTemplate::set($element_m, $vars);
            else
                echo cpgTemplate::set($element, $vars);
        }
        // page nav
        echo cpgTemplate::set($page_nav, array(
                '{PAGE_NAV}' => $sel,
                ));
        echo cpgTemplate::set($control_end, []);
        endtable();
        return;
    }
    // -----------------------------------------------------------------------------------------
    // ORDER MANAGER
    // -----------------------------------------------------------------------------------------
    public static function order()
    {
        global $CONFIG;
        global $currency_symbol;
        global $lang_cs_order, $lang_cs_common, $lang_cs_cart, $lang_cs_error;
        global $lang_date;
        global $cpg_udb;
        // get ACTION
        $task = cpgTool::request_var('task');
        $move_state = cpgTool::request_var('move_state');
        $sort = cpgTool::request_var('sort');
        $display = cpgTool::request_var('display');
        $box = cpgTool::request_var('box');
        $oid = (int)cpgTool::get_var('oid');

        if ($box == '-1' || !$box || !isset($box)) $archive_sql = ''; //dispaly all
        else $archive_sql = "WHERE archive = '$box' ";
        // checkboxes
        $superCage = Inspekt::makeSuperCage();
        $id_array = $superCage->post->getInt('orders');

    	$action['5'] = $lang_cs_order['move_cancelled'];
    	$action['4'] = $lang_cs_order['move_processed'];
        if ($CONFIG['cpgshop_extra_states']) $action['3'] = $lang_cs_order['move_printed'];
        $action['2'] = $lang_cs_order['move_paid'];
        $action['1'] = $lang_cs_order['move_incoming'];
        $action['mark_new'] = $lang_cs_order['mark_new'];
        $action['mark_old'] = $lang_cs_order['mark_old'];
        // $action['mark_delete'] = $lang_cs_order['mark_delete'];
        // pagination
        if (cpgTool::request_var('start') == true) {
            $start = cpgTool::request_var('start');
        } else {
            $start = 0;
        }

        if (cpgTool::request_var('count') == true) {
            $count = cpgTool::request_var('count');
        } else {
            $count = 25;
        }
        // sorting
        $sort_codes = array(
            'oid_d' => 'oid DESC',
            'oid_a' => 'oid ASC',
            'uid_d' => 'user_id DESC',
            'uid_a' => 'user_id ASC',
            'new_d' => 'new DESC',
            'new_a' => 'new ASC',
            );
        $sort = (!isset($sort) || !isset($sort_codes[$sort])) ? 'oid_d' : $sort;

        $lb = "<select name=\"sort_listbox\" class=\"listbox\" onchange=\"if(this.options[this.selectedIndex].value) window.location.href='index.php?file=cpgshop/cpgshop_config&amp;page=order&amp;box=$box&amp;start=$start&amp;count=$count&amp;sort='+this.options[this.selectedIndex].value;\">\n";
        foreach($sort_codes as $key => $value) {
            $selected = ($key == $sort) ? 'selected="selected"' : "";
            $lb .= "        <option value=\"" . $key . "\" $selected>" . $lang_cs_order[$key] . "</option>\n";
        }
        $lb .= "</select>\n";

        $s1 = $count == 1 ? 'selected="selected"' : '';
        $s50 = $count == 50 ? 'selected="selected"' : '';
        $s75 = $count == 75 ? 'selected="selected"' : '';
        $s100 = $count == 100 ? 'selected="selected"' : '';
        // pagination end
        // dropdeown tasks
        $switch_codes = array(
            '-1' => 'all',
            '1' => 'incoming',
            '2' => 'paid',
            '3' => 'printed',
            '4' => 'processed',
        	'5' => 'cancelled',
        );
        if (!$CONFIG['cpgshop_extra_states']) unset($switch_codes['3']);

        $lbox = "<select name=\"sort_listbox\" class=\"listbox\" onchange=\"if(this.options[this.selectedIndex].value) window.location.href='index.php?file=cpgshop/cpgshop_config&amp;page=order&amp;sort=$sort&amp;start=$start&amp;count=$count&amp;box='+this.options[this.selectedIndex].value;\">\n";
        foreach($switch_codes as $key => $value) {
            $selected = ($key == $box) ? 'selected="selected"' : "";
            $lbox .= "        <option value=\"" . $key . "\" $selected>" . $lang_cs_order[$value] . "</option>\n";
        }
        $lbox .= "</select>\n";
        // dropdeown tasks end
        // TEMPLATE
        $tpl_order = cpgTemplate::get('blog_order');
        $order_title = cpgTemplate::extract($tpl_order, 'order_title');
        $order_element = cpgTemplate::extract($tpl_order, 'order_element');
        $order_footer = cpgTemplate::extract($tpl_order, 'order_footer');
        $order_legend = cpgTemplate::extract($tpl_order, 'order_legend');

        switch ($move_state) {
            case 'mark_new':
                foreach($id_array as $value) {
                    $result = cpgDB::runQuery(("UPDATE {$CONFIG['TABLE_CS_ORDER']} SET new='1' WHERE oid ='" . $value . "'"));
                    $msg[] = sprintf($lang_cs_order['order_modified'], $value);
                }
                HTMLelement::message($lang_cs_common['message'], $msg);
                HTMLelement::spacer();
                break;
            case 'mark_old':
                foreach($id_array as $value) {
                    $result = cpgDB::runQuery(("UPDATE {$CONFIG['TABLE_CS_ORDER']} SET new='0' WHERE oid ='" . $value . "'"));
                    $msg[] = sprintf($lang_cs_order['order_modified'], $value);
                }
                HTMLelement::message($lang_cs_common['message'], $msg);
                HTMLelement::spacer();
                break;
            case 'mark_delete':
                // not to be used
                break;
            default:
                if (is_numeric($move_state)) {
                    foreach($id_array as $value) {
                    	$archive = cpgDB::fetchRow("SELECT archive FROM {$CONFIG['TABLE_CS_ORDER']} WHERE oid='" . $value . "';");
                    	//if we have a cancelled order don't allow a move
                    	if ($archive['archive'] != 5) {
	                        $result = cpgDB::runQuery(("UPDATE {$CONFIG['TABLE_CS_ORDER']} SET archive='" . $move_state . "' WHERE oid ='" . $value . "'"));
	                        $msg[] = sprintf($lang_cs_order['order_modified'], $value);
                    	} else {
                    		$msg[] = sprintf($lang_cs_order['order_no_move'], $value);
                    	}
					}
                    HTMLelement::message($lang_cs_common['message'], $msg);
                    HTMLelement::spacer();
                }
        } // switch

    	$archive = cpgDB::fetchRow("SELECT archive FROM {$CONFIG['TABLE_CS_ORDER']} WHERE oid='" . $oid . "';");
    	//if we have a cancelled order don't allow actions
    	if ($archive['archive'] == 5 && $display == 'view_act') {
    		$msg[] = sprintf($lang_cs_order['order_no_work'], $oid);
    		HTMLelement::message($lang_cs_common['message'], $msg);
    		HTMLelement::spacer();
		} else {
    		switch ($task) {
	            case "paypal_log":
	                $row = cpgDB::fetchRow("SELECT log FROM {$CONFIG['TABLE_CS_PAYPAL_LOG']} WHERE invoice='" . $oid . "' LIMIT 1;");

	                starttable();
	                $array = cpgTool::decode_data($row['log']);
	                foreach ($array as $key => $value) {
	                    echo "<tr><td>$key:</td><td>$value</td></tr>\n";
	                }

	                echo <<<EOT
					<tr>
						<td align="center" colspan="2">
							<form>
								<input onclick="javascript: window.close();" class="button largefont" type="button" value="{$lang_cs_order['close']}">
							</form>
						</td>
					</tr>
EOT;
	                endtable();
	                pagefooter();
	                die();
	                break;
	            case "create_dir":
	                $result = cpgDB::fetchRow("SELECT user_id, cship, cdown, sent, sentd FROM {$CONFIG['TABLE_CS_ORDER']} WHERE oid='" . $oid . "' LIMIT 1;");

	                if (cpgTool::ipn_download_dir($result['user_id'], $oid, true)) {
	                    HTMLelement::message($lang_cs_common['message'], sprintf($lang_cs_order['create_dir_succ'], $oid));
	                    HTMLelement::spacer();

	                    if ($CONFIG['cpgshop_states_auto_move']) {
	                        // query some data... we need to do that outside the if cause we need for state change emails the uid
	                        // $result = cpgDB::fetchRow("SELECT user_id, cdown, cship, sent, sentd FROM {$CONFIG['TABLE_CS_ORDER']} WHERE oid='".$invoice."';");
	                        // send state changed email
	                        cpgTool::email_state_change($result['user_id'], $oid, 'state_change_downloaded');
	                        // check if not shipping but just to download... in that case we can move to sent
	                        if (!$result['cship'] && $result['cdown']) {
	                            $result2 = cpgDB::runQuery(("UPDATE {$CONFIG['TABLE_CS_ORDER']} SET archive = '4' WHERE oid ='" . $oid . "'"));
	                        }
	                    }
	                }
	                unset($result);
	                break;
	            case "resend_pwd":
	                $result = cpgDB::fetchRow("SELECT user_id FROM {$CONFIG['TABLE_CS_ORDER']} WHERE oid='" . $oid . "' LIMIT 1;");

	                if (cpgTool::ipn_send_password($result['user_id'], $oid)) {
	                    HTMLelement::message($lang_cs_common['message'], sprintf($lang_cs_order['resend_pwd_succ'], $oid));
	                    HTMLelement::spacer();
	                }
	                unset($result);
	                break;
	            case "resend_invoice":
	                $result = cpgDB::fetchRow("SELECT user_id, profile, cart FROM {$CONFIG['TABLE_CS_ORDER']} WHERE oid='" . $oid . "' LIMIT 1;");

	                $profile_data = unserialize($result['profile']);
	                $cart_data = unserialize($result['cart']);

	                if (cpgTool::cpgshop_order_confirmation_mail(USER_ID, $oid, $cart_data, $profile_data, false)) {
	                    HTMLelement::message($lang_cs_common['message'], sprintf($lang_cs_order['resend_invoice_succ'], $oid));
	                    HTMLelement::spacer();
	                }
	                unset($result);
	                break;
	            case "del_dir":
	                $result = cpgDB::fetchRow("SELECT user_id FROM {$CONFIG['TABLE_CS_ORDER']} WHERE oid='" . $oid . "' LIMIT 1;");

	                if (cpgTool::download_dir_springbreak($result['user_id'], $oid)) {
	                    HTMLelement::message($lang_cs_common['message'], sprintf($lang_cs_order['del_dir_succ'], $oid));
	                    HTMLelement::spacer();
	                }
	                unset($result);
	                break;
	            case "lock_dir":
	                $result = cpgDB::fetchRow("SELECT user_id FROM {$CONFIG['TABLE_CS_ORDER']} WHERE oid='" . $oid . "' LIMIT 1;");

	                if (cpgTool::lock_download_dir($result['user_id'], $oid)) {
	                    HTMLelement::message($lang_cs_common['message'], sprintf($lang_cs_order['lock_dir_succ'], $oid));
	                    HTMLelement::spacer();
	                } else {
	                    HTMLelement::message($lang_cs_common['message'], sprintf($lang_cs_order['lock_dir_fail'], $oid));
	                    HTMLelement::spacer();
	                }
	                unset($result);
	                break;
	            default:
	                $do = array(
	                    'mark_sent' => array('sql' => "sent='1'", 'move' => 4, 'template' => 'state_change_paid'),
	                    'unmark_sent' => array('sql' => "sent='0'", 'move' => 2, 'template' => ''),
	                    'mark_downloaded' => array('sql' => "sentd='1'", 'move' => 4, 'template' => 'state_change_downloaded'),
	                    'unmark_downloaded' => array('sql' => "sentd='0'", 'move' => 2, 'template' => ''),
	                    'mark_paid' => array('sql' => "paid='1'", 'move' => 2, 'template' => 'state_change_paid'),
	                    'unmark_paid' => array('sql' => "paid='0'", 'move' => 1, 'template' => ''),
	                    );
	                if ($CONFIG['cpgshop_extra_states']) {
	                    $do['mark_printed'] = array('sql' => "printed='1'", 'move' => 3, 'template' => 'state_change_printed');
	                    $do['unmark_printed'] = array('sql' => "printed='0'", 'move' => 2, 'template' => '');
	                    $do['unmark_downloaded']['move'] = 3;
	                    $do['unmark_sent']['move'] = 3;
	                }

	                if ($task && array_key_exists($task, $do)) {
		                $result = cpgDB::runQuery(("UPDATE {$CONFIG['TABLE_CS_ORDER']} SET " . $do[$task]['sql'] . " WHERE oid ='" . (int)$oid . "'"));
	                    HTMLelement::message($lang_cs_common['message'], sprintf($lang_cs_order['order_modified'], $oid));
	                    HTMLelement::spacer();
	                    // automatically move items to their virtual folders
	                    if ($CONFIG['cpgshop_states_auto_move']) {
	                        // query some data... we need to do that outside the if cause we need for state change emails the uid
	                        $result = cpgDB::fetchRow("SELECT user_id, cdown, cship, sent, sentd FROM {$CONFIG['TABLE_CS_ORDER']} WHERE oid='" . (int)$oid . "';");
	                        if ($task == 'mark_sent' || $task == 'mark_downloaded') {
	                            if ($do[$task]['template'] != '')
	                                cpgTool::email_state_change($result['user_id'], $oid, $do[$task]['template']);
	                            // check if pure download, shipping or both
	                            if ($result['cship'] && $result['cdown']) {
	                                // only update if one of this methods is already set.. so both are shipped, downloaded
	                                if (($result['sent'] &$result['sentd']) == 1) {
	                                    // do the move sql update
	                                    $result2 = cpgDB::runQuery(("UPDATE {$CONFIG['TABLE_CS_ORDER']} SET archive = '" . $do[$task]['move'] . "' WHERE oid ='" . (int)$oid . "'"));
	                                }
	                            } else {
	                                // theres just a download or a to ship item... we update
	                                $result2 = cpgDB::runQuery(("UPDATE {$CONFIG['TABLE_CS_ORDER']} SET archive = '" . $do[$task]['move'] . "' WHERE oid ='" . (int)$oid . "'"));
	                            }
	                        } else {
	                            $result2 = cpgDB::runQuery(("UPDATE {$CONFIG['TABLE_CS_ORDER']} SET archive = '" . $do[$task]['move'] . "' WHERE oid ='" . (int)$oid . "'"));
	                            if ($do[$task]['template'] != '')
	                                cpgTool::email_state_change($result['user_id'], $oid, $do[$task]['template']);
	                        }
	                    }
	                }
	                break;
	        } //end switch
        // to display the single order
    	}

        if ($display == 'view_act') {
            // grab profile array from the db
            $result = cpgDB::runQuery(("UPDATE {$CONFIG['TABLE_CS_ORDER']} SET new='0' WHERE oid ='" . $oid . "'"));
            $result = cpgDB::fetchRow("SELECT user_id, profile, cart, note, time, dtime, cdown, cship, paid, sent, sentd, printed, new, archive, status FROM {$CONFIG['TABLE_CS_ORDER']} WHERE oid='" . (int)$oid . "';");

            $profile_data = unserialize($result['profile']);
            $user_info = $cpg_udb->get_user_infos($result['user_id']);
            $cart_data = unserialize($result['cart']);

            $additional_info = (cpgTool::decode_data($result['note']));
            if ($cart_data) {
                $order_address = cpgTemplate::extract($tpl_order, 'order_address');
                $billing_address = cpgTool::verify_billingshipping_info('', $profile_data['billing_address']);
                $order_back = cpgTemplate::extract($tpl_order, 'back_button');
                $order_action = cpgTemplate::extract($tpl_order, 'action_buttons');

                if ($profile_data['delivery']['method'] == 'download') {
                    $shipping_address = $billing_address;
                } else {
                    $shipping_address = cpgTool::verify_billingshipping_info('', $profile_data['shipping_address']);
                }
                // check if pure download, shipping or both
                $shipping = $result['cship'];
                $download = $result['cdown'];;

                if ($download && $shipping) $spacer = " :: ";
                // create icons and set/ unset buttons
                $button_link = "index.php?file=cpgshop/cpgshop_config&amp;page=order&amp;box=" . $box . '&amp;sort=' . $sort . '&amp;start=' . $start . '&amp;oid=' . $oid . '&amp;count=' . $count ;
                $view_act = "&amp;display=view_act";
                $icon_new = "{$lang_cs_order['v']}<img src=\"plugins/cpgshop/images/s_" . ($result['new'] ? 'new' : 'old') . ".gif\" alt=\"\" border=\"0\" /><br />";
                $icon_booked =
                "<input onclick=\"window.location.href='{$button_link}{$view_act}&amp;task=mark_paid'\" class=\"button\" type=\"button\" value=\"{$lang_cs_order['set']}\">"
                 . "<input onclick=\"window.location.href='{$button_link}{$view_act}&amp;task=unmark_paid'\" class=\"button\" type=\"button\" value=\"{$lang_cs_order['unset']}\">"
                 . " {$lang_cs_order['b']}<img src=\"plugins/cpgshop/images/s_" . ($result['paid'] ? 'pos' : 'neg') . ".gif\" alt=\"\" border=\"0\" /><br />";
                if ($shipping)
                    $icon_sent =
                    "<input onclick=\"window.location.href='{$button_link}{$view_act}&amp;task=mark_sent'\" class=\"button\" type=\"button\" value=\"{$lang_cs_order['set']}\">"
                     . "<input onclick=\"window.location.href='{$button_link}{$view_act}&amp;task=unmark_sent'\" class=\"button\" type=\"button\" value=\"{$lang_cs_order['unset']}\">"
                     . " {$lang_cs_order['s']}<img src=\"plugins/cpgshop/images/s_" . ($result['sent'] ? 'pos' : 'neg') . ".gif\" alt=\"\" border=\"0\" /><br />";
                else $icon_sent = '';
                if ($download)
                    $icon_down =
                    "<input onclick=\"window.location.href='{$button_link}{$view_act}&amp;task=mark_downloaded'\" class=\"button\" type=\"button\" value=\"{$lang_cs_order['set']}\">"
                     . "<input onclick=\"window.location.href='{$button_link}{$view_act}&amp;task=unmark_downloaded'\" class=\"button\" type=\"button\" value=\"{$lang_cs_order['unset']}\">"
                     . " {$lang_cs_order['d']}<img src=\"plugins/cpgshop/images/s_" . ($result['sentd'] ? 'pos' : 'neg') . ".gif\" alt=\"\" border=\"0\" /><br />";
                else $icon_down = '';
                if ($CONFIG['cpgshop_extra_states'] && $shipping)
                    $icon_print =
                    "<input onclick=\"window.location.href='{$button_link}{$view_act}&amp;task=mark_printed'\" class=\"button\" type=\"button\" value=\"{$lang_cs_order['set']}\">"
                     . "<input onclick=\"window.location.href='{$button_link}{$view_act}&amp;task=unmark_printed'\" class=\"button\" type=\"button\" value=\"{$lang_cs_order['unset']}\">"
                     . " {$lang_cs_order['p']}<img src=\"plugins/cpgshop/images/s_" . ($result['printed'] ? 'pos' : 'neg') . ".gif\" alt=\"\" border=\"0\" /><br />";
                else $icon_print = '';
                // paypal status
                $paypal_status = '';
                if ($profile_data['gateway']['method'] == 'paypal' && $CONFIG['cpgshop_paypal_use_ipn']) {
                    $pp_fee = cpgDB::fetchRow("SELECT pp_fee, pp_currency FROM {$CONFIG['TABLE_CS_PAYPAL_LOG']} WHERE invoice='" . $oid . "';");

                    $paypal_status = "<strong>{$lang_cs_order['paypal_status']}:</strong> {$result['status']}<br><strong>{$lang_cs_order['paypal_fee']}:</strong> {$currency_symbol[$pp_fee['pp_currency']]} {$pp_fee['pp_fee']}";
                }
                // create the action buttons for the detailed view
                // create button - used for the manual process (not ipn)
                $resend_invoice = "<input onclick=\"window.location.href='{$button_link}&amp;task=resend_invoice&amp;display=view_act'\" class=\"button largefont\" type=\"button\" value=\"{$lang_cs_order['resend_invoice']}\">";
                if ($CONFIG['cpgshop_download_enable'] == '1') {
                    if ($profile_data['gateway']['method'] == 'paypal' && $CONFIG['cpgshop_paypal_use_ipn']) {
                        // do we have an IPN log entry... yes, then display [P] button
                        $result_gateway = cpgDB::runQuery("SELECT COUNT(*) FROM {$CONFIG['TABLE_CS_PAYPAL_LOG']} WHERE invoice='" . $oid . "'");
                        if (cpg_db_fetch_row($result_gateway, true)) {
                            $paypal_log_button = "<input onclick=\"MM_openBrWindow('{$button_link}&amp;task=paypal_log','" . uniqid(rand()) . "','scrollbars=yes,toolbar=no,status=no,locationbar=no,resizable=yes,width=560,height=340');\" class=\"button largefont\" type=\"button\" value=\"{$lang_cs_order['paypal_log']}\">";
                        }
                    }
                    if ($download) {
                        // create button - used for the manual process (not ipn)
                        $create_dir_button = "<input onclick=\"window.location.href='{$button_link}&amp;task=create_dir&amp;display=view_act'\" class=\"button largefont\" type=\"button\" value=\"{$lang_cs_order['create_dir']}\">";
                        // resend pwd
                        $resend_pwd_button = "<input onclick=\"window.location.href='{$button_link}&amp;task=resend_pwd&amp;display=view_act'\" class=\"button largefont\" type=\"button\" value=\"{$lang_cs_order['resend_pwd']}\">";
                        // delete dir
                        $del_dir_button = "<input onclick=\"window.location.href='{$button_link}&amp;task=del_dir&amp;display=view_act'\" class=\"button largefont\" type=\"button\" value=\"{$lang_cs_order['del_dir']}\">";
                        // delete dir
                        $lock_dir_button = "<input onclick=\"window.location.href='{$button_link}&amp;task=lock_dir&amp;display=view_act'\" class=\"button largefont\" type=\"button\" value=\"{$lang_cs_order['lock_dir']}\">";
                    }
                }
                // download time (dir created)
                if ($result['dtime'] != 0) {
                    $dtime = localised_date($result['dtime'], $lang_date['log']);
                    $lang_dtime = $lang_cs_order['download_time'];
                } else {
                    $dtime = '';
                    $lang_dtime = '';
                }
                // start with the output of the back button
                starttable($CONFIG['picture_table_width'], $lang_cs_order['order_detail'] . ': ' . sprintf($lang_cs_order['orderid'], $oid, $date)); // .$lang_cs_order['orderid'] . ' ' . $oid . ' - ' . $date);
                echo cpgTemplate::set($order_back, array(
                        '{BACK}' => "<input onclick=\"window.location.href='{$button_link}'\" class=\"button largefont\" type=\"button\" value=\"{$lang_cs_order['back']}\">",
                		));
                endtable();
                // output address lists and info
                starttable();
                echo cpgTemplate::set($order_address, array(
                        '{ICON_V}' => '', // $icon_new,
                        '{ICON_B}' => $icon_booked,
                        '{ICON_P}' => $icon_print,
                        '{ICON_S}' => $icon_sent,
                        '{ICON_D}' => $icon_down,
                        '{LEGEND}' => $lang_cs_order['legend'],
                        '{DELIVERY_METHOD}' => ($profile_data['delivery']['method'] == 'download') ? $lang_cs_order['download'] : $lang_cs_cart['cpgshop_' . $profile_data['delivery']['method'] . '_enable'],
                        '{GATEWAY_METHOD}' => $lang_cs_cart['cpgshop_' . $profile_data['gateway']['method'] . '_enable'],
                        '{LANG_DELIVERY_METHOD}' => $lang_cs_order['delivery_method'],
                        '{LANG_GATEWAY_METHOD}' => $lang_cs_order['gateway_method'],
                        '{LANG_TYPE_SHIPPING}' => $lang_cs_order['cart_type'],
                        '{LANG_DOWNLOADED}' => $lang_dtime,
                        '{DATE}' => $dtime,
                        '{TYPE_SHIPPING}' => $download ? $lang_cs_order['download_items'] : '',
                        '{TYPE_DOWNLOAD}' => $shipping ? $spacer . $lang_cs_order['shipping_items'] : '',
                        '{PAYPAL_STATUS}' => $paypal_status,
                        '{ADDRESS_BILLING}' => $billing_address,
                        '{ADDRESS_SHIPPING}' => $shipping_address,
                        '{LANG_BILLING}' => $lang_cs_order['address_data'],
                        '{LANG_SHIPPING}' => $lang_cs_order['shipping_addr'],
                        '{LANG_TEXT}' => $lang_cs_order['additional_info'],
                        '{LANG_INFO}' => $lang_cs_order['information'],
                        '{TEXTFIELD}' => HTMLElement::text_area('additional_info', $additional_info, 50, 4),
                        '{EMAIL}' => "<a href=\"mailto:{$user_info['user_email']}\">{$user_info['user_email']}</a>",
                        '{PROFILE}' => HTMLElement::link("profile.php?uid={$result['user_id']}", $user_info['user_name']),
                        ));
                endtable();
                // action button table
                starttable();
                echo cpgTemplate::set($order_action, array(
                        '{BUTTON_LIST}' => $paypal_log_button . $create_dir_button . $del_dir_button . $lock_dir_button . $resend_pwd_button . $resend_invoice,
                        ));
                endtable();

                starttable();
                // echo cpgTool::verify_billingshipping_info('',$profile_data['gateway']);
                echo HTMLelement::prev_cart($cart_data, $profile_data, 'html_plain');
                HTMLelement::spacer();
                endtable();

                starttable();
                echo cpgTemplate::set($order_back, array(
                        '{BACK}' => "<input onclick=\"window.location.href='{$button_link}'\" class=\"button largefont\" type=\"button\" value=\"{$lang_cs_order['back']}\">",
                        ));
                endtable();
                return;
            }
        }

        // main
		//before we output anything lets do the download folder cleanup
    	//before we display the order list, we check for to delete download dirs
   		if ($CONFIG['cpgshop_download_enable'] && $CONFIG['cpgshop_del_download_dir'] > 0) { //it's set
   			$time = localised_timestamp() - $CONFIG['cpgshop_del_download_dir'] * 3600;

   			$result = cpgDB::runQuery("SELECT oid, user_id FROM {$CONFIG['TABLE_CS_ORDER']} WHERE dtime < '$time' AND dtime > '0';");

   			if (cpg_db_num_rows($result) > 0) {
   				$rowset = cpg_db_fetch_rowset($result, true);
   				foreach ($rowset as $value) {
   					if ($value['oid'] && $value['user_id']) {
   						cpgTool::download_dir_springbreak($value['user_id'], $value['oid']);
   					}
   				}
   			}
   		}

        starttable($CONFIG['picture_table_width'], $lang_cs_order['order_title'] . ' :: ' . $lbox, 4);
        // starttable($CONFIG['picture_table_width'], $lang_cs_order['order_title'] . ' :: ' . "<a href=\"index.php?file=cpgshop/cpgshop_config&page=order&box=".($box ^ 1) ."\">{$lang_cs_order[$box]}</a>", 4);
        echo cpgTemplate::set($order_title, array(
                '{LANG_STATUS}' => $lang_cs_order['order_status'],
                '{LANG_ORDER}' => $lang_cs_order['order_detail'],
                '{LANG_USER}' => $lang_cs_order['username'],
                '{LANG_TOGGLE_ALL}' => $lang_cs_common['toggle_all'],
                ));
        $order_array = cpgDB::fetchRowset("SELECT oid, user_id, user_name, cart, gross, item_count, time, status, txnid, payment, delivery, tax, note, cdown, cship, paid, sent, sentd, printed, new, archive FROM `{$CONFIG['TABLE_CS_ORDER']}` " . $archive_sql . " ORDER BY " . $sort_codes[$sort] . " LIMIT $start, $count;");
        // getting the pic count for pagination
        $sql = "SELECT COUNT(*) FROM {$CONFIG['TABLE_CS_ORDER']} " . $archive_sql . ";";
        $result = cpgDB::runQuery($sql);

        list($order_count) = cpg_db_fetch_row($result, true);

        $order_count_text = sprintf($lang_cs_common['n_pic'], $order_count);
        // pagination
        $next_target = "index.php?file=cpgshop/cpgshop_config&amp;page=order&amp;box=" . $box . '&amp;sort=' . $sort . '&amp;start=' . ($start + $count) . '&amp;count=' . $count ;
        $prev_target = "index.php?file=cpgshop/cpgshop_config&amp;page=order&amp;box=" . $box . '&amp;sort=' . $sort . '&amp;start=' . max(0, $start - $count) . '&amp;count=' . $count ;

        if ($start + $count < $order_count) {
            $next_link = "<a href=\"$next_target\"><strong>{$lang_cs_common['see_next']}</strong></a>&nbsp;&nbsp;-&nbsp;&nbsp;";
        } else {
            $next_link = '';
        }

        if ($start > 0) {
            $prev_link = "<a href=\"$prev_target\"><strong>{$lang_cs_common['see_prev']}</strong></a>&nbsp;&nbsp;-&nbsp;&nbsp;";
        } else {
            $prev_link = '';
        }
        $sel = <<<EOT
            <strong>$order_count_text</strong>&nbsp;&nbsp;-&nbsp;&nbsp;
            $prev_link
            $next_link
            <strong>{$lang_cs_common['n_of_pic_to_disp']}</strong>
	        <select onchange="if(this.options[this.selectedIndex].value) window.location.href='index.php?file=cpgshop/cpgshop_config&amp;page=order&amp;sort=$sort&amp;box=$box&amp;start=$start&amp;count='+this.options[this.selectedIndex].value;"  name="count" class="listbox">
	               <option value="25">25</option>
	               <option value="1" $s1>1</option>
	               <option value="50" $s50>50</option>
	               <option value="75" $s75>75</option>
	               <option value="100" $s100>100</option>
	       	</select>
EOT;
        // end pagination
        // to download and / or shipping -> display info -> and icons sent / unsent -  downloaded or not
        foreach ($order_array as $order) {
            // check if pure download, shipping or both in the cart of the actual order
            $shipping = $order['cship'];
            $download = $order['cdown'];
            // create icons
            $icon_new = "{$lang_cs_order['v']}<img src=\"plugins/cpgshop/images/s_" . ($order['new'] ? 'new' : 'old') . ".gif\" alt=\"\" border=\"0\" /><br />";
            $icon_paid = "{$lang_cs_order['b']}<img src=\"plugins/cpgshop/images/s_" . ($order['paid'] ? 'pos' : 'neg') . ".gif\" alt=\"\" border=\"0\" /><br />";
            if ($shipping)
                $icon_sent = "{$lang_cs_order['s']}<img src=\"plugins/cpgshop/images/s_" . ($order['sent'] ? 'pos' : 'neg') . ".gif\" alt=\"\" border=\"0\" /><br />";
            else $icon_sent = '';
            if ($download)
                $icon_down = "{$lang_cs_order['d']}<img src=\"plugins/cpgshop/images/s_" . ($order['sentd'] ? 'pos' : 'neg') . ".gif\" alt=\"\" border=\"0\" /><br />";
            else $icon_down = '';
            if ($CONFIG['cpgshop_extra_states'] && $shipping)
                $icon_print = " {$lang_cs_order['p']}<img src=\"plugins/cpgshop/images/s_" . ($order['printed'] ? 'pos' : 'neg') . ".gif\" alt=\"\" border=\"0\" /><br />";
            else $icon_print = '';
            // output everything
            echo cpgTemplate::set($order_element, array(
                    '{USER_PROFILE_LINK}' => HTMLelement::link("profile.php?uid=" . $order['user_id'], $order['user_name']),
                    '{ICON_V}' => $icon_new,
                    '{ICON_B}' => $icon_paid,
                    '{ICON_S}' => $icon_sent,
                    '{ICON_P}' => $icon_print,
                    '{ICON_D}' => $icon_down,
                    '{ORDER_DATE}' => localised_date($order['time'], $lang_date['log']),
                    '{ITEM_COUNT}' => $lang_cs_order['noitems'] . ': ' . $order['item_count'],
                    '{GROSS}' => sprintf($lang_cs_order['gross'], $currency_symbol[$CONFIG['cpgshop_currency']] . ' ' . $order['gross']),
                    '{ORDER_ID}' => $lang_cs_order['orderid'] . ': ' . $order['oid'],
                    '{USER_ID}' => $lang_cs_order['userid'] . ': ' . $order['user_id'],
                    '{BUTTON_LIST}' => '',
                    '{LANG_ZIP}' => $lang_cs_order['download_zip'],
                    '{LINK}' => "index.php?file=cpgshop/cpgshop_config&amp;page=order&amp;display=view_act&amp;oid={$order['oid']}&amp;box={$box}&amp;start={$start}&amp;count={$count}&amp;sort={$sort}",
                    '{OID}' => $order['oid'],
                    ));
        }
        if (!$order_array) echo "<tr><td colspan=\"4\" class=\"tableb_alternate\" align=\"center\"> {$lang_cs_error['nothing_display']}</td></tr>";

        endtable();
        starttable();

        $hidden = HTMLElement::hidden('start', $start);
        $hidden .= HTMLElement::hidden('count', $count);
        $hidden .= HTMLElement::hidden('box', $box);
        $hidden .= HTMLElement::hidden('sort', $sort);

        echo cpgTemplate::set($order_footer, array(
                '{SORT_BY}' => $lang_cs_order['sort_by'] . ' ' . $lb,
                '{PAGINATION}' => $sel,
                '{ACTION}' => HTMLElement::simple_select('move_state', $action, null, ''),
                '{LANG_SUBMIT}' => $lang_cs_order['go'],
                '{HIDDEN}' => $hidden,
                ));

        endtable();
        starttable();
        echo cpgTemplate::set($order_legend, array(
                '{LEGEND}' => $lang_cs_order['legend'],
                ));
        endtable();
        return;
    }
    // -----------------------------------------------------------------------------------------
    // OPTION SET MANAGER
    // -----------------------------------------------------------------------------------------
    public static function option_set()
    {
        global $CONFIG;
        global $currency_symbol;
        global $lang_cs_common, $lang_cs_optionset;

		$markup_element_id = -1;

        // get ACTION
        if (cpgTool::post_var('task') == false) {
            $task = cpgTool::get_var('task');
        } else {
            $task = cpgTool::post_var('task');
        }
        // TEMPLATE
        $tpl_option_set = cpgTemplate::get('blog_option_set');
        $this_title = cpgTemplate::extract($tpl_option_set, 'title');
        $element = cpgTemplate::extract($tpl_option_set, 'element');
        $element_m = str_replace('tableb', 'tableh2', $element);
        $page_nav = cpgTemplate::extract($tpl_option_set, 'page_nav');
        $control = cpgTemplate::extract($tpl_option_set, 'control');
        $control_end = cpgTemplate::extract($tpl_option_set, 'control_end');
        $aoe = cpgTemplate::extract($tpl_option_set, 'aoe');
        // task -> action
        switch ($task) {
            case 'new':
                // get a price list
                $rowset = cpgDB::fetchRowset("SELECT oid, title FROM `{$CONFIG['TABLE_CS_OPTION']}` ORDER BY title ASC;");
                $option_array = array();
                foreach ($rowset as $row) {
                    $option_array[$row['oid']] = $row['title'];
                }
                // vars
                $vars = array(
                    '{GB_TITLE}' => $lang_cs_optionset['new_optionset_title'],
                    '{ID}' => "",
                    '{TASK}' => "new_act",
                    '{LANG_TITLE}' => $lang_cs_common['title'],
                    '{TITLE}' => HTMLelement::text_input("title", ""),
                    '{LANG_OPTION_SET}' => $lang_cs_common['optionset'],
                    '{OPTION_SET}' => HTMLelement::multiple_select('option_set', $option_array),
                    '{LANG_SUBMIT}' => $lang_cs_common['add'],
                    '{LANG_RESET}' => $lang_cs_common['reset'],
                    );
                echo cpgTemplate::set($aoe, $vars);
                HTMLelement::spacer();
                break;
            case 'new_act':
                $title = addslashes(cpgTool::post_var('title'));
                $option_set = cpgTool::encode_data(cpgTool::post_var('option_set'));
                $result = cpgDB::runQuery("INSERT INTO `{$CONFIG['TABLE_CS_OPTIONSET']}` (oid, title, option_array) VALUES ('', '$title', '$option_set');");
                $markup_element_id = cpgDB::insertID();
                // success message
                HTMLelement::message($lang_cs_common['message'], sprintf($lang_cs_optionset['add_optionset_success'], $title));
                HTMLelement::spacer();
                break;
            case 'edit':
                $id = (int)cpgTool::get_var('id');
                $current_option_set_data = cpgDB::fetchRow("SELECT * FROM `{$CONFIG['TABLE_CS_OPTIONSET']}` WHERE oid='$id';");
                $current_option_array = cpgTool::decode_data($current_option_set_data['option_array']);
                // get a price list
                $rowset = cpgDB::fetchRowset("SELECT oid, title FROM `{$CONFIG['TABLE_CS_OPTION']}` ORDER BY title ASC;");
                $option_array = array();
                $default_array = array();
                foreach ($rowset as $row) {
                    $option_array[$row['oid']] = $row['title'];
                    if (in_array($row['oid'], $current_option_array)) $default_array[] = $row['oid'];
                }
                // vars
                $vars = array(
                    '{GB_TITLE}' => $lang_cs_optionset['edit_optionset_title'],
                    '{ID}' => $id,
                    '{TASK}' => "edit_act",
                    '{LANG_TITLE}' => $lang_cs_common['title'],
                    '{TITLE}' => HTMLelement::text_input("title", $current_option_set_data['title']),
                    '{LANG_OPTION_SET}' => $lang_cs_common['optionset'],
                    '{OPTION_SET}' => HTMLelement::multiple_select('option_set', $option_array, $default_array),
                    '{LANG_SUBMIT}' => $lang_cs_common['edit'],
                    '{LANG_RESET}' => $lang_cs_common['reset'],
                    );
                echo cpgTemplate::set($aoe, $vars);
                HTMLelement::spacer();
                break;
            case 'edit_act':
                $id = (int)cpgTool::post_var('id');
                $title = addslashes(cpgTool::post_var('title'));
                $option_set = cpgTool::encode_data(cpgTool::post_var('option_set'));
                $result = cpgDB::runQuery("UPDATE `{$CONFIG['TABLE_CS_OPTIONSET']}` SET title='$title', option_array='$option_set' WHERE oid = '$id';");
                $markup_element_id = $id;
                // success message
                HTMLelement::message($lang_cs_common['message'], sprintf($lang_cs_optionset['edit_optionset_success'], $title));
                HTMLelement::spacer();
                break;
                break;
            case 'del_act':
                // which one will be delete
                $superCage = Inspekt::makeSuperCage();
                $id_array = $superCage->post->getInt('id');

                $msg = array();
                foreach ($id_array as $delete_id) {
                    cpgDB::runQuery("DELETE FROM `{$CONFIG['TABLE_CS_OPTIONSET']}` WHERE oid = '$delete_id' LIMIT 1;");
                    $msg[] = sprintf($lang_cs_optionset['del_optionset_success'], $delete_id);
                }
                HTMLelement::message($lang_cs_common['message'], $msg);
                HTMLelement::spacer();
                break;
        }
        // main page
        starttable($CONFIG['picture_table_width'], $lang_cs_optionset['option_set_list_title'], 3);
        // control box
        echo cpgTemplate::set($control, array(
                '{LANG_NEW}' => $lang_cs_optionset['new_optionset'],
                '{LANG_DEL}' => $lang_cs_optionset['del_optionset'],
                '{LANG_SURE}' => $lang_cs_common['are_you_sure'],
                ));
        // title
        echo cpgTemplate::set($this_title, array(
                '{LANG_TOGGLE_ALL}' => $lang_cs_common['toggle_all'],
                '{LANG_TITLE}' => $lang_cs_optionset['optionset_name'],
                '{LANG_OPTION_SET}' => $lang_cs_optionset['optionset_data'],
                ));
        $option_set_array = cpgDB::fetchRowset("SELECT * FROM `{$CONFIG['TABLE_CS_OPTIONSET']}` ORDER BY oid DESC;");
        if (count($option_set_array) == 0) echo HTMLelement::apply_simple_text(HTMLelement::simple_text(3), $lang_cs_optionset['no_optionset']);
        foreach ($option_set_array as $key => $option_set) {
            $option_set['title'] = "<a href=\"index.php?file=cpgshop/cpgshop_config&page=option_set&task=edit&id={$option_set['oid']}\">{$option_set['title']}</a>";
            $vars = array(
                '{CHECK_BOX}' => HTMLelement::check_box("id[]", $option_set['oid']),
                '{TITLE}' => $option_set['title'],
                '{OPTION_SET}' => HTMLelement::plain_option_list($option_set['option_array']),
                );
            if ($option_set['oid'] == $markup_element_id)
                echo cpgTemplate::set($element_m, $vars);
            else
                echo cpgTemplate::set($element, $vars);
        }
        // page nav
        echo cpgTemplate::set($page_nav, array(
                '{PAGE_NAV}' => "",
                ));
        echo cpgTemplate::set($control_end, []);
        endtable();
        return;
    }
    // -----------------------------------------------------------------------------------------
    // OPTION MANAGER
    // -----------------------------------------------------------------------------------------
    public static function option()
    {
        global $CONFIG;
        global $currency_symbol;
        global $lang_cs_common, $lang_cs_option;

		$markup_element_id = -1;

        // get ACTION
        if (cpgTool::post_var('task') == false) {
            $task = cpgTool::get_var('task');
        } else {
            $task = cpgTool::post_var('task');
        }
        // TEMPLATE
        $tpl_option = cpgTemplate::get('blog_option');
        $this_title = cpgTemplate::extract($tpl_option, 'title');
        $element = cpgTemplate::extract($tpl_option, 'element');
        $element_m = str_replace('tableb', 'tableh2', $element);
        $page_nav = cpgTemplate::extract($tpl_option, 'page_nav');
        $control = cpgTemplate::extract($tpl_option, 'control');
        $control_end = cpgTemplate::extract($tpl_option, 'control_end');
        $aoe = cpgTemplate::extract($tpl_option, 'aoe');
        // task -> action
        switch ($task) {
            case 'new':
                $vars = array(
                    '{GB_TITLE}' => $lang_cs_option['new_option_title'],
                    '{ID}' => "",
                    '{TASK}' => "new_act",
                    '{LANG_TITLE}' => $lang_cs_common['title'],
                    '{TITLE}' => HTMLelement::text_input("title", ""),
                    '{LANG_TITLE_ARRAY}' => $lang_cs_option['option_arr_title'],
                    '{TITLE_ARRAY}' => HTMLelement::text_input("title_array", ""),
                    '{LANG_VALUE_ARRAY}' => $lang_cs_option['option_arr_value'],
                    '{VALUE_ARRAY}' => HTMLelement::text_input("value_array", ""),
                    // '{LANG_CURRENCY}'	 =>	$lang_cs_common['currrency'],
                    // '{CURRENCY}'		 =>	HTMLelement::simple_select("currency", $currency_symbol, $CONFIG['cpgshop_currency']),
                    '{LANG_SUBMIT}' => $lang_cs_common['add'],
                    '{LANG_RESET}' => $lang_cs_common['reset'],
                    );
                echo cpgTemplate::set($aoe, $vars);
                HTMLelement::spacer();
                break;
            case 'new_act':
                $title = addslashes(cpgTool::post_var('title'));
                $title_array = cpgTool::encode_data(explode('||', cpgTool::post_var('title_array')));
                $value_array = explode('||', cpgTool::post_var('value_array'));
                $currency = cpgTool::post_var('currency');
                foreach ($value_array as $key => $value) {
                    $value_array[$key] = (float)$value;
                }
                $value_array = cpgTool::encode_data($value_array);
                cpgDB::runQuery("INSERT INTO `{$CONFIG['TABLE_CS_OPTION']}` (oid, title, title_array, value_array, currency) VALUES ('', '$title', '$title_array', '$value_array', '{$CONFIG['cpgshop_currency']}');");
                $markup_element_id = cpgDB::insertID();
                HTMLelement::message($lang_cs_common['message'], sprintf($lang_cs_option['add_option_success'], $title));
                HTMLelement::spacer();
                break;
            case 'edit':
                $id = (int)cpgTool::get_var('id');
                $current_option_data = cpgDB::fetchRow("SELECT * FROM `{$CONFIG['TABLE_CS_OPTION']}` WHERE oid = '$id' LIMIT 1;");
                // little convert
                $current_option_data['title_array'] = implode("||", cpgTool::decode_data($current_option_data['title_array']));
                $current_option_data['value_array'] = implode("||", cpgTool::decode_data($current_option_data['value_array']));
                // vars
                $vars = array(
                    '{GB_TITLE}' => $lang_cs_option['edit_option'],
                    '{ID}' => $id,
                    '{TASK}' => "edit_act",
                    '{LANG_TITLE}' => $lang_cs_common['title'],
                    '{TITLE}' => HTMLelement::text_input("title", $current_option_data['title']),
                    '{LANG_TITLE_ARRAY}' => $lang_cs_option['option_arr_title'],
                    '{TITLE_ARRAY}' => HTMLelement::text_input("title_array", $current_option_data['title_array']),
                    '{LANG_VALUE_ARRAY}' => $lang_cs_option['option_arr_value'],
                    '{VALUE_ARRAY}' => HTMLelement::text_input("value_array", $current_option_data['value_array']),
                    '{LANG_CURRENCY}' => $lang_cs_common['currency'],
                    '{CURRENCY}' => HTMLelement::simple_select("currency", $currency_symbol, $CONFIG['cpgshop_currency']),
                    '{LANG_SUBMIT}' => $lang_cs_common['edit'],
                    '{LANG_RESET}' => $lang_cs_common['reset'],
                    );
                echo cpgTemplate::set($aoe, $vars);
                HTMLelement::spacer();
                break;
            case 'edit_act':
                $id = (int)cpgTool::post_var('id');
                $title = addslashes(cpgTool::post_var('title'));
                $title_array = cpgTool::encode_data(explode('||', cpgTool::post_var('title_array')));
                $value_array = explode('||', cpgTool::post_var('value_array'));
                $currency = cpgTool::post_var('currency');
                foreach ($value_array as $key => $value) {
                    $value_array[$key] = (float)$value;
                }
                $value_array = cpgTool::encode_data($value_array);

            	$currency=$CONFIG['cpgshop_currency'];
                cpgDB::runQuery("UPDATE `{$CONFIG['TABLE_CS_OPTION']}` SET title ='$title', title_array='$title_array', value_array='$value_array', currency='$currency' WHERE oid = '$id' LIMIT 1;");
                // $msg = array();
                // $msg[] = sprintf($lang_cs_option['edit_option_success'], $title);
                $markup_element_id = $id;
                // starttable($CONFIG['picture_table_width'], $lang_cs_common['message']);
                HTMLelement::message($lang_cs_common['message'], sprintf($lang_cs_option['edit_option_success'], $title));
                HTMLelement::spacer();
                break;
            case 'del_act':
                // which one will be delete
                $superCage = Inspekt::makeSuperCage();
                $id_array = $superCage->post->getInt('id');

                $msg = array();
                foreach ($id_array as $delete_id) {
                    if (cpgTool::check_if_option_used($delete_id)) {
                        $msg[] = sprintf($lang_cs_option['del_option_denied'], $delete_id);
                    } else {
                        cpgDB::runQuery("DELETE FROM `{$CONFIG['TABLE_CS_OPTION']}` WHERE oid = '$delete_id' LIMIT 1;");
                        $msg[] = sprintf($lang_cs_option['del_option_success'], $delete_id);
                    }
                }
                HTMLelement::message($lang_cs_common['message'], $msg);
                HTMLelement::spacer();
                break;
        }
        // main page
        starttable($CONFIG['picture_table_width'], $lang_cs_option['option_list_title'], 4);
        // control box
        echo cpgTemplate::set($control, array(
                '{LANG_NEW}' => $lang_cs_option['new_option'],
                '{LANG_DEL}' => $lang_cs_option['del_option'],
                '{LANG_SURE}' => $lang_cs_common['are_you_sure'],
                ));
        // title
        echo cpgTemplate::set($this_title, array(
                '{LANG_TOGGLE_ALL}' => $lang_cs_common['toggle_all'],
                '{LANG_TITLE}' => $lang_cs_common['title'],
                '{LANG_DATA}' => $lang_cs_common['data'],
                '{LANG_CURRENCY}' => $lang_cs_common['currency'],
                ));
        $option_array = cpgDB::fetchRowset("SELECT * FROM `{$CONFIG['TABLE_CS_OPTION']}` ORDER BY oid DESC;");
        if (count($option_array) == 0) echo HTMLelement::apply_simple_text(HTMLelement::simple_text(4), $lang_cs_option['no_option']);
        foreach ($option_array as $key => $option) {
            $option['title'] = "<a href=\"index.php?file=cpgshop/cpgshop_config&page=option&task=edit&id={$option['oid']}\">{$option['title']}</a>";
            $option['title_array'] = cpgTool::decode_data($option['title_array']);
            $option['value_array'] = cpgTool::decode_data($option['value_array']);
            $combine_array = array_combine($option['title_array'], $option['value_array']);
            $vars = array(
                '{CHECK_BOX}' => HTMLelement::check_box("id[]", $option['oid']),
                '{TITLE}' => $option['title'],
                '{DATA}' => HTMLelement::plain_option($combine_array),
                '{CURRENCY}' => $currency_symbol[$CONFIG['cpgshop_currency']],
                );
            if ($option['oid'] == $markup_element_id)
                echo cpgTemplate::set($element_m, $vars);
            else
                echo cpgTemplate::set($element, $vars);
        }
        // page nav
        echo cpgTemplate::set($page_nav, array(
                '{PAGE_NAV}' => "",
                ));
        echo cpgTemplate::set($control_end, []);
        endtable();
        return;
    }
    // -----------------------------------------------------------------------------------------
    // PRICE SET MANAGER
    // -----------------------------------------------------------------------------------------
    public static function price_set()
    {
        global $CONFIG;
        global $currency_symbol;
        global $lang_cs_common, $lang_cs_priceset;

		$markup_element_id = -1;

        // get ACTION
        if (cpgTool::post_var('task') == false) {
            $task = cpgTool::get_var('task');
        } else {
            $task = cpgTool::post_var('task');
        }
        // TEMPLATE
        $tpl_price_set = cpgTemplate::get('blog_price_set');
        $this_title = cpgTemplate::extract($tpl_price_set, 'title');
        $element = cpgTemplate::extract($tpl_price_set, 'element');
        $element_m = str_replace('tableb', 'tableh2', $element);
        $page_nav = cpgTemplate::extract($tpl_price_set, 'page_nav');
        $control = cpgTemplate::extract($tpl_price_set, 'control');
        $control_end = cpgTemplate::extract($tpl_price_set, 'control_end');
        $aoe = cpgTemplate::extract($tpl_price_set, 'aoe');
        $message = cpgTemplate::get('element_message');
        // task -> action
        switch ($task) {
            case 'new':
                // get a price list
                $rowset = cpgDB::fetchRowset("SELECT pid, title, value, currency, shipping, type FROM `{$CONFIG['TABLE_CS_PRICE']}` ORDER BY title ASC;");
                $price_array = array();
                foreach ($rowset as $row) {
                    $price_array[$row['pid']] = "{$row['title']} - {$row['value']} {$currency_symbol[$CONFIG['cpgshop_currency']]}";
                }
                // vars
                $vars = array(
                    '{GB_TITLE}' => $lang_cs_priceset['new_priceset_title'],
                    '{TASK}' => "new_act",
                    '{LANG_TITLE}' => $lang_cs_common['title'],
                    '{TITLE}' => HTMLelement::text_input("title", ""),
                    '{LANG_PRICE_SET}' => $lang_cs_common['priceset'],
                    '{PRICE_SET}' => HTMLelement::multiple_select('price_set', $price_array),
                    '{LANG_SUBMIT}' => $lang_cs_common['add'],
                    '{LANG_RESET}' => $lang_cs_common['reset'],
                    );
                echo cpgTemplate::set($aoe, $vars);
                HTMLelement::spacer();
                break;
            case 'new_act':
                $title = addslashes(cpgTool::post_var('title'));
                $price_set = cpgTool::encode_data(cpgTool::post_var('price_set'));
                $result = cpgDB::runQuery("INSERT INTO `{$CONFIG['TABLE_CS_PRICESET']}` (pid, title, price_array) VALUES ('', '$title', '$price_set');");
                $markup_element_id = $pid;
                // success message
                HTMLelement::message($lang_cs_common['message'], sprintf($lang_cs_priceset['add_priceset_success'], $title));
                HTMLelement::spacer();
                break;
            case 'edit':
                $id = (int)cpgTool::get_var('id');
                $current_price_set_data = cpgDB::fetchRow("SELECT * FROM `{$CONFIG['TABLE_CS_PRICESET']}` WHERE pid='$id';");
                $current_price_array = cpgTool::decode_data($current_price_set_data['price_array']);
                // get a price list
                $rowset = cpgDB::fetchRowset("SELECT pid, title, value, currency, shipping, type FROM `{$CONFIG['TABLE_CS_PRICE']}` ORDER BY title ASC;");
                $price_array = array();
                $default_array = array();
                foreach ($rowset as $row) {
                    $price_array[$row['pid']] = "{$row['title']} {$currency_symbol[$CONFIG['cpgshop_currency']]} ({$row['title']})";
                    if (in_array($row['pid'], $current_price_array)) $default_array[] = $row['pid'];
                }
                // vars
                $vars = array(
                    '{GB_TITLE}' => $lang_cs_priceset['edit_priceset_title'],
                    '{ID}' => $id,
                    '{TASK}' => "edit_act",
                    '{LANG_TITLE}' => $lang_cs_common['title'],
                    '{TITLE}' => HTMLelement::text_input("title", $current_price_set_data['title']),
                    '{LANG_PRICE_SET}' => $lang_cs_common['priceset'],
                    '{PRICE_SET}' => HTMLelement::multiple_select('price_set', $price_array, $default_array),
                    '{LANG_SUBMIT}' => $lang_cs_common['edit'],
                    '{LANG_RESET}' => $lang_cs_common['reset'],
                    );
                echo cpgTemplate::set($aoe, $vars);
                HTMLelement::spacer();
                break;
            case 'edit_act':
                $id = (int)cpgTool::post_var('id');
                $title = addslashes(cpgTool::post_var('title'));
                $price_set = cpgTool::encode_data(cpgTool::post_var('price_set'));
                $result = cpgDB::runQuery("UPDATE `{$CONFIG['TABLE_CS_PRICESET']}` SET title='$title', price_array='$price_set' WHERE pid = '$id';");
                $markup_element_id = $id;
                // success message
                HTMLelement::message($lang_cs_common['message'], sprintf($lang_cs_priceset['edit_priceset_success'], $title));
                HTMLelement::spacer();
                break;
                break;
            case 'del_act':
                // which one will be delete
                $superCage = Inspekt::makeSuperCage();
                $id_array = $superCage->post->getInt('id');

                $msg = array();
                foreach ($id_array as $delete_id) {
                    cpgDB::runQuery("DELETE FROM `{$CONFIG['TABLE_CS_PRICESET']}` WHERE pid = '$delete_id' LIMIT 1;");
                    $msg[] = sprintf($lang_cs_priceset['del_priceset_success'], $delete_id);
                }
                HTMLelement::message($lang_cs_common['message'], $msg);
                HTMLelement::spacer();
                break;
        }
        // main page
        starttable($CONFIG['picture_table_width'], $lang_cs_priceset['price_set_list_title'], 3);
        // control box
        echo cpgTemplate::set($control, array(
                '{LANG_NEW}' => $lang_cs_priceset['new_priceset'],
                '{LANG_DEL}' => $lang_cs_priceset['del_priceset'],
                '{LANG_SURE}' => $lang_cs_common['are_you_sure'],
                ));
        // title
        echo cpgTemplate::set($this_title, array(
                '{LANG_TOGGLE_ALL}' => $lang_cs_common['toggle_all'],
                '{LANG_TITLE}' => $lang_cs_priceset['priceset_name'],
                '{LANG_PRICE_SET}' => $lang_cs_priceset['priceset_data'],
                ));
        $price_set_array = cpgDB::fetchRowset("SELECT * FROM `{$CONFIG['TABLE_CS_PRICESET']}` ORDER BY pid DESC;");
        if (count($price_set_array) == 0) echo HTMLelement::apply_simple_text(HTMLelement::simple_text(4), $lang_cs_priceset['no_priceset']);
        foreach ($price_set_array as $key => $price_set) {
            $price_set['title'] = "<a href=\"index.php?file=cpgshop/cpgshop_config&page=price_set&task=edit&id={$price_set['pid']}\">{$price_set['title']}</a>";
            $vars = array(
                '{CHECK_BOX}' => HTMLelement::check_box("id[]", $price_set['pid']),
                '{TITLE}' => $price_set['title'],
                '{PRICE_SET}' => HTMLelement::plain_price_list($price_set['price_array']),
                );
            if ($price_set['pid'] == $markup_element_id)
                echo cpgTemplate::set($element, $vars);
            else
                echo cpgTemplate::set($element, $vars);
        }
        // page nav
        echo cpgTemplate::set($page_nav, array(
                '{PAGE_NAV}' => "",
                ));
        echo cpgTemplate::set($control_end, []);
        endtable();
        return;
    }
    // -----------------------------------------------------------------------------------------
    // PRICE MANAGER
    // -----------------------------------------------------------------------------------------
    public static function price()
    {
        global $CONFIG;
        global $currency_symbol, $item_type;
        global $lang_cs_common, $lang_cs_price;
        
        $markup_element_id = -1;

        // get ACTION
        if (cpgTool::post_var('task') == false) {
            $task = cpgTool::get_var('task');
        } else {
            $task = cpgTool::post_var('task');
        }
        // TEMPLATE
        $tpl_price = cpgTemplate::get('blog_price');
        $this_title = cpgTemplate::extract($tpl_price, 'title');
        $element = cpgTemplate::extract($tpl_price, 'element');
        $element_m = str_replace('tableb', 'tableh2', $element);
        $page_nav = cpgTemplate::extract($tpl_price, 'page_nav');
        $control = cpgTemplate::extract($tpl_price, 'control');
        $control_end = cpgTemplate::extract($tpl_price, 'control_end');
        $aoe = cpgTemplate::extract($tpl_price, 'aoe');
        $message = cpgTemplate::get('element_message');
        // task -> action
        switch ($task) {
            // add new price
            case 'new':
                $vars = array(
                    '{GB_TITLE}' => $lang_cs_price['new_price_title'],
                    '{ID}' => "",
                    '{TASK}' => "new_act",
                    '{LANG_TITLE}' => $lang_cs_common['title'],
                    '{TITLE}' => HTMLelement::text_input("title", ""),
                    '{LANG_VALUE}' => $lang_cs_common['price'],
                    '{VALUE}' => HTMLelement::text_input("value", ""),
                    '{LANG_EXTRA_SHIPPING}' => $lang_cs_common['extra_shipping'],
                    '{EXTRA_SHIPPING}' => HTMLelement::text_input("shipping", ""),
                    '{LANG_TYPE}' => $lang_cs_common['type'],
                    '{TYPE}' => HTMLelement::simple_select("type", $item_type, "0"),
                    '{LANG_SIZE}' => $lang_cs_common['size'],
                    '{SIZE}' => HTMLelement::text_input("size", ""),
                    // '{LANG_CURRENCY}'		=>	$lang_cs_common['currency'],
                    // '{CURRENCY}'			=>	HTMLelement::simple_select("currency", $currency_symbol, $CONFIG['cpgshop_currency']),
                    '{LANG_SUBMIT}' => $lang_cs_common['add'],
                    '{LANG_RESET}' => $lang_cs_common['reset'],
                    );
                echo cpgTemplate::set($aoe, $vars);
                HTMLelement::spacer();
                break;
            // add a new price
            case 'new_act':
                $title = addslashes(cpgTool::post_var('title'));
                $value = cpgTool::price_format(cpgTool::post_var('value'));
                $shipping = cpgTool::price_format(cpgTool::post_var('shipping'));
                $currency = addslashes(cpgTool::post_var('currency'));
                $type = addslashes(cpgTool::post_var('type'));
                $size = addslashes(cpgTool::post_var('size'));
                if ($type == 0) $size = ''; //if shipping, then we do not need the download max width/height

                $result = cpgDB::runQuery("INSERT INTO `{$CONFIG['TABLE_CS_PRICE']}` (pid, title, value, currency, shipping, type, size) VALUES ('', '$title', '$value', '{$CONFIG['cpgshop_currency']}', '$shipping', '$type', '$size');");
                $markup_element_id = cpgDB::insertID();
                // success message
                HTMLelement::message($lang_cs_common['message'], sprintf($lang_cs_price['add_price_success'], $title));
                HTMLelement::spacer();
                break;
            case 'edit':
                // id = ?
                $superCage = Inspekt::makeSuperCage();
                $id = $superCage->get->getInt('id');
                // $id = $id_array[0];
                $current_price_data = cpgDB::fetchRow("SELECT pid, title, value, currency, shipping, type, size FROM `{$CONFIG['TABLE_CS_PRICE']}` WHERE pid = '$id' LIMIT 1;");
                // no data
                if (!is_array($current_price_data)) cpgTool::error($lang_cs_common['invaild_id']);
                // get current data
                $vars = array(
                    '{GB_TITLE}' => $lang_cs_price['edit_price_title'],
                    '{ID}' => $id,
                    '{TASK}' => "edit_act",
                    '{LANG_TITLE}' => $lang_cs_common['title'],
                    '{TITLE}' => HTMLelement::text_input("title", $current_price_data['title']),
                    '{LANG_VALUE}' => $lang_cs_common['price'],
                    '{VALUE}' => HTMLelement::text_input("value", $current_price_data['value']),
                    '{LANG_EXTRA_SHIPPING}' => $lang_cs_common['extra_shipping'],
                    '{EXTRA_SHIPPING}' => HTMLelement::text_input("shipping", $current_price_data['shipping']),
                    '{LANG_TYPE}' => $lang_cs_common['type'],
                    '{TYPE}' => HTMLelement::simple_select("type", $item_type, $current_price_data['type']),
                    '{LANG_SIZE}' => $lang_cs_common['size'],
                    '{SIZE}' => HTMLelement::text_input("size", $current_price_data['size']),
                    '{LANG_CURRENCY}' => $lang_cs_common['currency'],
                    '{CURRENCY}' => HTMLelement::simple_select("currency", $currency_symbol, $CONFIG['cpgshop_currency']),
                    '{LANG_SUBMIT}' => $lang_cs_common['modify'],
                    '{LANG_RESET}' => $lang_cs_common['reset'],
                    );
                echo cpgTemplate::set($aoe, $vars);
                HTMLelement::spacer();

                break;
            case 'edit_act':
                $id = (int)cpgTool::post_var('id');

                $title = addslashes(cpgTool::post_var('title'));
                $value = cpgTool::price_format(cpgTool::post_var('value'));
                $shipping = cpgTool::price_format(cpgTool::post_var('shipping'));
                //$currency = addslashes(cpgTool::post_var('currency'));
                $type = addslashes(cpgTool::post_var('type'));
                $size = addslashes(cpgTool::post_var('size'));
                if ($type == 0) $size = ''; //if shipping, then we do not need the download max width/height

                $result = cpgDB::runQuery("UPDATE `{$CONFIG['TABLE_CS_PRICE']}` SET title='$title', value='$value', shipping='$shipping', type='$type', size='$size' WHERE pid = '$id';");
                $markup_element_id = $id;
                // success message
                HTMLelement::message($lang_cs_common['message'], sprintf($lang_cs_price['edit_price_success'], $title));
                HTMLelement::spacer();

                break;
            case 'del_act':
                // which one will be delete
                $superCage = Inspekt::makeSuperCage();
                $id_array = $superCage->post->getInt('id');

                $msg = array();
                foreach ($id_array as $delete_id) {
                    if (cpgTool::check_if_price_used($delete_id)) {
                        $msg[] = sprintf($lang_cs_price['del_price_denied'], $delete_id);
                    } else {
                        cpgDB::runQuery("DELETE FROM `{$CONFIG['TABLE_CS_PRICE']}` WHERE pid = '$delete_id' LIMIT 1;");
                        $msg[] = sprintf($lang_cs_price['del_price_success'], $delete_id);
                    }
                }
                HTMLelement::message($lang_cs_common['message'], $msg);
                HTMLelement::spacer();
                break;
        }
        // starttable
        starttable($CONFIG['picture_table_width'], $lang_cs_price['price_list_title'], 7);
        // control box
        echo cpgTemplate::set($control, array(
                '{LANG_NEW}' => $lang_cs_price['new_price'],
                '{LANG_DEL}' => $lang_cs_price['del_price'],
                '{LANG_EDIT}' => $lang_cs_price['edit_price'],
                '{LANG_SURE}' => $lang_cs_common['are_you_sure'],
                ));
        // title
        echo cpgTemplate::set($this_title, array(
                '{LANG_TOGGLE_ALL}' => $lang_cs_common['toggle_all'],
                '{LANG_TITLE}' => $lang_cs_common['name'],
                '{LANG_VALUE}' => $lang_cs_common['value'],
                '{LANG_CURRENCY}' => $lang_cs_common['currency'],
                '{LANG_SIZE}' => $lang_cs_common['size_title'],
                '{LANG_EXTRA_SHIPPING}' => $lang_cs_common['extra_shipping'],
                '{LANG_TYPE}' => $lang_cs_common['type'],
                ));
        // price list
        $price_array = cpgDB::fetchRowset("SELECT * FROM `{$CONFIG['TABLE_CS_PRICE']}` ORDER BY pid DESC;");
        if (count($price_array) == 0) echo HTMLelement::apply_simple_text(HTMLelement::simple_text(4), $lang_cs_price['no_price']);
        foreach ($price_array as $price) {
            $price['title'] = "<a href=\"index.php?file=cpgshop/cpgshop_config&page=price&task=edit&id={$price['pid']}\">{$price['title']}</a>";
            $vars = array(
                '{CHECK_BOX}' => HTMLelement::check_box("id[]", $price['pid']),
                '{TITLE}' => $price['title'],
                '{VALUE}' => cpgTool::price_format($price['value']),
                '{EXTRA_SHIPPING}' => cpgTool::price_format($price['shipping']),
                '{TYPE}' => $item_type[$price['type']],
                '{SIZE}' => $price['size'],
                '{CURRENCY}' => $currency_symbol[$CONFIG['cpgshop_currency']],
                );
            if ($price['pid'] == $markup_element_id)
                echo cpgTemplate::set($element_m, $vars);
            else
                echo cpgTemplate::set($element, $vars);
        }
        // page nav
        echo cpgTemplate::set($page_nav, array(
                '{PAGE_NAV}' => "",
                ));
        echo cpgTemplate::set($control_end, []);
        endtable();
        return;
    }
}
